#ifndef CDIB_H
#define CDIB_H
////////////////////////////////////////////////////////////////
// Copyright 1996 Microsoft Systems Journal. 
// If this code works, it was written by Paul DiLascia.
// If not, I don't know who wrote it.
// See dib.cpp

////////////////
// CDib implements Device Independent Bitmaps as a form of CBitmap. 
//
class CDib : public CBitmap {
protected:
	DECLARE_DYNAMIC(CDib)
	BITMAP	         m_bm;		      // stored for speed
	CPalette          m_pal;	      // palette

public:
	CDib();
	~CDib();

	CSize	GetSize() { return CSize(m_bm.bmWidth, m_bm.bmHeight); }
	BOOL Attach(HGDIOBJ hbm);

   // load transparent turns all pixels that have the same color as the 1st
   // pixel in the image into the Windows button face color
	BOOL Load(LPCTSTR szPathName, bool bTransparent = false);
	BOOL Load(HINSTANCE hInst, LPCTSTR lpResourceName, bool bTransparent = false);
	BOOL Load(HINSTANCE hInst, UINT uID, bool bTransparent = false)
		{ return Load(hInst, MAKEINTRESOURCE(uID), bTransparent); }

	// Universal Draw function.
	BOOL Draw(CDC& dc, const CRect* rcDs = NULL, const CRect* rcSrc = NULL,
		            CPalette* pPal = NULL,
                  BOOL bForeground =  FALSE);

	BOOL DeleteObject();
	BOOL CreatePalette(CPalette& pal);
	CPalette* GetPalette()  { return &m_pal; }

	UINT GetColorTable(RGBQUAD* colorTab, UINT nColors);
};
#endif      // CDIB_H