#ifndef  CheckpointView_H
#define	CheckpointView_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       CheckpointView.h	[ CheckpointView.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface of the CCheckpointView class
//
//***************************************************************************

#include <afxcview.h>

class CCheckpointView : public CListView
{
protected:
	CCheckpointView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CCheckpointView)

// Form Data
public:
	//{{AFX_DATA(CCheckpointView)
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCheckpointView)
	public:
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual  ~CCheckpointView();

   void     CheckModified(CString sFileName);
   static int CALLBACK
            SortCompareCallback(LPARAM leftItemData, LPARAM rightItemData, LPARAM pThis);
   int      SortCompare(LPARAM leftItemData, LPARAM rightItemData);

   enum HEADER_COUNT { FIXED_HEADERS = 1 };
   enum SORT_DIRECTION { SORT_DESCENDING = 1 };

   CSourceMetricsDoc *
                  m_poSMDoc;        // resolve this once and then use it everywhere in place of GetDocument()
   SMProject *    m_poProject;      // reference to the view's project object
   CListCtrl *    m_poListCtrl;     // reference to the view's embedded list view control
   int            m_iCheckpointIndex; // checkpoint's item index in project view
   CString        m_sCaption;       // this view's frame caption
   CStringArray   m_saColumnOrder;  // column order numbers
   int            m_iMetricColumns; // number of metrics values for the checkpoint's language
   int            m_iViewColumns;   // total number of columns, including fixed, non-metric columns
   CString        m_sSection;       // profile option key string
   SMCheckpoint   m_oCkpt;          // pointer to checkpoint being displayed in this view
   int            m_iSelectedIndex; // index of selected file in list view
   int            m_iSortColumn;    // valid only during sorts
   CByteArray     m_baSortOrder;    // toggled: 1 for sort descending, == 0 for ascending
   long           m_lViewID;        // keep around for use in the destructor

   // members used only during printing
   CString        m_sProjectCaption;
   bool           m_fPrinting;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CCheckpointView)
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnFileDelete();
	afx_msg void OnUpdateFileDelete(CCmdUI* pCmdUI);
	afx_msg void OnFileClick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDestroy();
	afx_msg void OnViewFileMetricsDetails();
	afx_msg void OnCkptViewViewsource();
	afx_msg void OnUpdateCkptViewViewsource(CCmdUI* pCmdUI);
	afx_msg void OnCkptViewChart();
	afx_msg void OnUpdateCkptViewMetricsDetails(CCmdUI* pCmdUI);
	afx_msg void OnCkContextHelp();
	afx_msg void OnUpdateCkContextHelp(CCmdUI* pCmdUI);
	afx_msg void OnCkptEditViewsource();
	afx_msg void OnUpdateCkptEditViewsource(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif               // CheckpointView_H
