//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       CreateCheckpointDlg.cpp	[ CreateCheckpointDlg.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of the CCreateCheckpointDlg class
//
//***************************************************************************

#include "stdafx.h"
#include "SourceMetrics.h"
#include "CreateCheckpointDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CCreateCheckpointDlg, CDialog)
	//{{AFX_MSG_MAP(CCreateCheckpointDlg)
	ON_BN_CLICKED(IDC_NEW_CKPT_ADD_FILE_BUTTON, OnClickAddFileButton)
	ON_BN_CLICKED(IDC_NEW_CKPT_REMOVE_FILE_BUTTON, OnClickRemoveFileButton)
	ON_BN_CLICKED(ID_NEW_CKPT_HELP, OnNewCkptHelp)
	ON_LBN_DBLCLK(IDC_ALL_FILES_LIST, OnDblclkAllFilesList)
	ON_LBN_DBLCLK(IDC_NEW_CKPT_FILES_LIST, OnDblclkNewCkptFilesList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CCreateCheckpointDlg::CCreateCheckpointDlg(CWnd* pParent, CStringList & ckptfiles, CStringList & files)
	: CDialog(CCreateCheckpointDlg::IDD, pParent), saCkptFiles(ckptfiles), saOtherFiles(files)
{
   COLORMAP oColorMap;

   // put images on the add and remove buttons
   oColorMap.from = RGB(255, 255, 255);   // background is white
   oColorMap.to = GetSysColor(COLOR_BTNFACE);
   m_bitmapAdd.LoadMappedBitmap(IDB_ADD_CKPT_BUTTON, 0, &oColorMap, 1);
   m_bitmapRemove.LoadMappedBitmap(IDB_REMOVE_CKPT_BUTTON, 0, &oColorMap, 1);

	//{{AFX_DATA_INIT(CCreateCheckpointDlg)
	m_sName = _T("");
	m_sFilter = _T("");
	//}}AFX_DATA_INIT
}


void CCreateCheckpointDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCreateCheckpointDlg)
	DDX_Control(pDX, IDC_NEW_CKPT_NAME, m_oNameEditControl);
	DDX_Control(pDX, IDC_NEW_CKPT_REMOVE_FILE_BUTTON, m_oRemoveButton);
	DDX_Control(pDX, IDC_NEW_CKPT_ADD_FILE_BUTTON, m_oAddButton);
	DDX_Control(pDX, IDC_NEW_CKPT_FILES_LIST, m_oCkptFilesList);
	DDX_Control(pDX, IDC_ALL_FILES_LIST, m_oOtherFilesList);
	DDX_Text(pDX, IDC_NEW_CKPT_NAME, m_sName);
	DDX_Text(pDX, IDC_NEW_CKPT_FILTER, m_sFilter);
	//}}AFX_DATA_MAP
   if( not pDX->m_bSaveAndValidate )
   {                                // initialize list box contents
      CDC *    poDC = m_oCkptFilesList.GetDC();
      CString  sItem;               // list text scratch
      CSize    oItemSize;
      int      iMaxItemWidth = 0;
      POSITION oPosition;           // iterator marker

      oPosition = saOtherFiles.GetHeadPosition();
      for( int i = 0; i < saOtherFiles.GetCount(); ++i )
      {
         sItem = saOtherFiles.GetNext(oPosition);
         oItemSize = poDC->GetTextExtent(sItem);
         iMaxItemWidth = max(oItemSize.cx, iMaxItemWidth);
         m_oOtherFilesList.AddString(sItem);
      }
      oPosition = saCkptFiles.GetHeadPosition();
      for( int j = 0; j < saCkptFiles.GetCount(); ++j )
      {
         sItem = saCkptFiles.GetNext(oPosition);
         oItemSize = poDC->GetTextExtent(sItem);
         iMaxItemWidth = max(oItemSize.cx, iMaxItemWidth);
         m_oCkptFilesList.AddString(sItem);
      }
      m_oCkptFilesList.ReleaseDC(poDC);
      m_oOtherFilesList.SetHorizontalExtent(iMaxItemWidth);
      m_oCkptFilesList.SetHorizontalExtent(iMaxItemWidth);
      m_oAddButton.SetBitmap((HBITMAP)m_bitmapAdd.GetSafeHandle());
      m_oRemoveButton.SetBitmap((HBITMAP)m_bitmapRemove.GetSafeHandle());
   }
   else
   {                                // read back final list
      saCkptFiles.RemoveAll();
      for( int i = 0; i < m_oCkptFilesList.GetCount(); ++i )
      {
         CString  sItem;

         m_oCkptFilesList.GetText(i, sItem);
         saCkptFiles.AddTail(sItem);
      }
   }
}

/////////////////////////////////////////////////////////////////////////////
// CCreateCheckpointDlg message handlers

void CCreateCheckpointDlg::OnClickAddFileButton() 
{
   CWaitCursor oWaitCursor;
   int         iSelectedCount = m_oOtherFilesList.GetSelCount();
	int *       piIndexes = new int[iSelectedCount];

   if( m_oOtherFilesList.GetSelItems(iSelectedCount, piIndexes) > 0 )
   {
      CStringList oDeleteFiles;
      POSITION    oPosition;

      // move selected items first
      for( int i = 0; i < iSelectedCount; ++i )
      {
         CString  sItem;
         int      iIndex = piIndexes[i];

         m_oOtherFilesList.GetText(iIndex, sItem);
         m_oCkptFilesList.AddString(sItem);
         oDeleteFiles.AddTail(sItem);
      }
      // then delete them
      oPosition = oDeleteFiles.GetHeadPosition();
      for( int j = 0; j < iSelectedCount; ++j )
      {
         CString  sItem;

         sItem = oDeleteFiles.GetNext(oPosition);
         m_oOtherFilesList.DeleteString(m_oOtherFilesList.FindStringExact(-1, sItem));
      }
   }
   delete [] piIndexes;
   return;
}

void CCreateCheckpointDlg::OnClickRemoveFileButton() 
{
   CWaitCursor oWaitCursor;
   int         iSelectedCount = m_oCkptFilesList.GetSelCount();
	int *       piIndexes = new int[iSelectedCount];

   if( m_oCkptFilesList.GetSelItems(iSelectedCount, piIndexes) > 0 )
   {
      CStringList oDeleteFiles;
      POSITION    oPosition;

      // move files into other list box
      for( int i = 0; i < iSelectedCount; ++i )
      {
         CString  sItem;
         int      iIndex = piIndexes[i];

         m_oCkptFilesList.GetText(iIndex, sItem);
         m_oOtherFilesList.AddString(sItem);
         oDeleteFiles.AddTail(sItem);
      }
      // then delete them
      oPosition = oDeleteFiles.GetHeadPosition();
      for( int j = 0; j < iSelectedCount; ++j )
      {
         CString  sItem;

         sItem = oDeleteFiles.GetNext(oPosition);
         m_oCkptFilesList.DeleteString(m_oCkptFilesList.FindStringExact(-1, sItem));
      }
   }
   delete [] piIndexes;
   return;
}

void CCreateCheckpointDlg::OnDblclkAllFilesList() 
{
   CWaitCursor oWaitCursor;
   CString  sItem;
   int      iIndex = m_oOtherFilesList.GetCaretIndex();

   m_oOtherFilesList.GetText(iIndex, sItem);
   m_oCkptFilesList.AddString(sItem);
   m_oOtherFilesList.DeleteString(iIndex);
}

void CCreateCheckpointDlg::OnDblclkNewCkptFilesList() 
{
   CWaitCursor oWaitCursor;
   CString  sItem;
   int      iIndex = m_oCkptFilesList.GetCaretIndex();

   m_oCkptFilesList.GetText(iIndex, sItem);
   m_oOtherFilesList.AddString(sItem);
   m_oCkptFilesList.DeleteString(iIndex);
}

void CCreateCheckpointDlg::OnNewCkptHelp() 
{
   AfxGetApp()->WinHelp(CCreateCheckpointDlg::IDD, HELP_CONTEXT);
}

void CCreateCheckpointDlg::OnOK() 
{
   m_oNameEditControl.GetWindowText(m_sName);
   if( m_sName.GetLength() == 0 )
   {
      CString  sCaption;
      CString  sMessage;

      sCaption.LoadString(IDS_NEW_CKPT_BADNAME_CAPTION);
      sMessage.LoadString(IDS_NEW_CKPT_BADNAME);
      MessageBox(sMessage, sCaption, MB_ICONSTOP bitor MB_OK);
      m_oNameEditControl.SetFocus();
   }
   else           // it's OK to exit
   {
	   CDialog::OnOK();
   }
}
