#ifndef  FreqGraphView_H
#define	FreqGraphView_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       FreqGraphView.h	[ FreqGraphView.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface of the CFreqGraphView class
//
//***************************************************************************

#include "SRGraphResource.h"
#include "GraphView.h"

class CFreqGraphView : public CGraphView
{
protected:
	CFreqGraphView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CFreqGraphView)

// Form Data
public:
	//{{AFX_DATA(CFreqGraphView)
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFreqGraphView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual  ~CFreqGraphView();

   void  SetMetricIndex();
   void  UpdateGraph();
   void  RedisplayGraph();
   void  ShowFeedback(SRGraphFeedback *pFeedback);

   int            m_iMetricsCount;     // number of metrics for current language
   CString        m_sPlotMetric;       // name of metric to be plotted
   int            m_iPlotMetricIndex;  // index of same
   COLORREF       m_refPlotColor;      // graph bar color
   SMProject *    m_poProject;         // reference to the view's project object
   CString        m_sCaption;          // this view's frame caption
   SMCheckpoint   m_oCkpt;             // pointer to checkpoint being displayed in this view
   CString        m_sSection;          // profile option key string
   CSourceMetricsDoc *
                  m_poSMDoc;           // keep around for use in the destructor
   long           m_lViewID;           // ditto

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CFreqGraphView)
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnGraphOptions();
	afx_msg void OnUpdateGraphOptions(CCmdUI* pCmdUI);
	afx_msg void OnRequestClose();
	afx_msg void OnUpdateRequestClose(CCmdUI* pCmdUI);
	afx_msg void OnFreqGraphHelp();
	afx_msg void OnUpdateFreqGraphHelp(CCmdUI* pCmdUI);
	afx_msg void OnGraphNextMetric();
	afx_msg void OnUpdateGraphNextMetric(CCmdUI* pCmdUI);
	afx_msg void OnGraphPrevMetric();
	afx_msg void OnUpdateGraphPrevMetric(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif               // FreqGraphView_H
