//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       GraphOptionsDlg.cpp	[ GraphOptionsDlg.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of the CGraphOptionsDlg class
//
//***************************************************************************

#include "stdafx.h"
#include "SourceMetrics.h"
#include "GraphOptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphOptionsDlg dialog

BEGIN_MESSAGE_MAP(CGraphOptionsDlg, CDialog)
	//{{AFX_MSG_MAP(CGraphOptionsDlg)
	ON_BN_CLICKED(IDC_SELECT_PLOT_COLOR, OnSelectPlotColor)
	ON_CBN_SELCHANGE(IDC_METRICS_LIST, OnSelchangeMetricsList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CGraphOptionsDlg::CGraphOptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphOptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGraphOptionsDlg)
	m_sPlotMetric = _T("");
	//}}AFX_DATA_INIT
}


void CGraphOptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphOptionsDlg)
	DDX_Control(pDX, IDC_COLOR_BUTTON, m_btnColorPanel);
	DDX_Control(pDX, IDC_METRICS_LIST, m_comboMetricNames);
	DDX_CBString(pDX, IDC_METRICS_LIST, m_sPlotMetric);
	//}}AFX_DATA_MAP

   if( pDX->m_bSaveAndValidate )
   {
      m_btnColorPanel.m_RGBSwatchColor = m_refPanelColor;
   }
   else
   {
      for( int i = 0; i < m_saMetrics.GetSize(); ++i )
      {
         int   iIndex;

         iIndex = m_comboMetricNames.AddString(m_saMetrics[i]);
         m_comboMetricNames.SetItemData(iIndex, i);
      }
      m_comboMetricNames.SelectString(-1, m_sPlotMetric);
      m_btnColorPanel.m_RGBSwatchColor = m_refPanelColor;
   }
}

/////////////////////////////////////////////////////////////////////////////
// CGraphOptionsDlg message handlers

void CGraphOptionsDlg::OnSelectPlotColor() 
{
   CColorDialog   oDlg(m_refPanelColor, CC_RGBINIT, this);
   
   if( oDlg.DoModal() == IDOK )
   {
      m_refPanelColor = oDlg.GetColor();
      m_btnColorPanel.m_RGBSwatchColor = m_refPanelColor;
		Invalidate();
   }
}

void CGraphOptionsDlg::OnSelchangeMetricsList() 
{
   GetWindowText(m_sPlotMetric);
   m_iPlotMetric = m_comboMetricNames.GetItemData(m_comboMetricNames.FindStringExact(-1, m_sPlotMetric));
}
