/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
 */

#ifndef _CREGISTRY_H_
#define _CREGISTRY_H_


#define IN
#define OUT 

class CRegistry {
public:
	CRegistry();
	~CRegistry();

	void StopParamLogger();

	LONG SetRoot(
		IN LPCTSTR ,
		IN REGSAM samDesired = KEY_READ);	// Security access mask

	LONG ChangeDirectory( 
		IN LPCTSTR ,
		IN REGSAM samDesired = KEY_READ);	// Security access mask

	LONG DirKeys( 
		IN DWORD, 			// iSubkey	
		OUT LPTSTR, 		// lpszName
		IN OUT LPDWORD );  // lpcchName

	static LONG CRegistry::EnumerateSubTree( 
		HKEY hKey, 
		LPCTSTR lpSubKey, 
		BOOL IsEnumerateValues, 
//		EnumerationFunc pEnumFunc, 
		DWORD param );

	LONG DirValues(
		IN DWORD,			// iValue
		OUT LPTSTR, 		// lpszName
		IN OUT LPDWORD,    // lpcchName
		OUT LPDWORD,		// Address of buffer for type code
		OUT LPBYTE,			// Address of buffer for value data
		IN OUT LPDWORD);		// Address for size of data buffer

	LONG QueryValue(
		IN LPCTSTR,			// Address of name of value to query
		OUT LPDWORD,		// Address of buffer for type code
		OUT LPBYTE,			// Address of buffer for value data
		IN OUT LPDWORD);		// Address for size of data buffer

	LONG SetValue(
		IN LPCTSTR,			 // Address of name of value to set
		IN DWORD,        // Flag for value type
		IN CONST LPBYTE, // Address of value data
		IN DWORD );      // Size of value data
				
	LONG QueryInfoKey(
		OUT LPDWORD lpcSubKeys,					// Address of buffer for number of subkeys	
		OUT LPDWORD lpcValues,					// Address of buffer for number of value entries	
		OUT LPDWORD lpcchMaxSubkey,			// Address of buffer for longest subkey name length	
		OUT LPDWORD lpcchMaxValueName,	// Address of buffer for longest value name length	
		OUT LPDWORD lpcbMaxValueData );	// Address of buffer for longest value data length	

	DWORD FlushKey(); // Flushes current key to disk

private:
	HKEY hRegKey;
	char currentPath[ 200 ];
};

class CRegistry_EX : public CRegistry
{
public:
	LONG getValueDW( LPTSTR name, LPDWORD pValue );
	LONG getValueREG_SZ( LPTSTR name, LPBYTE pStr, PDWORD pStrSize );
	LONG getValueREG_MULTI_SZ( LPTSTR name, LPBYTE pStr, PDWORD pStrSize );
};
typedef CRegistry_EX *PCRegistry_EX;

#endif
