/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
*/

// 
extern "C" int __cdecl __Trace(const char * , ...);

#ifndef _AFX_H
#ifndef _dbgUtils_h
#define _dbgUtils_h
	#ifndef ASSERT // avoid redefinitions
		#include "crtdbg.h"
		#ifdef _DEBUG
			#define ASSERT( e ) _ASSERT( e )

			#define TRACE __Trace // use Noam's function

			#define TRACE1(f,a1)        __Trace(f,a1)
			#define TRACE2(f,a1,a2)     __Trace(f,a1,a2)
			#define TRACE3(f,a1,a2,a3)  __Trace(f,a1,a2,a3)
			#define VERIFY(f)	ASSERT( f )

		#else // _DEBUG
			#define ASSERT( e ) 
			#define TRACE(f)	1 ? (void)0 : __Trace
			#define TRACE1(f,a1)        
			#define TRACE2(f,a1,a2)    
			#define TRACE3(f,a1,a2,a3)  
			#define VERIFY(f)          ((void)(f))
		#endif // ifdef _DEBUG
	#endif // ifndef ASSERT
#endif // _dbgUtils_h
#endif // _AFX_H