/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 /* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
*/


#ifndef __SinkTee_H
#define __SinkTee_H

#include "IDataPath.h"

// helper for creating psuedo IUNKNOWN implementation
#define DUMMY_IUNKNOWN	\
	HRESULT __stdcall QueryInterface(REFIID , void ** ppv){ return S_OK;}	\
	ULONG __stdcall AddRef(){return 0;}				\
	ULONG __stdcall Release(){return 0;}			

///////////////////////////////// SinkTee2 ///////////////////
// This class is used as a Tee junction - watever is written to it, it writes to both Sinks.
// Good for debugging
// NOTE: I cut corners here, emulating COM ref counting. 
//	In real life, you should use some mechanism to ensure the application
//  does not leave dead objects...
class SinkTee2 : public IDataSink2
{
public:
	DUMMY_IUNKNOWN
	virtual ~SinkTee2();

	BOOL Init( IDataSink2 *pSink1, IDataSink2 *pSink2 );
	virtual HRESULT Write( char* buff, ULONG size, ULONG *pcbWritten);

	// write the data, return success only if ALL the data is written
	virtual HRESULT Write_( char* buff, ULONG size);
	virtual HRESULT Flush(){ return E_NOTIMPL; }

private:
	IDataSink2 *m_pSink1, *m_pSink2;
};

#endif