/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
 */

#include <objbase.h>
#include "VsoftComUtil.h"

BOOL Guid2Str( IN const GUID &guid, OUT char *strBuffer, IN UINT bufferSz )
{
	WCHAR wchar_buf[256];
	int iErr;
	size_t sz;

	if (strBuffer == NULL)
		return FALSE;

	iErr = StringFromGUID2( guid, wchar_buf, 255 );
	if ( iErr == 0 )
		// String too small (how bug should it be?)
		return FALSE;

	// Convert from Unicode to ascii
	sz = wcstombs( strBuffer, wchar_buf, bufferSz );
	if (sz == -1)
		return FALSE;
	return TRUE;
}

BOOL Str2Guid( IN const char *strGuid, OUT GUID &guid )
{
	wchar_t *wchar_buf;
	size_t sz;
	HRESULT hRes;
	int str_sz;

	if (strGuid == NULL)
		return FALSE;

	str_sz = strlen(strGuid);
	// find out the wide-char string required size
	sz = mbstowcs( NULL, strGuid, str_sz + 1); // convert multi-byte to wide-char (2 bytes)
	if (sz == -1)
		return FALSE;

	wchar_buf = (wchar_t*)malloc( (sz + 2)*sizeof(wchar_t));
	if (!wchar_buf)
		return FALSE;

	sz = mbstowcs( wchar_buf, strGuid, str_sz + 1); // do actual conversion
	if (sz == -1)
	{
		free(wchar_buf);
		return FALSE;
	}

	hRes = CLSIDFromString( wchar_buf, &guid );
	free(wchar_buf);
	if (FAILED(hRes))
		return FALSE;
	return TRUE;			
}
