/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
*/

#ifndef _IDATAPATH_H_
#define _IDATAPATH_H_

#define offset_t int

// {3ACFFF60-D6DD-11d2-8261-0060089927E0}
static const GUID IID_IDataSink2 = 
{ 0x3acfff60, 0xd6dd, 0x11d2, { 0x82, 0x61, 0x0, 0x60, 0x8, 0x99, 0x27, 0xe0 } };

// {09E5BA80-2307-11d3-8E6F-00600854316E}
static const GUID IID_IDataSource2 = 
{ 0x9e5ba80, 0x2307, 0x11d3, { 0x8e, 0x6f, 0x0, 0x60, 0x8, 0x54, 0x31, 0x6e } };

interface IDataSink2 : public IUnknown
{
public:
	virtual HRESULT Write( char* buff, ULONG size, ULONG *pcbWritten) = 0;

	// write the data, return success only if ALL the data is written
	virtual HRESULT Write_( char* buff, ULONG size) = 0; 
	virtual HRESULT Flush() = 0;
};

interface IDataSource2: public IUnknown
{
public:
	// Read data from the input.
	// return the actual number of bytes read.
	// retVal: S_OK ( 0 ) if successful, <0 if error
	virtual HRESULT	Read(char * buff, ULONG sizeToRead, ULONG * actualRead ) = 0;

	
	// Read data from the input.
	// persist on reading until all data is received ( or an error).
	// retVal: S_OK ( 0 ) if successful, <0 if error
	virtual HRESULT	Read_(char * buff, ULONG sizeToRead ) = 0;

	// virtual int Close() = 0; <-- not implemented. 
	// Since we start with open stream, we dont close it ourselves.
	
	// retVal: TRUE if the input is at the end.
	virtual	BOOL	AtEnd() = 0;

	// return the size of the stream in bytes in 'theSize'
	// S_OK if succeedded, otherwise some FAIL code.
	virtual HRESULT		Size(offset_t & theSize) = 0; 
};


#endif
