#ifndef MetricDetailsDlg_H
#define MetricDetailsDlg_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       MetricDetailsDlg.h	[ MetricDetailsDlg.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Defines a detail display class, CMetricDetailsDlg, derived from CDialog
//
//***************************************************************************

#include "SRGraphResource.h"
#include "ochart.h"	   // Include the objective chart header
#include "SRGraphButton.h"

class CMetricDetailsDlg : public CDialog
{
// Construction
public:
	CMetricDetailsDlg(CWnd* pParent = NULL);   // standard constructor
   ~CMetricDetailsDlg() {;}

// Dialog Data
	//{{AFX_DATA(CMetricDetailsDlg)
	enum { IDD = IDD_METRIC_DETAILS };
	CSRGraphButton	m_btnGraph;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMetricDetailsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
   SRGraph        m_oGraph;
   CWnd *         m_poParent;

public:
   CString        m_sCaptionSuffix;
   CStringArray   m_saEntities;     // list of names of values
   CStringArray   m_saValues;       // list of detail values
   CDWordArray    m_iaBlockDepths;  // list of statements at each block depth (optional)

protected:

	// Generated message map functions
	//{{AFX_MSG(CMetricDetailsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDetailsHelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // MetricDetailsDlg_H
