#ifndef MetricsProgressDlg_H
#define MetricsProgressDlg_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       MetricsProgressDlg.h	[ MetricsProgressDlg.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface of the CMetricsProgressDlg class (shows user the
//             progress as metrics for files in a checkpoint are computed)
//
//***************************************************************************

/////////////////////////////////////////////////////////////////////////////
// CMetricsProgressDlg dialog

class CMetricsProgressDlg : public CDialog
{
// Construction
public:
	CMetricsProgressDlg(int iFiles, CWnd* pParent = NULL);

   bool  IsCancelled();

// Dialog Data
	//{{AFX_DATA(CMetricsProgressDlg)
	enum { IDD = IDD_NEW_CKPT_PROGRESS };
	CButton	m_btnCancel;
	CProgressCtrl	m_barProgress;
	CStatic	m_staticPercent;
	CStatic	m_staticFileName;
	//}}AFX_DATA

   void     SetFileName(CString & sFileName);
   void     DoModeless();
   CEvent * GetEvent()                 { return &m_oEvent; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMetricsProgressDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
   CWnd *   m_poParent;          // save for Create call
   int      m_iFileCount;        // files in the checkpoint being created
   int      m_iFilesProcessed;   // current count, used to compute percent
   CEvent   m_oEvent;            // synchronization event used to make sure we're initialized
   bool     m_fIsCancelled;      // true if user clicks on the Cancel button

	// Generated message map functions
	//{{AFX_MSG(CMetricsProgressDlg)
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif                     // MetricsProgressDlg_H
