//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       NewProjectPage1.cpp	[ NewProjectPage1.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of new project wizard, page 1
//
//***************************************************************************

#include "stdafx.h"
#include "SourceMetrics.h"
#include "NewProjectWizard.h"
#include "Resource.h"
#include "SMCpp.h"
#include "SMVisualBasic.h"
#include "SMJava.h"
#include "SMHTML.h"
#include "SMDelphi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage1 property page

IMPLEMENT_DYNCREATE(CNewProjectPage1, CPropertyPage)

CNewProjectPage1::CNewProjectPage1()
   : CPropertyPage(CNewProjectPage1::IDD), m_sLanguageGuide(""), m_poLanguageExemplar(NULL)
{
	//{{AFX_DATA_INIT(CNewProjectPage1)
	//}}AFX_DATA_INIT
	m_sLanguageGuide.LoadString(IDS_NEWP1_LANGUAGE_GUIDE);
}

CNewProjectPage1::~CNewProjectPage1()
{
   delete m_poLanguageExemplar;
}

void CNewProjectPage1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewProjectPage1)
	DDX_Control(pDX, IDC_PROJECT_LANGUAGE, m_oLanguageRadioBox);
	DDX_Control(pDX, IDC_EDIT_FILE_EXTENSIONS, m_oEditFileExtensions);
	DDX_Text(pDX, IDC_PROJECT_LANGUAGE_GUIDE, m_sLanguageGuide);
	//}}AFX_DATA_MAP

   // common variables used in the confirm page, resident in the sheet object
	DDX_Text(pDX, IDC_EDIT_FILE_EXTENSIONS, m_poSheet->m_sFileExtensions);
	DDX_Text(pDX, IDC_PROJECT_EXTENSIONS_LABL, m_poSheet->m_sFileExtensionsLabel);
	DDX_Text(pDX, IDC_PROJECT_LANGUAGE, m_poSheet->m_sLanguageLabel);
   if( not pDX->m_bSaveAndValidate )        // do only on initialization
   {
      DDX_Text(pDX, IDC_LANGUAGE_CPP, SMCpp::CPP_NAME);
   	DDX_Text(pDX, IDC_LANGUAGE_JAVA, SMJava::JAVA_NAME);
	   DDX_Text(pDX, IDC_LANGUAGE_HTML, SMHTML::HTML_NAME);
	   DDX_Text(pDX, IDC_LANGUAGE_VB, SMVisualBasic::VB_NAME);
	   DDX_Text(pDX, IDC_LANGUAGE_PASCAL, SMDelphi::DELPHI_NAME);
   }
}

BEGIN_MESSAGE_MAP(CNewProjectPage1, CPropertyPage)
	//{{AFX_MSG_MAP(CNewProjectPage1)
	ON_BN_CLICKED(IDC_LANGUAGE_CPP, OnLanguageCpp)
	ON_BN_CLICKED(IDC_LANGUAGE_JAVA, OnLanguageJava)
	ON_BN_CLICKED(IDC_LANGUAGE_HTML, OnLanguageHtml)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_LANGUAGE_VB, OnLanguageVB)
	ON_BN_CLICKED(IDC_LANGUAGE_PASCAL, OnLanguageDelphi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage1 message handlers

BOOL CNewProjectPage1::OnSetActive() 
{
	m_poSheet->SetWizardButtons(PSWIZB_NEXT);
	GetParentFrame()->m_dwPromptContext = CNewProjectPage1::IDD;
	return CPropertyPage::OnSetActive();
}

void CNewProjectPage1::OnLanguageCpp() 
{
   SetLanguage(IDC_LANGUAGE_CPP, new SMCpp(Exemplar()));
}

void CNewProjectPage1::OnLanguageJava() 
{
   SetLanguage(IDC_LANGUAGE_JAVA, new SMJava(Exemplar()));
}

void CNewProjectPage1::OnLanguageHtml() 
{
   SetLanguage(IDC_LANGUAGE_HTML, new SMHTML(Exemplar()));
}

void CNewProjectPage1::OnLanguageVB() 
{
   SetLanguage(IDC_LANGUAGE_VB, new SMVisualBasic(Exemplar()));
}

void CNewProjectPage1::OnLanguageDelphi() 
{
   SetLanguage(IDC_LANGUAGE_PASCAL, new SMDelphi(Exemplar()));
}

void CNewProjectPage1::SetLanguage(int iButtonID, SMLanguage * poLang)
{
   m_poSheet->m_iLanguageID = iButtonID;
   if( m_poLanguageExemplar != NULL )
   {
      delete m_poLanguageExemplar;        // user changed his/her mind
   }
   m_poLanguageExemplar = poLang;
   m_poSheet->m_sLanguage = m_poLanguageExemplar->Name();

   // read default extensions from the registry, set language name text from the radio button caption
	m_poSheet->m_sFileExtensions =
         AfxGetApp()->GetProfileString(CSourceMetricsApp::OPTION_SETTINGS + m_poSheet->m_sLanguage,
                                       CSourceMetricsApp::LANGUAGE_EXTENSIONS,
                                       m_poLanguageExemplar->DefaultExtensions());
   m_oEditFileExtensions.SetFocus();
	m_oEditFileExtensions.SetWindowText(m_poSheet->m_sFileExtensions);
	m_oEditFileExtensions.SetSel(0, -1);
}

BOOL CNewProjectPage1::OnKillActive() 
{
   BOOL  fResult = FALSE;     // assume failure

   if( not CPropertyPage::OnKillActive() ) return FALSE;

   // now copy user input to the sheet object
   if( ( ((CButton *)GetDlgItem(IDC_LANGUAGE_CPP))->GetCheck() == 1 )
   or ( ((CButton *)GetDlgItem(IDC_LANGUAGE_JAVA))->GetCheck() == 1 )
   or ( ((CButton *)GetDlgItem(IDC_LANGUAGE_HTML))->GetCheck() == 1 )
   or ( ((CButton *)GetDlgItem(IDC_LANGUAGE_PASCAL))->GetCheck() == 1 )
   or ( ((CButton *)GetDlgItem(IDC_LANGUAGE_VB))->GetCheck() == 1 )
   or ( ((CButton *)GetDlgItem(IDC_LANGUAGE_PASCAL))->GetCheck() == 1 ) )
   {
      fResult = TRUE;
   }
   else
   {
      CString  msg;        // scratch for error dialog
      CString  caption;

      msg.LoadString(IDS_NEWP1_LANGUAGE_ERROR);
      caption.LoadString(IDS_NEW_PROJ_ERROR_CAPTION);
      MessageBox(msg, caption, MB_ICONSTOP bitor MB_OK);
   }
   return fResult;
}

int CNewProjectPage1::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CPropertyPage::OnCreate(lpCreateStruct) == -1)
		return -1;
	
   m_poSheet->m_sFileExtensionsLabel.LoadString(IDS_NEWP1_EXTENSIONS_LABEL);
   m_poSheet->m_sLanguageLabel.LoadString(IDS_NEWP1_LANGUAGE_LABEL);
	
	return 0;
}
