//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       NewProjectPage2.cpp	[ NewProjectPage2.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of new project wizard, page 2
//
//***************************************************************************

#include "stdafx.h"
#include <shlobj.h>

#include "SourceMetrics.h"
#include "NewProjectWizard.h"

#include <io.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage2 property page

IMPLEMENT_DYNCREATE(CNewProjectPage2, CPropertyPage)

BEGIN_MESSAGE_MAP(CNewProjectPage2, CPropertyPage)
	//{{AFX_MSG_MAP(CNewProjectPage2)
	ON_BN_CLICKED(IDC_BUTTON_DIRECTORY_BROWSE, OnButtonDirectoryBrowse)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CNewProjectPage2::CNewProjectPage2()
   : CPropertyPage(CNewProjectPage2::IDD), m_fUserGoingBack(false)
{
	//{{AFX_DATA_INIT(CNewProjectPage2)
	//}}AFX_DATA_INIT
	m_sDirectoryGuide.LoadString(IDS_NEWP2_DIRECTORY_GUIDE);
}

CNewProjectPage2::~CNewProjectPage2()
{
}

void CNewProjectPage2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewProjectPage2)
	DDX_Control(pDX, IDC_BUTTON_DIRECTORY_BROWSE, m_btnPickDirectory);
	DDX_Text(pDX, IDC_PROJECT_DIRECTORY_GUIDE, m_sDirectoryGuide);
	//}}AFX_DATA_MAP

   // common variables used in the confirm page, resident in the sheet object
	DDX_Text(pDX, IDC_SOURCE_DIRECTORY_LABL, m_poSheet->m_sDirectoryLabel);
	DDX_Text(pDX, IDC_EDIT_PROJECT_DIRECTORY, m_poSheet->m_sProjectDirectory);
	DDX_Check(pDX, IDC_CHECK_INCL_SUBDIRECTORIES, m_poSheet->m_fIncludeSubdirectories);
	DDX_Text(pDX, IDC_CHECK_INCL_SUBDIRECTORIES, m_poSheet->m_sSubdirectoriesLabel);
   if( (not pDX->m_bSaveAndValidate) and (m_btnPickDirectory.GetBitmap() == NULL) )
   {
      m_btnPickDirectory.SetBitmap((HBITMAP)m_bitmapBrowse.GetSafeHandle());
   }
}

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage2 message handlers

BOOL CNewProjectPage2::OnSetActive() 
{
   m_fUserGoingBack = false;
   m_poSheet->SetWizardButtons(PSWIZB_BACK bitor PSWIZB_NEXT);
	GetParentFrame()->m_dwPromptContext = CNewProjectPage2::IDD;
	return CPropertyPage::OnSetActive();
}

void CNewProjectPage2::OnButtonDirectoryBrowse() 
{
   BROWSEINFO  oBrowseInfo;
   LPMALLOC    poMalloc;
   TCHAR       cDirectory[MAX_PATH];

   oBrowseInfo.pidlRoot = NULL;
   oBrowseInfo.hwndOwner = this->m_hWnd;
   oBrowseInfo.ulFlags = BIF_RETURNFSANCESTORS bitor BIF_RETURNONLYFSDIRS;
   oBrowseInfo.lpfn = NULL;
   oBrowseInfo.lParam = 0;
   oBrowseInfo.lpszTitle = "Select Project Directory";   // TODO: put in resource string
   ::GetCurrentDirectory(_MAX_DIR, cDirectory);
   oBrowseInfo.pszDisplayName = cDirectory;

   if( SUCCEEDED(::SHGetMalloc(&poMalloc)) )
   {
      LPITEMIDLIST   oPIDList;

      if( (oPIDList = ::SHBrowseForFolder(&oBrowseInfo)) != NULL )
      {
         if( SUCCEEDED(::SHGetPathFromIDList(oPIDList, cDirectory)) )
         {
            CEdit *           poEditDirectory;  // edit field we want to write selected path into

	         poEditDirectory = (CEdit *)GetDlgItem(IDC_EDIT_PROJECT_DIRECTORY);
            poEditDirectory->SetFocus();
            poEditDirectory->SetWindowText(cDirectory);
            poEditDirectory->SetSel(0, -1);
         }
         poMalloc->Free(oPIDList);
      }
      poMalloc->Release();
   }
}

LRESULT CNewProjectPage2::OnWizardBack() 
{
	m_fUserGoingBack = true;
	return CPropertyPage::OnWizardBack();
}

BOOL CNewProjectPage2::OnKillActive() 
{
   BOOL  fResult = TRUE;         // assume success

   if( not CPropertyPage::OnKillActive() ) return FALSE;

   // now copy user input to the sheet object
   // if going on--check the directory
   if( not m_fUserGoingBack )
   {
      CString  msg;

      fResult = FALSE;     // go on only if user has specified a directory
      if( m_poSheet->m_sProjectDirectory.GetLength() == 0 )
      {
         msg.LoadString(IDS_NEWP2_DIRECTORY_ERROR);
      }
      else if( _taccess(m_poSheet->m_sProjectDirectory, 6) != 0 )
      {
         msg.LoadString(IDS_NEWP2_DIRECTORY_ACCESS_ERROR);
      }
      else
      {
         fResult = TRUE;
      }
      if( not fResult )
      {
         CString  caption;

         caption.LoadString(IDS_NEW_PROJ_ERROR_CAPTION);
         MessageBox(msg, caption, MB_ICONSTOP bitor MB_OK);
      }
   }
   return fResult;
}

int CNewProjectPage2::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CPropertyPage::OnCreate(lpCreateStruct) == -1)
   {
		return -1;
   }
   else
   {
      COLORMAP oColorMap;

      oColorMap.from = RGB(255, 255, 255);   // background is white
      oColorMap.to = GetSysColor(COLOR_BTNFACE);
      m_bitmapBrowse.LoadMappedBitmap(IDB_BROWSE_BUTTON, 0, &oColorMap, 1);
	   m_poSheet->m_sSubdirectoriesLabel.LoadString(IDS_NEWP2_SUBDIRECTORIES);
	   m_poSheet->m_sDirectoryLabel.LoadString(IDS_NEWP2_SOURCE_DIRECTORY_LABEL);
   	return 0;
   }
}
