//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       NewProjectPage3.cpp	[ NewProjectPage3.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of new project wizard, page 3
//
//***************************************************************************

#include "stdafx.h"

#include <io.h>

#include "SourceMetrics.h"
#include "NewProjectWizard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage3 property page

IMPLEMENT_DYNCREATE(CNewProjectPage3, CPropertyPage)

CNewProjectPage3::CNewProjectPage3()
   : CPropertyPage(CNewProjectPage3::IDD), m_fUserGoingBack(false), m_fDefaultNameChanged(false)
{
	//{{AFX_DATA_INIT(CNewProjectPage3)
	//}}AFX_DATA_INIT
	m_sProjectNameGuide.LoadString(IDS_NEWP3_PROJECT_NAME_GUIDE);
}

CNewProjectPage3::~CNewProjectPage3()
{
}

void CNewProjectPage3::DoDataExchange(CDataExchange* pDX)
{
   CString sProjectName;      // use as the default project name

	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewProjectPage3)
	DDX_Text(pDX, IDC_PROJECT_NAME_GUIDE, m_sProjectNameGuide);
	//}}AFX_DATA_MAP

   // common variables used in the confirm page, resident in the sheet object
	DDX_Text(pDX, IDC_PROJECT_NAME_LABL, m_poSheet->m_sProjectNameLabel);

   // set the directory name as the default project name
   if( (not pDX->m_bSaveAndValidate) and (not m_fDefaultNameChanged) )
   {
      CString sPath(m_poSheet->m_sProjectDirectory);

      if( sPath.Right(1) != '\\' )
      {
         sPath += '\\';
      }
      _splitpath(sPath, NULL, sProjectName.GetBuffer(_MAX_DIR), NULL, NULL);
      sProjectName.ReleaseBuffer();
      if( not sProjectName.IsEmpty() )
      {
         int   iLastBackSlashIndex;

         // trim off leading and trailing back slashes
         if( sProjectName.Right(1) == '\\' )
         {
            sProjectName = sProjectName.Left(sProjectName.GetLength() - 1);
         }
         if( (iLastBackSlashIndex = sProjectName.ReverseFind('\\')) >= 0 )
         {
            sProjectName = sProjectName.Mid(iLastBackSlashIndex + 1);
         }
         m_poSheet->m_sProjectName = sProjectName.SpanExcluding("\\");
      }
   }
	DDX_Text(pDX, IDC_EDIT_PROJECT_NAME, m_poSheet->m_sProjectName);
}


BEGIN_MESSAGE_MAP(CNewProjectPage3, CPropertyPage)
	//{{AFX_MSG_MAP(CNewProjectPage3)
	ON_WM_CREATE()
	ON_EN_CHANGE(IDC_EDIT_PROJECT_NAME, OnChangeEditProjectName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage3 message handlers

BOOL CNewProjectPage3::OnSetActive() 
{
   m_fUserGoingBack = false;
   m_poSheet->SetWizardButtons(PSWIZB_BACK bitor PSWIZB_NEXT);
	GetParentFrame()->m_dwPromptContext = CNewProjectPage3::IDD;
	return CPropertyPage::OnSetActive();
}

BOOL CNewProjectPage3::OnKillActive() 
{
   BOOL  fResult = FALSE;     // assume failure

   if( not CPropertyPage::OnKillActive() ) return FALSE;

   if( not m_fUserGoingBack )
   {
      CString  msg;
      CString  caption;

      if( m_poSheet->m_sProjectName.IsEmpty() )
      {
         msg.LoadString(IDS_NEWP3_PROJECT_NAME_ERROR);
         caption.LoadString(IDS_NEW_PROJ_ERROR_CAPTION);
         MessageBox(msg, caption, MB_ICONSTOP bitor MB_OK);
      }
      else
      {
         CString sPathName(m_poSheet->m_sProjectDirectory);

         if( sPathName.Right(1) != '\\' )
         {
            sPathName += '\\';
         }
         sPathName += m_poSheet->m_sProjectName + _T(".smp");
         if( _access(sPathName, 0) == 0 )       // see if project file already exists
         {
            msg.LoadString(IDS_NEWP3_DUPLICATE_PROJ_ERROR);
            caption.LoadString(IDS_NEW_PROJ_ERROR_CAPTION);
            if( MessageBox(msg, caption, MB_ICONQUESTION bitor MB_YESNO) == IDYES )
            {
               fResult = true;
            }
         }
         else
         {
            fResult = TRUE;   // OK to go on
         }
      }
   }
   else
   {
      fResult = TRUE;         // OK to go back
   }
	return fResult;
}

LRESULT CNewProjectPage3::OnWizardBack() 
{
   m_fUserGoingBack = true;
	return CPropertyPage::OnWizardBack();
}

int CNewProjectPage3::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CPropertyPage::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_poSheet->m_sProjectNameLabel.LoadString(IDS_NEWP3_PROJECT_NAME_LABEL);
	
	return 0;
}

void CNewProjectPage3::OnChangeEditProjectName() 
{
   m_fDefaultNameChanged = true;   // user didn't want the default, so leave it alone from now on
}
