//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       NewProjectPage4.cpp	[ NewProjectPage4.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of new project wizard, page 4
//
//***************************************************************************

#include "stdafx.h"
#include "SourceMetrics.h"
#include "NewProjectWizard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage4 property page

IMPLEMENT_DYNCREATE(CNewProjectPage4, CPropertyPage)

CNewProjectPage4::CNewProjectPage4() : CPropertyPage(CNewProjectPage4::IDD), m_fUserGoingBack(false)
{
	//{{AFX_DATA_INIT(CNewProjectPage4)
	m_sCheckpointGuide = _T("");
	//}}AFX_DATA_INIT
	m_sCheckpointGuide.LoadString(IDS_NEWP4_CHECKPOINT_GUIDE);
}

CNewProjectPage4::~CNewProjectPage4()
{
}

void CNewProjectPage4::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewProjectPage4)
	DDX_Text(pDX, IDC_PROJECT_CHECKPOINT_GUIDE, m_sCheckpointGuide);
	//}}AFX_DATA_MAP

   // common variables used in the confirm page, resident in the sheet object
	DDX_Text(pDX, IDC_CHECK_CREATE_CHECKPOINT, m_poSheet->m_sCreateCheckpointLabel);
	DDX_Check(pDX, IDC_CHECK_CREATE_CHECKPOINT, m_poSheet->m_fCreateCheckpoint);
	DDX_Text(pDX, IDC_CHECKPOINT_NAME_LABL, m_poSheet->m_sCheckpointNameLabel);
	DDX_Text(pDX, IDC_EDIT_CHECKPOINT_NAME, m_poSheet->m_sCheckpointName);
}


BEGIN_MESSAGE_MAP(CNewProjectPage4, CPropertyPage)
	//{{AFX_MSG_MAP(CNewProjectPage4)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_CHECK_CREATE_CHECKPOINT, OnClickCreateCheckpoint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage4 message handlers

BOOL CNewProjectPage4::OnSetActive() 
{
   CEdit *  poEditCheckpointName;

   poEditCheckpointName = (CEdit *)GetDlgItem(IDC_EDIT_CHECKPOINT_NAME);
   m_fUserGoingBack = false;
   m_poSheet->SetWizardButtons(PSWIZB_BACK bitor PSWIZB_NEXT);
   if( m_poSheet->m_sCheckpointName.GetLength() > 0 )
   {
      poEditCheckpointName->SetFocus();
      poEditCheckpointName->SetSel(0, -1);      // select all characters
   }
	GetParentFrame()->m_dwPromptContext = CNewProjectPage4::IDD;
	return CPropertyPage::OnSetActive();
}

int CNewProjectPage4::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CPropertyPage::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_poSheet->m_sCheckpointNameLabel.LoadString(IDS_NEWP4_CHECKPOINT_NAME_LABEL);
	m_poSheet->m_sCreateCheckpointLabel.LoadString(IDS_NEWP4_CREATE_CHECKPOINT_LABEL);
	
	return 0;
}

BOOL CNewProjectPage4::OnKillActive() 
{
   BOOL  fResult = FALSE;        // assume failure

   if( not CPropertyPage::OnKillActive() ) return FALSE;

   // now copy user input to the sheet object
   // if going on--check the directory
   if( not m_fUserGoingBack and m_poSheet->m_fCreateCheckpoint
         and m_poSheet->m_sCheckpointName.IsEmpty() )
   {
      CString  msg;
      CString  caption;

      msg.LoadString(IDS_NEWP4_CHECKPOINT_ERROR);
      caption.LoadString(IDS_NEW_PROJ_ERROR_CAPTION);
      MessageBox(msg, caption, MB_ICONSTOP bitor MB_OK);
   }
   else
   {
      fResult = TRUE;
   }
   return fResult;
}

void CNewProjectPage4::OnClickCreateCheckpoint() 
{
   CEdit *  poEditCheckpointName;

   poEditCheckpointName = (CEdit *)GetDlgItem(IDC_EDIT_CHECKPOINT_NAME);
	m_poSheet->m_fCreateCheckpoint = ((CButton *)GetDlgItem(IDC_CHECK_CREATE_CHECKPOINT))->GetCheck();
   ((CButton *)GetDlgItem(IDC_CHECKPOINT_NAME_LABL))->EnableWindow(m_poSheet->m_fCreateCheckpoint);
   poEditCheckpointName->EnableWindow(m_poSheet->m_fCreateCheckpoint);
   if( m_poSheet->m_fCreateCheckpoint )
   {
      poEditCheckpointName->SetFocus();
      poEditCheckpointName->SetSel(0, -1);      // select all characters
   }
}

LRESULT CNewProjectPage4::OnWizardBack() 
{
	m_fUserGoingBack = true;
	
	return CPropertyPage::OnWizardBack();
}
