//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       NewProjectPage5.cpp	[ NewProjectPage5.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of new project wizard, page 5
//
//***************************************************************************

#include "stdafx.h"
#include "SourceMetrics.h"
#include "Resource.h"
#include "NewProjectWizard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage5 property page

IMPLEMENT_DYNCREATE(CNewProjectPage5, CPropertyPage)

CNewProjectPage5::CNewProjectPage5() : CPropertyPage(CNewProjectPage5::IDD)
{
	//{{AFX_DATA_INIT(CNewProjectPage5)
	m_sProjectSpecs = _T("");
	m_sConfirmLabel = _T("");
	//}}AFX_DATA_INIT
   m_sConfirmLabel.LoadString(IDS_NEWP5_FINISH_PROMPT);
}

CNewProjectPage5::~CNewProjectPage5()
{
}

void CNewProjectPage5::DoDataExchange(CDataExchange* pDX)
{
   CString  sAddSpec;            // scratch for assembly of confirm message

	CPropertyPage::DoDataExchange(pDX);

   if( not pDX->m_bSaveAndValidate )
   {
      // now prepare the confirmation display
      sAddSpec.LoadString(IDS_NEW_PROJ_CONFIRM_PROMPT);
	   m_sProjectSpecs = sAddSpec + ":\n\n" +
                        m_poSheet->m_sProjectNameLabel + " " + m_poSheet->m_sProjectName + "\n" +
                        m_poSheet->m_sLanguageLabel + " " + m_poSheet->m_sLanguage + "\n" +
                        m_poSheet->m_sFileExtensionsLabel + " " + m_poSheet->m_sFileExtensions + "\n" +
                        m_poSheet->m_sDirectoryLabel + "\n  " + m_poSheet->m_sProjectDirectory + "\n" +
                        m_poSheet->m_sSubdirectoriesLabel + "? ";
      if( m_poSheet->m_fIncludeSubdirectories )
      {
         sAddSpec.LoadString(IDS_BOOLEAN_TRUE);
      }
      else
      {
         sAddSpec.LoadString(IDS_BOOLEAN_FALSE);
      }
      m_sProjectSpecs += sAddSpec + "\n" + m_poSheet->m_sCreateCheckpointLabel + "? ";
      if( m_poSheet->m_fCreateCheckpoint )
      {
         sAddSpec.LoadString(IDS_BOOLEAN_TRUE);
         sAddSpec += "\n" + m_poSheet->m_sCheckpointNameLabel + m_poSheet->m_sCheckpointName;
      }
      else
      {
         sAddSpec.LoadString(IDS_BOOLEAN_FALSE);
      }
      m_sProjectSpecs += sAddSpec;
   }
	//{{AFX_DATA_MAP(CNewProjectPage5)
	DDX_Text(pDX, IDC_NEW_PROJECT_SPECS, m_sProjectSpecs);
	DDX_Text(pDX, IDC_CONFIRM_PROJECT_LABL, m_sConfirmLabel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewProjectPage5, CPropertyPage)
	//{{AFX_MSG_MAP(CNewProjectPage5)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewProjectPage5 message handlers

BOOL CNewProjectPage5::OnSetActive() 
{
   m_poSheet->SetWizardButtons(PSWIZB_BACK bitor PSWIZB_FINISH);
	GetParentFrame()->m_dwPromptContext = CNewProjectPage5::IDD;
	return CPropertyPage::OnSetActive();
}
