#ifndef  NewProjectWizard_H
#define	NewProjectWizard_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       NewProjectWizard.h	[ NewProjectWizard.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Definition of new project wizard, containing property sheet
//
//***************************************************************************

#include "NewProjectPage1.h"
#include "NewProjectPage2.h"
#include "NewProjectPage3.h"
#include "NewProjectPage4.h"
#include "NewProjectPage5.h"

/////////////////////////////////////////////////////////////////////////////
// CNewProjectWizard

class CNewProjectWizard : public CPropertySheet
{
	DECLARE_DYNAMIC(CNewProjectWizard)

// Construction
public:
	CNewProjectWizard(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
private:
   CNewProjectPage1  m_Page1;
   CNewProjectPage2  m_Page2;
   CNewProjectPage3  m_Page3;
   CNewProjectPage4  m_Page4;
   CNewProjectPage5  m_Page5;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNewProjectWizard)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual        ~CNewProjectWizard();
   void           SetProjectName(CString & name)   { m_sProjectName = name; }
   void           SetProjectDir(CString & dir)     { m_sProjectDirectory = dir; }

   CString        m_sFileExtensionsLabel;    // label for filter edit field
   CString        m_sFileExtensions;         // project file filter
   SMLanguage *   m_poLanguage;              // exemplar for the new project
   CString        m_sLanguageLabel;          // source language label
   CString        m_sLanguage;               // language name
   int            m_iLanguageID;             // language radio button ID
   CString        m_sSubdirectoriesLabel;    // subdirectories checkbox label
	BOOL	         m_fIncludeSubdirectories;  // project extends to subdirectories
	CString	      m_sDirectoryLabel;         // project directory label
	CString	      m_sProjectDirectory;       // project's root directory
   CString        m_sProjectNameLabel;       // project name label
   CString        m_sProjectName;            // project name (name of .smp file)
   CString        m_sCheckpointNameLabel;    // create checkpoint ckbox label
   CString        m_sCheckpointName;         // create checkpoint checkbox label
   CString        m_sCreateCheckpointLabel;  // checkbox label
	BOOL	         m_fCreateCheckpoint;       // create first checkpoint with project

	// Generated message map functions
protected:
	//{{AFX_MSG(CNewProjectWizard)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif                        // NewProjectWizard_H
