//////////////////////////////////////////////////////////////////////
// Stingray Software - Objective Chart(tm) Copyright (c) 1996 Stingray
// Software Inc. All Rights Reserved. This source code is only
// intended as a supplement to the Stingray Objective Chart product.
// See the help files for detailed information regarding the use of these classes
/////////////////////////////////////////////////////////////////////

// GraphDoc.h : interface of the CGraphDoc class
//
/////////////////////////////////////////////////////////////////////////////
#ifdef _OBJCHART_DLL
	#undef AFXAPP_DATA
	#define AFXAPP_DATA AFXAPI_DATA
	#undef AFX_DATA
	#define AFX_DATA OC_DATA
#endif


#ifndef __GRAPHDOC_H__
#define __GRAPHDOC_H__

// Document sub-codes for processing data via the SECComDoc linking system

#define OGRIDDOC_CMND_NOOP			0x00000000	// No-Ops are always zero
#define OGRIDDOC_CMND_CELLVALUE		0x00000100	// Grid commands are kept away from graph commands



//@doc

//@mdata SRGraph | CGraphDoc | m_Graph | The SRGraph object which this document holds.

//@class Manages linked document operations for the SRGraphView class
//@rem This file is optional and is not required for the normal operation 
//of the Objective Graph kit.
class CGraphDoc : public SECComDoc
{
protected: // create from serialization only
	CGraphDoc();
	DECLARE_DYNCREATE(CGraphDoc)

// Attributes
public:
	virtual BOOL GmemInit(UINT code,HANDLE hMem);

	//@cmember
	SRGraph m_Graph;	// The graph object

// Operations
public:

	SecDocUpdate(UINT nSubCode,DWORD dwData);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGraphDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGraphDoc();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGraphDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
#endif // __GRAPHDOC_H__

/////////////////////////////////////////////////////////////////////////////
// Reset DLL declaration context

#undef AFX_DATA
#define AFX_DATA
#undef AFXAPP_DATA
#define AFXAPP_DATA NEAR
