//////////////////////////////////////////////////////////////////////
// Stingray Software - Objective Chart(tm) Copyright (c) 1996 Stingray
// Software Inc. All Rights Reserved. This source code is only
// intended as a supplement to the Stingray Objective Chart product.
// See the help files for detailed information regarding the use of these classes
/////////////////////////////////////////////////////////////////////
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       GraphPageSetup.cpp	[ GraphPageSetup.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner - based on original that was purchased with Objective Chart (see above)
//
// OVERVIEW:   Implements a graph page print setup class, CGraphPageSetup, derived from CDialog
//
//***************************************************************************

#include "stdafx.h"

#include "SourceMetrics.h"
#include "GraphPageSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CGraphPageSetup, CDialog)
	//{{AFX_MSG_MAP(CGraphPageSetup)
		// NOTE: the ClassWizard will add message map macros here
	ON_BN_CLICKED(IDC_GVW_CHECK1, OnCheckUseMax)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CGraphPageSetup::CGraphPageSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphPageSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGraphPageSetup)
		// NOTE: the ClassWizard will add member initialization here
	m_bUseMaxArea = FALSE;
	m_nVAlign = 1;
	m_nHAlign = 1;
	//}}AFX_DATA_INIT
}

void CGraphPageSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraphPageSetup)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_GVW_COMBO1, m_comboSize);
	DDX_Check(pDX, IDC_GVW_CHECK1, m_bUseMaxArea);
	DDX_Radio(pDX, IDC_GVW_RADIO1, m_nVAlign);
	DDX_Radio(pDX, IDC_GVW_RADIO5, m_nHAlign);
	//}}AFX_DATA_MAP
}

BOOL
CGraphPageSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_comboSize.SetCurSel(0);
	OnCheckUseMax();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CGraphPageSetup message handlers

void
CGraphPageSetup::OnCheckUseMax() 
{
	BOOL bNoUseMax = compl(((CButton *)GetDlgItem(IDC_GVW_CHECK1))->GetState()) bitand 1;

	GetDlgItem(IDC_GVW_RADIO1)->EnableWindow(bNoUseMax);
	GetDlgItem(IDC_GVW_RADIO2)->EnableWindow(bNoUseMax);
	GetDlgItem(IDC_GVW_RADIO3)->EnableWindow(bNoUseMax);
	GetDlgItem(IDC_GVW_RADIO5)->EnableWindow(bNoUseMax);
	GetDlgItem(IDC_GVW_RADIO6)->EnableWindow(bNoUseMax);
	GetDlgItem(IDC_GVW_RADIO7)->EnableWindow(bNoUseMax);	
	GetDlgItem(IDC_GVW_COMBO1)->EnableWindow(bNoUseMax);	
}
