//////////////////////////////////////////////////////////////////////
// Stingray Software - Objective Chart(tm) Copyright (c) 1996 Stingray
// Software Inc. All Rights Reserved. This source code is only
// intended as a supplement to the Stingray Objective Chart product.
// See the help files for detailed information regarding the use of these classes
/////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// The text comments in this file are formatted to generate
// a help file on build using Microsofts free Autoduck tool
// The help file is available with this source and it is
// reccomended that you use this file in conjunction with the
// mfc help files
/////////////////////////////////////////////////////////////
#ifdef _OBJCHART_DLL
	#undef AFXAPP_DATA
	#define AFXAPP_DATA AFXAPI_DATA
	#undef AFX_DATA
	#define AFX_DATA OC_DATA
#endif

#ifndef __GRAPHVW_H__
#define __GRAPHVW_H__
//@doc

// GraphView.h : interface of the SRGraphView class
//
/////////////////////////////////////////////////////////////////////////////

//@mdata BOOL | SRGraphView | m_bUseMaxArea | Set TRUE if the page should be limited in size during printing.
//@rem The PageSetup dialog allows standard sizes of display or a selection of paper sizes to be chosen and a 
//simple alignment to be spacified.

//@mdata int | SRGraphView | m_nValign | The vertical alignment code for print pagination.
//@rem May be.. None. Align to top of page, centre or bottom of page.

//@mdata int | SRGraphView | m_nHalign | The horizontal alignment code for print pagination
//@rem May be.. None. Align to left, centre or right of page.

//@mdata int | SRGraphView | m_nPageSizeCode | A selection of standard page sizes..
//@rem Standard sizes are chosen via the PageSetup dialog and may be..<nl><nl>
//320 X 240<nl>
//640 X 480<nl>
//800 X 600<nl>
//1024 X 768<nl>
//A5<nl>
//A4<nl>

//@mdata BOOL | SRGraphView | m_bUseMaxArea | Set TRUE if the page should be limited in size during printing.

//@mdata int | SRGraphView | m_nValign | The vertical alignment code for print pagination.

//@mdata int | SRGraphView | m_nHalign | The horizontal alignment code for print pagination

//@mdata int | SRGraphView | m_nPageSizeCode | A selection of standard page sizes..

//@mdata UINT | SRGraphView | m_TimerIdent | The mouse timer identifier.

//@mdata SRGraphTip | SRGraphView | m_GraphTip | The single graph tip object.

//@mdata DWORD | SRGraphView | m_dwSelectionType | The current selection type. i.e. horizontal, vertical, box or circular.

//@mdata int | SRGraphView | m_nUnzoomMinIndex | The graphs original minimum index (used for unzooming data )

//@mdata int | SRGraphView | m_nUnzoomMaxIndex |  The graphs original maximum index (used for unzooming data )

//@mdata int | SRGraphView | m_nUnzoomMinGroup | The graphs original minimum group (used for unzooming data )

//@mdata int | SRGraphView | m_nUnzoomMaxGroup | The graphs original maximum group (used for unzooming data )

//@mdata SRGraphComponent * | SRGraphView | m_pZoomedDisplay |	A pointer to the display which has been zoomed. Used in restoration of the original state.

//@mdata BOOL | SRGraphView | m_bZoomed | TRUE if tha graph has been zoomed. Used to activate the unzoom tool via the command update interface.

//@mdata BOOL | SRGraphView | m_bShowingTip | TRUE if a graph tip is currently on display. Only one exists so a call for a new tip will recycle the old one.

//@mdata CPoint | SRGraphView | m_SelectionPointA | The first point in a selection area

//@mdata CPoint | SRGraphView | m_SelectionPointB | The last point in a selection area

//@mdata BOOL | SRGraphView | m_bSelecting | TRUE if the graph is in selection box mode.

//@mdata BOOL | SRGraphView | m_bInFeedback | TRUE if the mouse point was clicked inside a feedback ared (data dragging will commence)

//@mdata int | SRGraphView | m_nDragIndex | The index of the data item being dragged

//@mdata int | SRGraphView | m_nDragGroup | The group of the data item being dragged

//@mdata BOOL | SRGraphView | m_bDragging | TRUE if dragging is in progress

//@mdata CPoint | SRGraphView | m_MousePoint | The stored mouse position. Used to ascertain if the mouse has rested still in a feedback area for the requisite 1.5 seconds.

//@mdata BOOL | SRGraphView | m_bMouseTimerIsRunning | TRUE if the mouse is considered to be "still" and the timeout is waiting to fire.



/////////////////////////////////////////////////////////////////////////////
// PageSetup dialog

class PageSetup : public CDialog
{
// Construction
public:
	PageSetup(CWnd* pParent = NULL);   // standard constructor
	int m_nPageSizeCode;

// Dialog Data
	//{{AFX_DATA(PageSetup)
	enum { IDD = IDD_GVW_PAGESETUP };
	CComboBox	m_Size;
	BOOL	m_bUseMaxArea;
	int		m_nValign;
	int		m_nHalign;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PageSetup)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(PageSetup)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnGvwCheck1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CSelectQuery dialog

class CSelectQuery : public CDialog
{
// Construction
public:
	CSelectQuery(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSelectQuery)
	enum { IDD = IDD_GVW_SELECTQUERY1 };
	int		m_Selection;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSelectQuery)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSelectQuery)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#define MOUSE_TIMER_EVENT 3860

//@class Specialised view class for the display and management of SRGraph objects. This CView based class simply adds 
//graph feedback, data dragging and data zooming to your graph and chart applications.
//@devnote The classes for PageSetup, SelQry and GraphTip are also in this class' files..
class SRGraphView : public CView
{
protected:
	virtual SRGraph * GetGraph();
	//@cmember Set TRUE if the page should be limited in size during printing.
	BOOL m_bUseMaxArea;
	//@cmember The vertical alignment code for print pagination.
	int m_nValign;
	//@cmember The horizontal alignment code for print pagination
	int m_nHalign;
	//@cmember A selection of standard page sizes..
	int m_nPageSizeCode;
	//@cmember The mouse timer identifier.
	UINT m_TimerIdent;
	//@cmember The single graph tip object.
	SRGraphTip m_GraphTip;
	//@cmember The current selection type. i.e. horizontal, vertical, box or circular.
	DWORD m_dwSelectionType;
	//@cmember The graphs original minimum index (used for unzooming data )
	int m_nUnzoomMinIndex;
	//@cmember The graphs original maximum index (used for unzooming data )
	int m_nUnzoomMaxIndex;
	//@cmember The graphs original minimum group (used for unzooming data )
	int m_nUnzoomMinGroup;
	//@cmember The graphs original maximum group (used for unzooming data )
	int m_nUnzoomMaxGroup;
	//@cmember A pointer to the display which has been zoomed. Used in restoration of the original state.
	SRGraphComponent * m_pZoomedDisplay;
	//@cmember TRUE if tha graph has been zoomed. Used to activate the unzoom tool via the command update interface.
	BOOL m_bZoomed;
	//@cmember TRUE if a graph tip is currently on display. Only one exists so a call for a new tip will recycle the old one.
	BOOL m_bShowingTip;
	//@cmember The first point in a selection area
	CPoint m_SelectionPointA;
	//@cmember The last point in a selection area
	CPoint m_SelectionPointB;
	//@cmember TRUE if the graph is in selection box mode.
	BOOL m_bSelecting;
	//@cmember TRUE if the mouse point was clicked inside a feedback ared (data dragging will commence)
	BOOL m_bInFeedback;
	//@cmember The index of the data item being dragged
	int m_nDragIndex;
	//@cmember The group of the data item being dragged
	int m_nDragGroup;
	//@cmember TRUE if dragging is in progress
	BOOL m_bDragging;
	//@cmember The stored mouse position. Used to ascertain if the mouse has rested still in a feedback area for the requisite 1.5 seconds.
	CPoint m_MousePoint;
	//@cmember TRUE if the mouse is considered to be "still" and the timeout is waiting to fire.
	BOOL m_bMouseTimerIsRunning;


protected:
	//@cmember Displays a feedback chart tip. You should override this function.
	virtual void ShowFeedback(SRGraphFeedback *pFeedback);
	//@cmember Constructor
	SRGraphView();
	DECLARE_DYNCREATE(SRGraphView)

// Attributes
public:
	//@cmember Draws a selecting box
	virtual void DrawSelection(CPoint point);
	//@cmember Override this to draw your own selection styles.
	virtual void DrawCustomSelection(CPoint point);
	//@cmember Handles data dragging and selection box display
	virtual void MouseDrag(int nFlags,CPoint point);
	//@cmember Returns the document
	CGraphDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SRGraphView)
	public:
	//@cmember Draws the graph
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	protected:
	//@cmember Prepares the print job
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	//@cmember Performs print pagination and outputs the graph to the printer
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	//@cmember Resets the graph from print mode
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual SRGraphPosition * GetPosition(SRGraph *pGraph,CPoint point);
	//@cmember Destructor
	virtual ~SRGraphView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(SRGraphView)
	//@cmember Does nothing.
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//@cmember Handles mouse movement and chatr tip triggering
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//@cmember Handles the mouse button presses
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//@cmember Handles mouse button release. Performs selection tasks or releases dragged data.
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//@cmember Checks to see if a chart tip is needed
	afx_msg void OnTimer(UINT nIDEvent);
	//@cmember Copys the image to the clipboard
	afx_msg void OnEditCopy();
	//@cmember Un zooms graphs
	afx_msg void OnGraphZoomout();
	//@cmember Activates or deactivates the un-zoom button and menu items
	afx_msg void OnUpdateGraphZoomout(CCmdUI* pCmdUI);
	//@cmember Runs a simple pagination dialog
	afx_msg void OnGraphPagesetup();
	//@cmember Edits a graph using the editor
	afx_msg void OnGraphEdit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GraphView.cpp
inline CGraphDoc* SRGraphView::GetDocument()
   { return (CGraphDoc*)m_pDocument; }
#endif

#endif // __GRAPHVW_H__

#undef AFX_DATA
#define AFX_DATA
#undef AFXAPP_DATA
#define AFXAPP_DATA NEAR

/////////////////////////////////////////////////////////////////////////////
