//////////////////////////////////////////////////////////////////////
// Stingray Software - Objective Chart(tm) Copyright (c) 1996 Stingray
// Software Inc. All Rights Reserved. This source code is only
// intended as a supplement to the Stingray Objective Chart product.
// See the help files for detailed information regarding the use of these classes
/////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////
// The text comments in this file are formatted to generate
// a help file on build using Microsofts free Autoduck tool
// The help file is available with this source and it is
// reccomended that you use this file in conjunction with the
// mfc help files
/////////////////////////////////////////////////////////////

// @doc
// @module SRGraphFeedback.cpp | 
// SRGraphFeedback implementation file
//
// copyright <cp>Stingray Software 1996 
//
// Written by Bob Powell (bob@stingsoft.com)

#ifdef _OBJCHART_DLL
#undef AFXAPI_DATA
#define AFXAPI_DATA __based(__segname("_DATA"))
#endif



#include "stdafx.h"

//@mfunc Constructor
SRGraphFeedback::SRGraphFeedback()
{
}

//@mfunc Constructor. Creates a feedback object with parameters which hold the extent and data array position of the data
//@parm A pointer to a list of CPoint objects used to define the boundaries of the hot area
//@parm The number of points included in the list
//@parm The group containing the SRGraphData associated with this hot area
//@parm The index within the group which resolves the SRGraphData associated with this hot area
//@parm A pointer to the graph object which owns this feedback object.
SRGraphFeedback::SRGraphFeedback(LPPOINT points,int pointCount,int group,int index,SRGraph *Parent)
{
	m_polygonRegion.CreatePolygonRgn(points,pointCount,ALTERNATE);
	m_nGroup=group;
	m_nIndex=index;
	m_pParentGraph=Parent;
}

//@mfunc Tests for a hit within this feedback area.
//@parm The X coordinate of the mouse cursor
//@parm the Y coordinate of the mouse cursor
//@rdesc TRUE if the cursor is within the boundaries of the region defining the hot area. Otherwise FALSE.
BOOL SRGraphFeedback::ptInFeedback(int x,int y)
{
	if(m_polygonRegion.PtInRegion(x,y))
		return TRUE;
	return FALSE;
}

//@mfunc Destuctor. Deletes any region data associated with this object.
SRGraphFeedback::~SRGraphFeedback()
{
	if(m_polygonRegion.GetSafeHandle()!=NULL)
		m_polygonRegion.DeleteObject();
}

int SRGraphFeedback::GetnGroup()
{
	return m_nGroup;
}

int SRGraphFeedback::GetnIndex()
{
	return m_nIndex;
}
