//////////////////////////////////////////////////////////////////////
// Stingray Software - Objective Chart(tm) Copyright (c) 1996 Stingray
// Software Inc. All Rights Reserved. This source code is only
// intended as a supplement to the Stingray Objective Chart product.
// See the help files for detailed information regarding the use of these classes
/////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////
// The text comments in this file are formatted to generate
// a help file on build using Microsofts free Autoduck tool
// The help file is available with this source and it is
// reccomended that you use this file in conjunction with the
// mfc help files
/////////////////////////////////////////////////////////////

// @doc
// @module SRGraphFeedback.h | 
// SRGraphFeedback definition file
//
// copyright <cp>Stingray Software 1996 
//
// Written by Bob Powell (bob@stingsoft.com)

#ifdef _OBJCHART_DLL
	#undef AFXAPP_DATA
	#define AFXAPP_DATA AFXAPI_DATA
	#undef AFX_DATA
	#define AFX_DATA OC_DATA
#endif

#ifndef __FEEDBACK__
#define __FEEDBACK__


//@mdata CRgn | SRGraphFeedback | m_polygonRegion | The polygonal region which outlines the data

//@mdata CRect | SRGraphFeedback | m_BoundingRect | A bounding rectangle for the polygonal region (not currently in use)

//@mdata int | SRGraphFeedback | m_nGroup | The group to which the data defined by the region belongs

//@mdata int | SRGraphFeedback | m_nIndex | The index in which the data defined by the region is stored

//@mdata SRGraph | SRGraphFeedback | *m_pParentGraph | A pointer to the SRGraph object which owns this feedback item.

//@class A List of these objects is used to store "hot" areas which can be used to
// associate a screen area with the data displayed in it.<nl>
//When a graphic object like a bar or graph data point is drawn the outline of that 
//object may be stored in an SRGraphFeedback object as a CRgn (region gdi object) along
//with the group and index of the data which is shown in the region.
//By running a hit test routine it is possible to derive information from the mouse cursor
//as it is moved in the display area.
class SRGraphFeedback : public CObject
{
public:
	int GetnIndex();
	virtual int GetnGroup();
	//@cmember Constructor
	SRGraphFeedback();
	//@cmember destructor
	virtual ~SRGraphFeedback();
	//@cmember Constructor with initialisation
	SRGraphFeedback(LPPOINT points,int PointCount,int group,int index,SRGraph *Parent);
	//@cmember To perform hit testing according to a coordinate supplied in X and Y.
	BOOL ptInFeedback(int x,int y);

// Attributes
public:
	//@cmember The region which defines the on screen feedback area
	CRgn m_polygonRegion;
	//@cmember The calulated bounding rectangle of the region
	CRect m_BoundingRect;
	//@cmember The group associated with this hot area
	int m_nGroup;
	//@cmember the index associated with this hot area
	int m_nIndex;
	//@cmember a pointer to the SRGraph object which owns this object
	SRGraph *m_pParentGraph;
};

#endif
#undef AFX_DATA
#define AFX_DATA
#undef AFXAPP_DATA
#define AFXAPP_DATA NEAR
