//////////////////////////////////////////////////////////////////////
// Stingray Software - Objective Chart(tm) Copyright (c) 1996 Stingray
// Software Inc. All Rights Reserved. This source code is only
// intended as a supplement to the Stingray Objective Chart product.
// See the help files for detailed information regarding the use of these classes
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// The text comments in this file are formatted to generate
// a help file on build using Microsofts free Autoduck tool
// The help file is available with this source and it is
// reccomended that you use this file in conjunction with the
// mfc help files
/////////////////////////////////////////////////////////////
//@doc
/////////////////////////////////////////////////////////////


//@module SRGraph.h |
//Copyright <cp>Stingray Software 1996. Written by Bob Powell ( bob@stingsoft.com )


#ifdef _OBJCHART_DLL
	#undef AFXAPP_DATA
	#define AFXAPP_DATA AFXAPI_DATA
	#undef AFX_DATA
	#define AFX_DATA OC_DATA
#endif


#ifndef __SRGRAPH__
#define __SRGRAPH__


//////////////////////////////////////////////////////
// Autoduck help file entries

//@mfunc BOOL | SRGraph | IsBackgroundDraw | Interrogates the m_bBackgroundDraw member
//@see <mf SRGraph::SetBackgroundDraw> <md SRGraph::m_bBackgroundDraw>

//@mfunc BOOL | SRGraph | IsFeedbackLogging | Interrogates the m_bFeedbackLogging member
//@see <mf SRGraph::SetFeedbackLogging> <md SRGraph::m_bFeedbackLogging>

//@mfunc void | SRGraph | SetBackgroundDraw | Initialises the m_BackgrounDraw member
//@parm BOOL | bBDraw | TRUE to enable background drawing FALSE to disable

//@mfunc void | SRGraph | SetFeedbackLogging | Initialises the m_bFeedbackLogging member
//@parm BOOL | bLogging | TRUE to enable feedback logging FALSE to disable
//@rem When drawing of graphs takes place an optional list of feedback items may be created which give
// information about a data item from its screen position. A list of
// "hot" areas is created which contains the group and index of the data which created it
//@see <c SRGraphFeedback> <md SRGraph::m_FeedbackList>

//@mdata BOOL | SRGraph | m_bIsEmpty | TRUE if this graph holds no data otherwise FALSE

//@mdata BOOL | SRGraph | m_bSignificantChange | TRUE after a <mf SRGraph::SetSignificantChanges> command
//@rem The signficant change system allows the graph to process data at a faster rate by only updating things when they have changed.
// All of the components in the component list will look at thier own significant change flag before the draw cycle commences. If the flag is TRUE 
//the component will completely re-draw all of its elements and update all of its labels.

//@mdata BOOL | SRGraph | m_bBackgroundDraw | TRUE if the <mf SRGraph::DrawComponentList> function should draw data in a back buffer before copying to the screen.
//@rem Usefull for drawing flicker free graphs. May be time consuming or memory hungry on slower or smaller systems. Ignored if the owner window is printing

//@mdata BOOL | SRGRaph | m_bFeedbackLogging | TRUE if automatic construction of the feedback list is required. Otherwise FALSE
//@see <c SRGraphFeedback> <md SRGraph::m_FeedbackList>

//@mdata BOOL | SRGraph | m_bHintPending | TRUE if a re-drawing hint has been flagged but not yet processed

//@mdata CObList | SRGraph | m_ComponentList | Holds a list of <c SRGraphComponent> objects which define the appearence of this graph
//@rem This is the master list for all graphic components in  this graph
//@see <c SRGraphComponent> <c SRGraphDisplay> <c SRGraphLegend> <c SRGraphTitle> <c SRGraphBackground> <mf SRGraph::DrawComponentList> <mf SRGraph::GetComponentList>

//@mdata CPtrList | SRGraph | m_data | The main list of <c SRGraphDataList> objects
//@rem This is root object for the data array in this graph. It holds pointers to a list of SRGraphDataList objects. One for each group
//@see <mf SRGraph::GetDataList>

//@mdata int | SRGraph | m_nDefaultGroup | The group currently being used as the default data set

//@mdata CObList | SRGraph | m_FeedbackList | Holds a list of <c SRGraphFeedback> objects
//@see <md SRGraph::m_bFeedbackLogging>

//@mdata LPARAM | SRGraph | m_lHint | A hint value passed to this graph after a view update request

//@mdata CObject* | SRGraph | m_pHint | A pointer to a CObject based Hint item. Not currently used in this implementation of Objective Chart (reserved)

//@mdata SRGraphStyle | SRGraph | m_Style | an <c SRGraphStyle> object which holds information about this graph.

//@mdata SRGraphAnnotationList | SRGraph | m_strTitle |  The multi-lingual titles for this graph object
//@see <c SRGraphAnnotationList> <c SRGraphAnnotation>

//@mdata int | SRGraph | m_nCountryCode | The telephone dialling code of the country for which annotation texts should be displayed.
//@rem The default setting for the country code is 1 (U.S.A.) Providing you have made the correct entries in your annotation lists re-programming
 //this data member will make the graph display the corresponding language text at the next re-draw.
//@see <mf SRGraph::SetCountryCode> <mf SRGraph::GetCountryCode>

//@mfunc void | SRGraph | SetCountryCode | Initialises the country code for this graph.
//@parm int | nCode | The integer which corresponds to the telephone dialling code of the desired language. ie 1 for U.S.A 49 for Germany etc.
//@see <mf SRGraph::GetCountryCode> <md SRGraph::m_nCountryCode>


//@mfunc int | SRGraph | GetCountryCode | Interrogates the country code for this graph.
//@rdesc The integer which corresponds to the telephone dialling code of the desired language. ie 1 for U.S.A 49 for Germany etc.
//@see <mf SRGraph::SetCountryCode> <md SRGraph::m_nCountryCode>

//@mfunc void | SRGraph | SetMaxArea | Sets the maximum area which a graph may use.
//@parm CRect | r | The CRect defining the rectangle
//@parm BOOL | UseMaxArea | if TRUE (default) then this area is used
//@rem Primarily used to limit page sizes and image areas during printing. May be used for window displays too.

//@mdata CRect  | SRGraph | m_MaxArea | maximum area which a chart may occupy
//@rem used only in the print preview mode in the current implementation. There is no reason why it should not be used in a screen mode however.

//@mdata DWORD | SRGraph | m_dwAlignInDC | semaphores for centering behaviour
//@rem used only in the print preview mode in the current implementation. There is no reason why it should not be used in a screen mode however.

//@mdata BOOL | SRGraph | m_bUseMaxArea | When TRUE the maximum area is used to define the image size. When FALSE the size is determined by the DC being used to draw on
//@rem used only in the print preview mode in the current implementation. There is no reason why it should not be used in a screen mode however.

//@mfunc BOOL | SRGraph | GetUseMaxArea | Returns TRUE if the maximum area as described in m_MaxArea is to be used

//@mfunc BOOL | SRGraph | SetUseMaxArea | Initialises the m_MaxArea member variable
//@parm BOOL | b | supply TRUE if the area is to be used

//@mfunc CRect | SRGraph | GetMaxArea | Returns the m_MaxArea rectangle

//@mfunc void | SRGraph | SetAlignment | Sets up pagination of the graph
//@parm DWORD | dwAlign | The alignment code
//@rem The alignment code may be defined by mixing parameters with a binary OR process<nl>
//Vertical alignment codes are...<nl>
//		CX_ALIGN_NONE<nl>
//		CX_ALIGN_VTOP<nl>
//		CX_ALIGN_VCENTER<nl>
//		CX_ALIGN_VBOTTOM<nl>
//Horizontal alignment codes are...<nl>
//		CX_ALIGN_NONE<nl>
//		CX_ALIGN_HLEFT<nl>
//		CX_ALIGN_HCENTER<nl>
//		CX_ALIGN_HRIGHT<nl>





/////////////////////////////////////////////////////////////////////////////////////////////

//@class The graph data parent object This is the main placeholder for all Objective Chart functionality
class SRGraph : public CObject
{
protected:
	CString m_strEmptyString;	// always empty.
//@access public data members
public:
	//@cmember NEW Returns the m_bFeedbackLogging flag.
	virtual BOOL GetFeedbackLogging();
	//@cmember Set TRUE to inform the whole graph of a change in the data or component structures.
	BOOL m_bSignificantChange;
	//@cmember The dialling code of the country for which this graph should be adjusted.
	int m_nCountryCode;
	
	//@cmember A pointer to a hint object (not used at this time)
	CObject * m_pHint;

	//@cmember The most recent hint code
	LPARAM m_lHint;

	//@cmember Semaphore signifying that a hint operation is outstanding
	BOOL m_bHintPending;

	//@cmember Semaphore enabling or disabling the use of a back buffer in draw operations
	BOOL m_bBackgroundDraw;

	//@cmember The default group for all display types that only use one group. (pie charts etc) 
	//Set this to the group number that you want to display with the 
	int m_nDefaultGroup;

	//@cmember Style data for axes and graph types
	SRGraphStyle m_Style;
	
	//@cmember List of components which make up the graphical display elements for this graph
	CObList m_ComponentList;

	//@cmember Flag signifies a clean graph if TRUE
	BOOL m_bIsEmpty;

	//@cmember the title list
	SRGraphAnnotationList m_strTitle;
	
	//@cmember A list of pointers to the data
	CPtrList m_data;

	//@cmember Semaphore to enable or disable feedback logging
	BOOL m_bFeedbackLogging;
	
	//@cmember A linked list of SRGraphFeedback objects
	CObList m_FeedbackList;
	

//operations
//@access private member functions
private:

	//@cmember Parses a substring from the text buffer
	int SubString(LPCSTR text,CString &section,DWORD *index,double *number);
	
	//@cmember Reports syntax errors in graph template texts.
	virtual void TemplateSyntax(LPCSTR line);


//@access public member functions
public:
	//@cmember Constructor
	SRGraph();
	
	//@cmember Destructor
	virtual ~SRGraph();

	//@cmember Rolls a group in the desired direction.
	virtual void RollGroup(int nGroup, double dValue=0.0, BOOL bDirection=FALSE);

	//@cmember Places a feedbck rectangle on the feedback list
	virtual void LogRectangle(CRect r,int group, int index);

	//@cmember Sets the maximum area which a graph may use.
	void SetMaxArea(CRect r,BOOL bUseArea=TRUE){m_MaxArea=r;m_bUseMaxArea=bUseArea;}

	//@cmember Returns the rectangle defined as the maximum usable area.
	CRect GetMaxArea(){return m_MaxArea;}

	//@cmember Returns TRUE if the sizes of the final display are to be controlled by the m_MaxArea rectangle
	BOOL GetUseMaxArea(){return m_bUseMaxArea;}

	//@cmember Enables or disables the use of the maximum size settings;
	void SetUseMaxArea(BOOL b){m_bUseMaxArea=b;}

	//@cmember Sets the alignment style for this graph.
	void SetAlignment(DWORD dwAlign){m_dwAlignInDC=dwAlign;}

	//@cmember Signals to all components on the main list that an important change has taken place.
	virtual void SetSignificantChanges();
	
	//@cmember Sets all styles in a range to a reference style
	virtual void SetGlobalStyle(int nStartGroup,int nEndGroup,int nStartIndex,int nEndIndex,SRGraphStyle *ptrStyle,BOOL bSetHeaders=TRUE);

	//@cmember Sets the minimum index for a given display on the component list
	virtual void SetComponentMinIndex(int nComponent,int index,UINT Type=-1);
	
	//@cmember Sets the minimum index for a given display on the component list
	virtual void SetComponentMaxIndex(int nComponent,int index,UINT Type=-1);
	
	//@cmember Sets the minimum group for a given display on the component list
	virtual void SetComponentMinGroup(int nComponent,int group,UINT Type=-1);
	
	//@cmember Sets the maximum group for a given display on the component list
	virtual void SetComponentMaxGroup(int nComponent,int group,UINT Type=-1);
	
	//@cmember Returns the average of all data items in this group
	virtual double GetGroupAverage(int group);

	//@cmember Returns the total for a given index across all groups
	virtual double GetIndexTotal(int index,int nMinGroup=0,int nMaxGroup=0);

	//@cmember Returns FALSE This object is not a dynamic graph
	virtual BOOL IsDynamic();

	//@cmember Wipes the component list without destroying the graph data
	virtual void KillComponentList();

	//@cmember Changes title text in the m_strTitle annotation list
	virtual void SetGraphTitle(LPCSTR title,int code=1);

	//@cmember Updates hint information for the component drawing routines
	virtual void SetComponentHint(CWnd * pCWnd,LPARAM lHint,CObject * pHint);

	//@cmember interprets tab delimited text data into graph information
	virtual void ParseText(LPCSTR text);
	
	//@cmember Empties a graph of data
	virtual void KillGraph(void);

	//@cmember Retrieves the total of all data storage values in a given range of groups and indices. Used to calculate percentages.
	virtual double GetDataTotal(int mingroup, int  minindex, int maxgroup, int maxindex);

	//@cmember Retrieves the total of all data storage values in this graph. Used to calculate percentages.
	virtual double GetDataTotal(int group=-1);

	//@cmember	Parses a graph template either froma resource or filename
	virtual void ReadTemplate(LPCSTR TemplateName);

	//@cmember	returns the header from the <c SRGraphData> list indexed by group
	virtual CString& GetHeader(int group=0,int code=1);

	//@cmember	returns text held in the <c SRGraphData> object within group and referenced by index
	virtual CString& GetText(int group,int index,int code=1);

	//@cmember returns the title of the graph
	virtual CString & GetGraphTitle(int code=1);

	//@cmember returns the total number of data sets (groups) in the graph
	virtual int GetGroupCount();

	//@cmember returns the count of the longest group;
	virtual int GetMaxXDivisions();

	//@cmember scans the graph data to return the maximum and minimum value used in this graph
	virtual CScale GetAutoScaleRange(BOOL HiLo=FALSE);

	//@cmember References the correct <c SRGraphDataList> in the array
	SRGraphDataList *GetGroup(int group,BOOL GrowList=TRUE);

	//@cmember Override this to interpret your own custom template commands.
	virtual BOOL UserParser(LPSTR line);

	//@cmember	Adds a <c SRGraphComponent> or derived object to the list of graphic objects
	virtual POSITION AddComponent(SRGraphComponent *gc);

	//@Cmember scans the component list drawing as it goes. Order in the list is reverse Z order on screen.
	virtual void DrawComponentList(CDC *pDC,CWnd *pCWnd);



	DECLARE_SERIAL(SRGraph);

	//@cmember handles storage and retrieval of data
	virtual void Serialize(CArchive &ar);


	//@cmember Sets a header for a group of data by annotating the <c SRGraphDataList> for that group.
	void SetHeader(int group,LPCSTR text);

	//@cmember Sets a numeric value in the data array
	void SetValue(int x,int group,double number);

	//@cmember Sets text in the data array
	void SetText(int x,int group,LPCSTR text);

#ifdef _DEBUG

	//@cmember Dump diagnostics. Debug only.
	void Dump(CDumpContext &dc) const;

#endif //_DEBUG

	//@cmember Searches for a feedback point
	virtual SRGraphFeedback *GetFeedback(int x,int y);
	
	//@cmember Adds a polygon to the feedback list
	virtual void LogPoly(LPPOINT points,int PointCount,int group,int index);
	
	//@cmember Adds a point to the feedback list
	virtual void LogPoint(CPoint point,int group,int index);
	
	//@cmember Retrieves an average value for a specific index across a range of groups
	virtual double GetGroupAverage(int MinIndex,int MaxIndex,int Group);
	
	//@cmember Gets the total of all graph values
	virtual double GetGraphTotal();
	
	//@cmember Retrieves the m_bBackgroundDraw member
	virtual BOOL IsBackgroundDraw(){return m_bBackgroundDraw;}
	
	//@cmember Retrieves the m_bFeedbackLogging member
	virtual BOOL IsFeedbackLogging(){return m_bFeedbackLogging;}
	
	//@cmember Initializes the m_bFeedbackLogging member
	virtual void SetFeedbackLogging(BOOL bLogging=TRUE){m_bFeedbackLogging=bLogging;}
	
	//@cmember Initialises the m_bBackgroundDraw member
	virtual void SetBackgroundDraw(BOOL bBDraw=TRUE){m_bBackgroundDraw=bBDraw;}
	
	//@cmember Retrieves a pointer to the m_strTitle member
	virtual SRGraphAnnotationList * GetTitle();
	
	//@cmember Retrieves a pointer to the m_FeedbackList member
	virtual CObList * GetFeedbackList();
	
	//@cmember Retrieves a pointer to the m_ComponentList member
	virtual CObList * GetComponentList();
	
	//@cmember Retrieves a pointer to the m_ComponentList member
	virtual SRGraphStyle * GetStyle();
	
	//@cmember Gets a numeric value from the data array
	virtual double GetValue(int index,int group);
	
	//@cmember Gets a pointer to a specific component in the component list
	virtual SRGraphComponent * GetComponent(int nComponent,UINT Type);
	
	//@cmember Searches the m_ComponentList for the next item after the supplied POSITION
	virtual SRGraphComponent * GetNextComponent(POSITION& rPos,UINT Type=-1);
	
	//@cmember Gets the first POSITION in the component list
	virtual POSITION GetFirstComponentPosition(UINT Type=-1);
	
	//@cmember Retrieves a pointer to the m_data member
	virtual CPtrList *GetDataList();
	
	//@cmember Finds the first POSITION of the first item on the m_data list
	virtual POSITION GetFirstDataPosition();
	
	//@cmember Gets the next item fron the m_data list
	virtual void *GetNextData(POSITION& p);

	//@cmember Sets the dialling code for the annotations in this graph
	virtual void SetCountryCode(int n){m_nCountryCode=n;SetSignificantChanges();}
	
	//@cmember Interrogates the dialling code for the annotations in this graph.
	virtual int GetCountryCode(){return m_nCountryCode;}

protected:
	//@cmember The maximum area which a chart may occupy
	CRect m_MaxArea;
	//@cmember Binary semaphores for centering behaviour
	DWORD m_dwAlignInDC;
	//@cmember Semaphore. When TRUE the maximum area is used to define the image size. When FALSE the size is determined by the DC being used to draw on
	BOOL m_bUseMaxArea;
};

//@class Graphs which handle dynamic data
class SRDynamicGraph : public SRGraph
{

public:
	DECLARE_SERIAL(SRDynamicGraph);
	
	//@cmember Stores or retrieves dynamic graphs
	virtual void Serialize(CArchive &ar);

	//@cmember Sets text header for this data
	virtual void SetText(int x,int group,LPCSTR text);
	
	//@cmember Overloaded member function. initialises a number in the buffer.
	virtual void SetValue(int x,int group,double number);
	
	//@cmember Overloaded member function. initialises a number in the buffer.
	virtual void SetValue(int x,int group,int number);
	
	//@cmember Overloaded member function. initialises a number in the buffer.
	virtual void SetValue(int x,int group,char number);
	
	//@cmember Overridden member function. Text parsing is not supporteed in dynamic graphs.
	virtual void ParseText(LPCSTR text);
	
	//@cmember returns the requested annotation from the SRGraphData referenced by index and group
	virtual CString& GetText(int group, int index, int code=1);
	
	//@cmember Returns the maximum number of indices.
	virtual int GetMaxXDivisions();
	
	//@cmember Returns the sum of all data stored in a specified group
	virtual double GetDataTotal(int group=-1);
	
	//@cmember returns the maximum and minimum values stored in this graph.	
	virtual CScale GetAutoScaleRange(BOOL HiLo=FALSE);
};


#endif //__SRGRAPH__

// Reset DLL declaration context

#undef AFX_DATA
#define AFX_DATA
#undef AFXAPP_DATA
#define AFXAPP_DATA NEAR
