// srgrapheditdialog.h : header file
//
#ifdef _OBJCHART_DLL
	#undef AFXAPP_DATA
	#define AFXAPP_DATA AFXAPI_DATA
	#undef AFX_DATA
	#define AFX_DATA OC_DATA
#endif
/////////////////////////////////////////////////////////////////////////////
// SRGraphEditDialog dialog
#ifndef __SRGRAPHEDITDIALOG_H__
#define __SRGRAPHEDITDIALOG_H__

class SRGraphEditDialog : public CDialog
{
// Construction
public:
	virtual void OnEditDataItem();
	virtual void AddCustomComponent(int Selection);
	virtual void BuildTree();
	SRGraphEditDialog(CWnd* pParent = NULL);   // standard constructor

	enum ImageValues {
	GRAPH_SEL,
	GRAPH_NSEL,
	COMLIST_SEL,
	COMLIST_NSEL,
	COMPONENT_SEL,
	COMPONENT_NSEL,
	ANNOTATION_SEL,
	ANNOTATION_NSEL,
	DATALIST_SEL,
	DATALIST_NSEL,
	DATAITEM_SEL,
	DATAITEM_NSEL,
	VALUE_SEL,
	VALUE_NSEL
	};

// Dialog Data
	//{{AFX_DATA(SRGraphEditDialog)
	enum { IDD = SRG_IDD_GRAPHEDIT };
	SRGTreeCtrl	m_GraphTree;
	//}}AFX_DATA

	//@cmember Pointer to the graph being edited.
	SRGraph *m_pGraph; 


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SRGraphEditDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HTREEITEM m_DataListItem;
	HTREEITEM m_ComponentListItem;
	HTREEITEM m_Root;
	CImageList m_ImageList;

	// Generated message map functions
	//{{AFX_MSG(SRGraphEditDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnDblclkTree1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRclickTree1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLoadComponentList();
	afx_msg void OnSaveComponentList();
	afx_msg void OnDeleteComponent();
	afx_msg void OnEditComponentProperties();
	afx_msg void OnAddComponent();
	afx_msg void OnAddLabel();
	afx_msg void OnAddannotation();
	afx_msg void OnLabelAddannotation();
	afx_msg void OnIdBack1();
	afx_msg void OnIdForward1();
	afx_msg void OnIdMovetotop();
	afx_msg void OnIdSendtoback();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif

#undef AFX_DATA
#define AFX_DATA
#undef AFXAPP_DATA
#define AFXAPP_DATA NEAR
