//////////////////////////////////////////////////////////////////////
// Stingray Software - Objective Chart(tm) Copyright (c) 1996 Stingray
// Software Inc. All Rights Reserved. This source code is only
// intended as a supplement to the Stingray Objective Chart product.
// See the help files for detailed information regarding the use of these classes
/////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
// The text comments in this file are formatted to generate
// a help file on build using Microsofts free Autoduck tool
// The help file is available with this source and it is
// reccomended that you use this file in conjunction with the
// mfc help files
/////////////////////////////////////////////////////////////

// @doc
// @module GrphTip.h |
// SRGraphTip header file
//
// copyright <cp>Stingray Software 1996 
//

/////////////////////////////////////////////////////////////////////////////
// SRGraphTip window
#ifdef _OBJCHART_DLL
	#undef AFXAPP_DATA
	#define AFXAPP_DATA AFXAPI_DATA
	#undef AFX_DATA
	#define AFX_DATA    AFX_DATA_EXPORT
#endif

#ifndef __GRAPH_TIP__
#define __GRAPH_TIP__

//@class A simple tooltip style window designed to show data for the SRGraphFeedback system
//@rem This simple window draws a ToolTip like box with text on the main window. It is not 
//clipped by its parent and remains in-place until either the program which displayed it turns 
//it off or until the mouse cursor passes over it.
class SRGraphTip : public CWnd
{
// Construction
public:
	//@cmember Returns TRUE if the Graph Tip is currently visible
	virtual BOOL IsShowing(){return m_bShowing;}

	//@cmember One step initialization of the Graph Tip
	virtual void ShowTip(LPCSTR strText,CPoint point,CWnd *pParentWnd);

	//@cmember Constructor
	SRGraphTip();

	//@cmember Removes the Graph Tip and destroys the window
	virtual void EraseTip();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SRGraphTip)
	//}}AFX_VIRTUAL

// Implementation
public:
	//@cmember Destructor
	virtual ~SRGraphTip();

	// Generated message map functions
protected:
	//@cmember The Afx generated class name
	CString m_ClassName;

	//@cmember The text to display in the Graph Tip
	CString m_TextString;

	//@cmember The point at which the graph tip is drawn
	CPoint m_Point;

	//@cmember TRUE when the Graph Tip is visible
	BOOL m_bShowing;

	//{{AFX_MSG(SRGraphTip)
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif

#undef AFX_DATA
#define AFX_DATA
#undef AFXAPP_DATA
#define AFXAPP_DATA NEAR
