#ifndef OptionsLanguagePage_H
#define OptionsLanguagePage_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       OptionsLanguagePage.h	[ OptionsLanguagePage.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface of the COptionsLanguagePage class
//
//***************************************************************************

class CSourceMetricsApp;

class COptionsLanguagePage : public CPropertyPage
{
	DECLARE_DYNCREATE(COptionsLanguagePage)

// Construction
public:
	COptionsLanguagePage();
	~COptionsLanguagePage();

   void  Init(SMLanguage * exemplar, int id);

// Dialog Data
	//{{AFX_DATA(COptionsLanguagePage)
	enum { IDD = IDD_OPTIONS_LANGUAGE };
	CListCtrl	m_viewlistColumnLabels;
	CEdit	m_editExtensions;
	CString	m_sExtensions;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionsLanguagePage)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
   CSourceMetricsApp *
                  m_poApp;             // for access to option parameters as string lists
   SMLanguage *   m_poExemplar;        // used to retrieve the column names and such for current language
   CString        m_sSection;          // the registry section for this page's settings
   int            m_iColumns;          // number of metrics display columns (that need labels)
   int            m_iDefaultLabelID0;  // string list ID of 0th default label for current language

	// Generated message map functions
	//{{AFX_MSG(COptionsLanguagePage)
	afx_msg void OnEndlabeleditColumnLabels(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickLanguageColumnLabels(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeExtensions();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // OptionsLanguagePage_H
