#ifndef OPTIONSPRINTPAGE_H
#define OPTIONSPRINTPAGE_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       OptionsPrintPage.h	[ OptionsPrintPage.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface of the COptionsPrintPage class
//
//***************************************************************************

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// COptionsPrintPage dialog

class COptionsPrintPage : public CPropertyPage
{
	DECLARE_DYNCREATE(COptionsPrintPage)

// Construction
public:
	COptionsPrintPage();   // standard constructor
   ~COptionsPrintPage();

// Dialog Data
	//{{AFX_DATA(COptionsPrintPage)
	enum { IDD = IDD_OPTIONS_PRINTING };
	CEdit	m_editTopMargin;
	CEdit	m_editRightMargin;
	CEdit	m_editLeftMargin;
	CEdit	m_editIntercolumnMargin;
	CEdit	m_editBottomMargin;
	CSpinButtonCtrl	m_spinTopMargin;
	CSpinButtonCtrl	m_spinRightMargin;
	CSpinButtonCtrl	m_spinLeftMargin;
	CSpinButtonCtrl	m_spinIntercolumnMargin;
	CSpinButtonCtrl	m_spinBottomMargin;
	CString	m_sBottomMargin;
	CString	m_sIntercolumnMargin;
	CString	m_sLeftMargin;
	CString	m_sRightMargin;
	CString	m_sTopMargin;
	CString	m_sFontName;
	CString	m_sFontSize;
	CString	m_sFontStyle;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionsPrintPage)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
   CSourceMetricsApp *
                  m_poApp;          // for access to option parameters as string lists
   CStringArray   m_oMargins;
   CStringArray   m_oFontData;
   CString        m_sSection;       // the registry section for this page's settings

   // helper methods
   void           SetMargin(NM_UPDOWN * poNMUpDown, CEdit & oEditControl);

	// Generated message map functions
	//{{AFX_MSG(COptionsPrintPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnDeltaposSpinBottomMargin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinIntercolSpace(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinLeftMargin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinRightMargin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinTopMargin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelectFont();
	afx_msg void OnChangePrintBottomMargin();
	afx_msg void OnChangePrintIntercolSpace();
	afx_msg void OnChangePrintLeftMargin();
	afx_msg void OnChangePrintRightMargin();
	afx_msg void OnChangePrintTopMargin();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // OPTIONSPRINTPAGE_H
