#ifndef OPTIONSPROPERTYSHEET_H
#define OPTIONSPROPERTYSHEET_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       OptionsPropertySheet.h	[ OptionsPropertySheet.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface of the COptionsPropertySheet class
//
//***************************************************************************

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "OptionsGeneralPage.h"
#include "OptionsLanguagePage.h"
#include "OptionsPrintPage.h"
#include "SMCpp.h"
#include "SMJava.h"
#include "SMVisualBasic.h"
#include "SMHTML.h"
#include "SMDelphi.h"

/////////////////////////////////////////////////////////////////////////////
// COptionsPropertySheet

class COptionsPropertySheet : public CPropertySheet
{
	DECLARE_DYNAMIC(COptionsPropertySheet)

// Construction
public:
	COptionsPropertySheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
private:
   SMCpp *           m_poCppExemplar;
   SMJava *          m_poJavaExemplar;
   SMVisualBasic *   m_poVBExemplar;
   SMHTML *          m_poHTMLExemplar;
   SMDelphi *        m_poDelphiExemplar;

   COptionsGeneralPage  m_GeneralPage;
   COptionsLanguagePage m_CppPage;
   COptionsLanguagePage m_JavaPage;
   COptionsLanguagePage m_VBPage;
   COptionsLanguagePage m_DelphiPage;
   COptionsLanguagePage m_HTMLPage;
   COptionsPrintPage    m_PrintPage;

public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionsPropertySheet)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COptionsPropertySheet();

	// Generated message map functions
protected:
	//{{AFX_MSG(COptionsPropertySheet)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // OPTIONSPROPERTYSHEET_H
