//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       PickDirectoryDlg.cpp	[ PickDirectoryDlg.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of the CPickDirectoryDlg class
//
//***************************************************************************

#include "stdafx.h"

#include <AFXPRIV.H>             // for overloaded DoModal() code
#include "SourceMetrics.h"
#include "PickDirectoryDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPickDirectoryDlg dialog

BEGIN_MESSAGE_MAP(CPickDirectoryDlg, CFileDialog)
	//{{AFX_MSG_MAP(CPickDirectoryDlg)
	//}}AFX_MSG_MAP

END_MESSAGE_MAP()

// static variable declarations
CString CPickDirectoryDlg::m_sPath;

CPickDirectoryDlg::CPickDirectoryDlg(
      BOOL fOpenFileDialog,
      LPCSTR pcDefExtensions,
      LPCSTR pcFileName /*= NULL*/,
      DWORD dwFlags /*= OFN_HIDEREADONLY bitor OFN_OVERWRITEPROMPT*/,
      LPCSTR pcFilter /*=NULL*/,
      CWnd* pParent /*=NULL*/)
	: CFileDialog(fOpenFileDialog, pcDefExtensions, pcFileName, dwFlags, pcFilter, pParent)
{
	//{{AFX_DATA_INIT(CPickDirectoryDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
   m_ofn.Flags or_eq OFN_ENABLETEMPLATE bitor OFN_EXPLORER bitor OFN_ENABLEHOOK bitor OFN_HIDEREADONLY;
   m_ofn.lpTemplateName = MAKEINTRESOURCE(IDD_PICK_DIRECTORY);
   m_sDialogCaption.LoadString(IDS_NEWPROJ_PICK_DIR_CAPTION);
   m_ofn.lpstrTitle = m_sDialogCaption;
   m_ofn.lCustData = IDCANCEL;   // initialize as return flag
   m_ofn.lpfnHook = OFNHook;
}

// *************************************************************************************************
// overload the MFC method to comment out an offensive ASSERT
int 
CPickDirectoryDlg::DoModal()
{
	ASSERT_VALID(this);
	ASSERT(m_ofn.Flags & OFN_ENABLEHOOK);
	ASSERT(m_ofn.lpfnHook != NULL); // can still be a user hook
#ifdef _MAC
	ASSERT((m_ofn.Flags & OFN_ALLOWMULTISELECT) == 0);
#endif

	// WINBUG: This is a special case for the file open/save dialog,
	//  which sometimes pumps while it is coming up but before it has
	//  disabled the main window.
	HWND hWndFocus = ::GetFocus();
	BOOL bEnableParent = FALSE;
	m_ofn.hwndOwner = PreModal();
	AfxUnhookWindowCreate();
	if (m_ofn.hwndOwner != NULL && ::IsWindowEnabled(m_ofn.hwndOwner))
	{
		bEnableParent = TRUE;
		::EnableWindow(m_ofn.hwndOwner, FALSE);
	}

	_AFX_THREAD_STATE* pThreadState = AfxGetThreadState();
	ASSERT(pThreadState->m_pAlternateWndInit == NULL);

	if (m_ofn.Flags & OFN_EXPLORER)
		pThreadState->m_pAlternateWndInit = this;
	else
		AfxHookWindowCreate(this);

	int nResult;
	if (m_bOpenFileDialog)
		nResult = ::GetOpenFileName(&m_ofn);
	else
		nResult = ::GetSaveFileName(&m_ofn);

// TODO: find out why the following always asserts
//	if (nResult)
//		ASSERT(pThreadState->m_pAlternateWndInit == NULL);
	pThreadState->m_pAlternateWndInit = NULL;

	// WINBUG: Second part of special case for file open/save dialog.
	if (bEnableParent)
		::EnableWindow(m_ofn.hwndOwner, TRUE);
	if (::IsWindow(hWndFocus))
		::SetFocus(hWndFocus);

	PostModal();
	return nResult ? nResult : IDCANCEL;
}

void CPickDirectoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CFileDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPickDirectoryDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

UINT APIENTRY
CPickDirectoryDlg::OFNHook(HWND /* hChildWnd */, UINT uMsg, WPARAM /* wParam */, LPARAM lParam)
{
   if( uMsg == WM_NOTIFY )
   {
      OFNOTIFY * poNotify = (OFNOTIFY *)lParam;

      switch( poNotify->hdr.code )
      {
      case CDN_INITDONE:
         CommDlg_OpenSave_HideControl(poNotify->hdr.hwndFrom, 0x442);   // file name label
         CommDlg_OpenSave_HideControl(poNotify->hdr.hwndFrom, 0x480);   // file name edit control
         CommDlg_OpenSave_SetControlText(poNotify->hdr.hwndFrom, IDOK, _T("Select"));
         break;

      case CDN_FOLDERCHANGE:
         {
            CFileFind   oFindFile;        // file search object
            BOOL        fFileFound;       // true if next file found
            CString     sFileName;

            CommDlg_OpenSave_GetFolderPath(poNotify->hdr.hwndFrom, m_sPath.GetBuffer(MAX_PATH), MAX_PATH);
            m_sPath.ReleaseBuffer();

            // find first file that isn't a directory
            fFileFound = oFindFile.FindFile(m_sPath + _T("\\*.*"));
            while( fFileFound != 0 )
            {
               fFileFound = oFindFile.FindNextFile();
               if( not oFindFile.IsDirectory() )
               {
                  sFileName = oFindFile.GetFileName();
                  break;
               }
            }
            oFindFile.Close();
            CommDlg_OpenSave_SetControlText(poNotify->hdr.hwndFrom, 0x480, (LPCTSTR)sFileName);
            _tcscpy(poNotify->lpOFN->lpstrFile, (LPCTSTR)sFileName);
         }
         break;
      }
   }
   return 0;
}
