#ifndef  ProjectView_H
#define	ProjectView_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       ProjectView.h	[ ProjectView.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface of the CProjectView class
//
//***************************************************************************

#include <afxcview.h>

/////////////////////////////////////////////////////////////////////////////
// CProjectView view

class CProjectView : public CListView
{
protected:
	CProjectView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CProjectView)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProjectView)
	public:
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual  ~CProjectView();

   static int CALLBACK
            SortCompareCallback(LPARAM leftItemData, LPARAM rightItemData, LPARAM pThis);
   int      SortCompare(LPARAM leftItemData, LPARAM rightItemData);

   enum HEADER_COUNT { FIXED_HEADERS = 3 };
   enum SORT_DIRECTION { SORT_DESCENDING = 1 };

   CSourceMetricsDoc *
                  m_poSMDoc;              // resolve this once and then use it everywhere in place of GetDocument()
   SMProject *    m_poProject;            // reference to the view's project object
   CListCtrl *    m_poListCtrl;           // reference to the view's embedded list view control
   int            m_iSelectedIndex;       // selected item's index (or -1)
   CString        m_sCaption;             // this view's frame caption (add to main frame when in focus)
   CStringArray   m_saColumnOrder;        // column order numbers
   int            m_iMetricColumns;       // number of metrics values for the checkpoint's language
   int            m_iViewColumns;         // total number of columns, including fixed, non-metric columns
   CString        m_sSection;             // profile option key string
   int            m_iSortColumn;          // valid only during sorts
   CByteArray     m_baSortOrder;          // toggled: 1 for sort descending, == 0 for ascending
   bool           m_fLabelEdit;           // true when user is editing a checkpoint name (used to control Delete key)

   // members used only during printing
   bool           m_fPrinting;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CProjectView)
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnCheckpointCreatechart();
	afx_msg void OnCheckpointDelete();
	afx_msg void OnUpdateCheckpointDelete(CCmdUI* pCmdUI);
	afx_msg void OnViewCheckpoint();
	afx_msg void OnCheckpointNew();
	afx_msg void OnListViewClick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndLabelEdit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCheckpointRename();
	afx_msg void OnUpdateCheckpointRename(CCmdUI* pCmdUI);
	afx_msg void OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnViewCkptMetricsDetails();
	afx_msg void OnUpdateViewCheckpoint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewCkptMetricsDetails(CCmdUI* pCmdUI);
	afx_msg void OnProjViewHelp();
	afx_msg void OnUpdateProjViewHelp(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnBeginlabeledit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnExportCkptMetrics();
	afx_msg void OnUpdateExportCkptMetrics(CCmdUI* pCmdUI);
	afx_msg void OnExportMetricsAll();
	afx_msg void OnUpdateExportMetricsAll(CCmdUI* pCmdUI);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif                  // ProjectView_H
