//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       SMFile.cpp	[ SMFile.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implements data container class SMFile
//
//***************************************************************************

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_SERIAL(SMFile, CObject, 1)

// ***************************************************************************
// constructor
SMFile::SMFile() : m_poLanguage(NULL)
{
   return;
}

// ***************************************************************************
// destructor
SMFile::~SMFile()
{
   delete m_poLanguage;
}

// ***************************************************************************
// copy constructor
SMFile::SMFile(const SMFile & ckpt)
{
   m_sPathname = ckpt.m_sPathname;
   m_poLanguage = ckpt.m_poLanguage->MakeNew();
   return;
}

// ***************************************************************************
// assignment operator
SMFile &
SMFile::operator=(const SMFile& file)
{
   if( &file != this )
   {
      m_sPathname = file.m_sPathname;
      delete m_poLanguage;             // make sure exiting object is freed
      m_poLanguage = file.m_poLanguage->MakeNew();
   }
   return *this;
}

// ***************************************************************************
//
void
SMFile::Serialize(CArchive & ar)
{
   // first do the MFC classes and C++ types
	if( ar.IsStoring() )
	{
		ar << m_sPathname << m_poLanguage;
	}
	else
	{
		ar >> m_sPathname >> m_poLanguage;
	}
   // then the metrics data objects
   m_poLanguage->Serialize(ar);
}
