#ifndef  SMFile_H
#define	SMFile_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       SMFile.h	[ SMFile.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Definition of data container class SMFile
//
//***************************************************************************

class SMLanguage; // forward reference

class SMFile : public CObject
{
   public:
      SMFile();
      SMFile(const SMFile & cpt);               // copy constructor
      SMFile & operator=(const SMFile& file);   // assignment operator
      virtual ~SMFile();

      // virtual overrides
	   virtual void Serialize(CArchive& ar);

      // property access methods
      CString  PathName() const              { return m_sPathname; }
      void     PathName(const CString & pn)  { m_sPathname = pn; } 

      // this is the heart of the metrics data: set at constructor time, accessed often
      SMLanguage *   m_poLanguage;        // file metric data container

   private:
      CString        m_sPathname;         // path relative to the project directory

      DECLARE_SERIAL(SMFile)
};
////////////////////////////////////////////////////////////////////////////////

#endif						// SMFile_H
