//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       SMSplashPanelFree.cpp	[ SMSplashPanelFree.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of class SMSplashPanelFree
//
//***************************************************************************

#include "stdafx.h"
#include "SourceMetrics.h"
#include "DibButton.h"
#include "SMSplashPanelFree.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SMSplashPanelFree dialog


SMSplashPanelFree::SMSplashPanelFree(CSourceMetricsApp * pApp, CWnd * pParent)
	: m_poApp(pApp), m_poParent(pParent), CDialog(SMSplashPanelFree::IDD, pParent)
{
	//{{AFX_DATA_INIT(SMSplashPanelFree)
	m_sFreewareMessage = _T("");
	//}}AFX_DATA_INIT
   m_sFreewareMessage.LoadString(IDS_FREEWARE_MSG);
   m_DibLogo.LoadDib(IDB_CAMPWOOD_LOGO, true);
}

BOOL SMSplashPanelFree::OnInitDialog() 
{
	CDialog::OnInitDialog();
   if( not m_DibLogo.SubclassDlgItem(IDC_LOGO_PICTURE, this) )
   {
      EndDialog(IDCANCEL);
      return FALSE;
   }
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void SMSplashPanelFree::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SMSplashPanelFree)
	DDX_Control(pDX, IDC_CHECK_DONT_SHOW, m_ckboxDontShow);
	DDX_Control(pDX, IDC_EDIT_FREEWARE_MESSAGE, m_editFreewareMsg);
	DDX_Text(pDX, IDC_EDIT_FREEWARE_MESSAGE, m_sFreewareMessage);
	//}}AFX_DATA_MAP
   if( not pDX->m_bSaveAndValidate )
   {
      CenterWindow(m_poParent);                          // put us in the middle of our parent's window
   }
}

BEGIN_MESSAGE_MAP(SMSplashPanelFree, CDialog)
	//{{AFX_MSG_MAP(SMSplashPanelFree)
	ON_BN_CLICKED(ID_SMEXIT, OnSMExit)
	ON_BN_CLICKED(ID_SMHELP, OnSMHelp)
	ON_WM_PAINT()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_CHECK_DONT_SHOW, OnCheckDontShow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SMSplashPanelFree message handlers

void SMSplashPanelFree::OnSMExit() 
{
   EndDialog(ID_SMEXIT);
}

void SMSplashPanelFree::OnSMHelp() 
{
   m_poApp->WinHelp(ID_ABOUT_FREEWARE);  	
}

void SMSplashPanelFree::OnPaint() 
{
	CPaintDC oDC(this);     // device context for painting
	CPen     oPen;
   CPen *   pOldPen;
   CBrush * pOldBrush;
   CRect    oDlgRect;

   oPen.CreatePen(PS_SOLID, 2, RGB(0, 0, 0));
   pOldPen = oDC.SelectObject(&oPen);
   pOldBrush = (CBrush *)oDC.SelectStockObject(NULL_BRUSH);
   GetClientRect(&oDlgRect);
   oDlgRect.DeflateRect(10, 10, 10, 10);
	oDC.Rectangle(&oDlgRect);
   oDC.SelectObject(pOldBrush);
	oPen.DeleteObject();
	
	// Do not call CDialog::OnPaint() for painting messages
}

void SMSplashPanelFree::OnCheckDontShow() 
{
   bool  fShowSplash;

   if( m_ckboxDontShow.GetCheck() )
   {
      fShowSplash = false;
   }
   else
   {
      fShowSplash = true;
   }
   m_poApp->SetShowFreewareSplash(fShowSplash);
}
