//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       SMVersion.cpp	[ SMVersion.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implements data container class SMVersion
//
//***************************************************************************

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_SERIAL(SMVersion, CObject, 1)

// ***************************************************************************
//
SMVersion::SMVersion() : m_iMajor(0), m_iMinor(0)
{
   CTime oCurrentDate(time(0));     // the current time in seconds

   m_oCreateDate = oCurrentDate;

   return;
}

// ***************************************************************************
// copy constructor
SMVersion::SMVersion(const SMVersion & version)
{
   m_iMajor = version.m_iMajor;
   m_iMinor = version.m_iMinor;
   m_oCreateDate = version.m_oCreateDate;

   return;
}

// ***************************************************************************
// assignment operator
SMVersion &
SMVersion::operator=(const SMVersion& version)
{
   if( &version != this )
   {
      m_iMajor = version.m_iMajor;
      m_iMinor = version.m_iMinor;
      m_oCreateDate = version.m_oCreateDate;
   }
   return *this;
}

// **************************************************************************
// return version as a text string
CString
SMVersion::Version() const
{
   CString  sVersion;

   sVersion.Format("%d.%d", m_iMajor, m_iMinor);

   return sVersion;
}

// ***************************************************************************
//
void
SMVersion::SetVersion(int major, int minor)
{
   m_iMajor = (short)major;
   m_iMinor = (short)minor;

   return;
}

// ***************************************************************************
//
CTime &
SMVersion::Date()
{
   return m_oCreateDate;
}

// ***************************************************************************
// returns TRUE if new version is newer than the version object's creation version
BOOL
SMVersion::IsOKVersion(int iTestMajor, int iTestMinor) const
{
   return (m_iMajor >= iTestMajor) and (m_iMinor >= iTestMinor);
}

// ***************************************************************************
//
void
SMVersion::Serialize(CArchive & ar)
{
   // first do the MFC classes and C++ types
	if( ar.IsStoring() )
	{
		ar << m_iMajor << m_iMinor << m_oCreateDate;
	}
	else
	{
		ar >> m_iMajor >> m_iMinor >> m_oCreateDate;
	}
   // then the metrics data objects
}
