#ifndef  SMVersion_H
#define	SMVersion_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       SMVersion.h	[ SMVersion.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Definition of data container class SMVersion
//
//***************************************************************************

class SMVersion : public CObject
{
   public:
      SMVersion();
      SMVersion(const SMVersion & cpt);               // copy constructor
      SMVersion & operator=(const SMVersion& ckpt);   // assignment operator
               
      virtual ~SMVersion()  {;}

      // virtual overrides
	   virtual void Serialize(CArchive& ar);

      // property access methods
      CString  Version() const;
      void     SetVersion(int major, int minor);
      CTime &  Date();
      BOOL     IsOKVersion(int major, int minor) const;

   private:
      short m_iMajor;        // major version number
      short m_iMinor;        // minor version number
      CTime m_oCreateDate;   // creation date

      DECLARE_SERIAL(SMVersion)
};
////////////////////////////////////////////////////////////////////////////////

#endif						// SMVersion_H
