//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       SourceMetrics.cpp	[ SourceMetrics.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   
//
//***************************************************************************

// SourceMetrics.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <locale.h>
#include "io.h"

#include "SourceMetrics.h"
#include "ChildFrame.h"
#include "SourceMetricsDoc.h"
#include "ProjectView.h"
#include "CheckpointView.h"
#include "FreqGraphView.h"
#include "HistGraphView.h"
#include "DibButton.h"
#include "OptionsPropertySheet.h"
#include "SMSplashPanel.h"
#include "SMSplashPanelFree.h"
#include "RegisterDlg.h"
#include "DisplayDetails.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSourceMetricsApp

BEGIN_MESSAGE_MAP(CSourceMetricsApp, CWinApp)
	//{{AFX_MSG_MAP(CSourceMetricsApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPTIONS, OnFileOptions)
	ON_COMMAND(ID_REGISTER_BTN, Register)
	ON_UPDATE_COMMAND_UI(ID_REGISTER_BTN, OnUpdateRegisterBtn)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

// compiled version of the program (from the VERSION resource)
short CSourceMetricsApp::m_iMajorVersion = 0;
short CSourceMetricsApp::m_iMinorVersion = 0;
CString CSourceMetricsApp::m_sVersion = "";;

// keys for options stored in the Windows registry
TCHAR * CSourceMetricsApp::OPTION_SETTINGS = _T("Settings\\");
TCHAR * CSourceMetricsApp::SOURCE_VIEWER = _T("SourceCodeViewer");
TCHAR * CSourceMetricsApp::REPORT_ERRORS = _T("ReportParserErrors");
TCHAR * CSourceMetricsApp::METRICS_LABELS_KEY = _T("ColumnLabels");
TCHAR * CSourceMetricsApp::PROJECT_VIEW_COLUMN_ORDER = _T("ProjectViewColumnOrder");
TCHAR * CSourceMetricsApp::CKPT_VIEW_COLUMN_ORDER = _T("CheckpointViewColumnOrder");
TCHAR * CSourceMetricsApp::LANGUAGE_EXTENSIONS = _T("Extensions");
TCHAR * CSourceMetricsApp::FREQ_GRAPH_METRIC = _T("FrequencyGraphMetric");
TCHAR * CSourceMetricsApp::FREQ_GRAPH_COLOR = _T("FrequencyGraphColor");
TCHAR * CSourceMetricsApp::HIST_GRAPH_METRIC = _T("HistoryGraphMetric");
TCHAR * CSourceMetricsApp::HIST_GRAPH_COLOR = _T("HistoryGraphColor");
TCHAR * CSourceMetricsApp::PRINT_MARGINS_KEY = _T("PrintMargins(TBLRC)");
TCHAR * CSourceMetricsApp::PRINT_FONT_KEY = _T("PrintFont(NameSizeStyle)");
TCHAR * CSourceMetricsApp::REGISTRATION_ID_KEY = _T("RegistrationID");

/////////////////////////////////////////////////////////////////////////////
// CSourceMetricsApp construction

CSourceMetricsApp::CSourceMetricsApp() : m_pAppMainFrame(NULL), m_fInitialized(false), m_fFreeVersion(true)
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSourceMetricsApp object

CSourceMetricsApp theApp;

// This identifier was generated to be statistically unique for your app.
// You may change it if you prefer to choose a specific identifier.

// {6B0F5080-66F9-11D0-B63D-00A0240C90F6}
static const CLSID clsid =
{ 0x6b0f5080, 0x66f9, 0x11d0, { 0xb6, 0x3d, 0x0, 0xa0, 0x24, 0xc, 0x90, 0xf6 } };

/////////////////////////////////////////////////////////////////////////////
// CSourceMetricsApp initialization

BOOL CSourceMetricsApp::InitInstance()
{
	CMultiDocTemplate *
            pDocTemplate;              // default template pointer
   CString  sExeName;
   TCHAR *  pcExeName;
   TCHAR *  poVersionInfo;             // GetFileVersionInfo fills buffer this points to
   DWORD    dwVersionBufferLength;     // size of version info
   DWORD    dwJunk;                    // needed for GetFileVersionInfo
   TCHAR *  poProductVersion;          // pointer to version info itself
   UINT     uiVersionLength;
   BOOL     fResult = TRUE;            // assume success

   // initialize the version numbers from our own version resource
   sExeName = m_pszExeName;
   sExeName += _T(".exe");
   pcExeName = sExeName.GetBuffer(sExeName.GetLength());
   dwVersionBufferLength = GetFileVersionInfoSize(pcExeName, &dwJunk);
   if( dwVersionBufferLength > 0 )
   {
      poVersionInfo = new TCHAR[dwVersionBufferLength];  // version string (format: N, N, N, N)
      if( (GetFileVersionInfo(pcExeName, 0, dwVersionBufferLength, poVersionInfo) != 0)
      and (VerQueryValue(poVersionInfo, _T("\\StringFileInfo\\040904B0\\ProductVersion"), (LPVOID *)&poProductVersion, &uiVersionLength) != 0)
      and (uiVersionLength > 0) )
      {
         CString  sVersion(poProductVersion);

         CSourceMetricsApp::m_sVersion = sVersion;
         CSourceMetricsApp::m_iMajorVersion = (short)atoi(sVersion);
         sVersion = sVersion.Mid(sVersion.Find(',') + 1);
         CSourceMetricsApp::m_iMinorVersion = (short)atoi(sVersion);
      }
      delete [] poVersionInfo;
   }
   // TODO: check the version of comctl32.dll
   sExeName.ReleaseBuffer();

	// Initialize OLE libraries
	if ( not AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
   AfxInitRichEdit();            // use a rich edit control in the source viewer
   _tsetlocale(LC_ALL, _T(""));  // initialize the current Windows locale as the app's locale

	// Standard initialization
#ifdef _AFXDLL
	Enable3dControls();			   // Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	   // Call this when linking to MFC statically
#endif
   SetRegistryKey("Campwood");
	LoadStdProfileSettings(10);   // Load standard INI file options (including MRU)

   // create a template for each view
	pDocTemplate = new CMultiDocTemplate(     // default "OnOpen" view (CProjectView)
		   IDR_PROJECT_VIEW,
		   RUNTIME_CLASS(CSourceMetricsDoc),
		   RUNTIME_CLASS(CChildFrame),
		   RUNTIME_CLASS(CProjectView));

	// Register the application's default document template.  Document templates
	//  serve as the connection between documents, frame windows and views.
	AddDocTemplate(pDocTemplate);

   // now create doc templates for each of the other unique views
   m_pCkpointTemplate = new CMultiDocTemplate(
         IDR_CHECKPOINT_VIEW,
		   RUNTIME_CLASS(CSourceMetricsDoc),
		   RUNTIME_CLASS(CChildFrame),
		   RUNTIME_CLASS(CCheckpointView));    // Checkpoint files view
	AddDocTemplate(m_pCkpointTemplate);
   m_pFreqGraphTemplate = new CMultiDocTemplate(
         IDR_GRAPH_VIEW,
		   RUNTIME_CLASS(CSourceMetricsDoc),
		   RUNTIME_CLASS(CChildFrame),
		   RUNTIME_CLASS(CFreqGraphView));     // Frequency graph view
	AddDocTemplate(m_pFreqGraphTemplate);
   m_pHistGraphTemplate = new CMultiDocTemplate(
         IDR_GRAPH_VIEW,
		   RUNTIME_CLASS(CSourceMetricsDoc),
		   RUNTIME_CLASS(CChildFrame),
		   RUNTIME_CLASS(CHistGraphView));     // History graph view
	AddDocTemplate(m_pHistGraphTemplate);

	// Connect the COleTemplateServer to the document template.
	//  The COleTemplateServer creates new documents on behalf
	//  of requesting OLE containers by using information
	//  specified in the document template.
	m_server.ConnectTemplate(clsid, pDocTemplate, FALSE);

	// Register all OLE server factories as running.  This enables the
	//  OLE libraries to create objects from other applications.
	// Note: MDI applications register all server objects without regard
	//  to the /Embedding or /Automation on the command line.
	COleTemplateServer::RegisterAll();

   // enable DDE execute style "Open"
   RegisterShellFileTypes();
   EnableShellOpen();

	// When a server application is launched stand-alone, it is a good idea
	//  to update the system registry in case it has been damaged.
	m_server.UpdateRegistry(OAT_DISPATCH_OBJECT);
	COleObjectFactory::UpdateRegistryAll();

	// Parse command line for special commands first, then if none, for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
   if( SpecialCommand() )
   {
      fResult = false;
   }
   else
   {
      ParseCommandLine(cmdInfo);
   }

	// Check to see if we need to show the user anything
	if( fResult and cmdInfo.m_bShowSplash and (cmdInfo.m_nShellCommand != CCommandLineInfo::AppUnregister) )
	{
	   // create main MDI Frame window (specify the style to remove FWS_ADDTOTITLE so filename isn't put in title
	   m_pAppMainFrame = new CMainFrame;
	   if( not m_pAppMainFrame->LoadFrame(IDR_MAINFRAME, WS_OVERLAPPEDWINDOW) )
      {
		   return FALSE;
      }
	   m_pMainWnd = m_pAppMainFrame;

		// Application was not run with /Embedding or /Automation. Show the main window in this case.
      // enable drag and drop open
      m_pMainWnd->DragAcceptFiles();

	   // The main window has been initialized, so show and update it.
	   m_pAppMainFrame->ShowWindow(m_nCmdShow);
	   m_pAppMainFrame->UpdateWindow();
      if( fResult )
      {
         m_fShowSplash = true;   // if not already shown and if not registered, display the splash panel
      }
      else
      {
         m_fShowSplash = false;
      }
   }
	// Dispatch commands specified on the command line (but cancel FileNew when no file specified)
   if( cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew )
   {
      cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
   }
	if( fResult and (not ProcessShellCommand(cmdInfo)) )
   {
      fResult = FALSE;
   }
   m_fInitialized = true;     // now ready to go
	return fResult;
}

// ***************************************************************************
// check for special command line parameters
bool
CSourceMetricsApp::SpecialCommand()
{
   CString  sCommandLine(m_lpCmdLine);
   CString  sTest(m_lpCmdLine);
   bool     fResult = false;           // assume no special command

	if( sCommandLine.GetLength() > 0 )
   {
      int      iTagOffset;
      TCHAR    cLanguage;
      CString  sFilePathname;

      sTest.MakeLower();
      iTagOffset = sTest.Find("/d");
      if( (iTagOffset >= 0) and ((sCommandLine.GetLength() - iTagOffset) > 2) )
      {
         cLanguage = sTest[iTagOffset + 2];
         iTagOffset = sCommandLine.Find(' ');
         sFilePathname = sCommandLine.Mid(iTagOffset);
         sFilePathname.TrimLeft();
         sFilePathname.TrimRight();
         if( (sFilePathname.GetLength() > 0) and (_taccess(sFilePathname, 4) == 0) and ShowSplashPanel() )
         {
            CDisplayDetails oDisplayDetails(cLanguage, sFilePathname);

            if( oDisplayDetails.Show(m_iMajorVersion, m_iMinorVersion) )
            {
               fResult = true;
            }
         }
      }
   }
   return fResult;
}

// ***************************************************************************
// show user the splash/nag window
bool
CSourceMetricsApp::ShowSplashPanel()
{
   bool  fResult = TRUE;
   m_iRegNumber =
         GetProfileInt(CSourceMetricsApp::OPTION_SETTINGS, CSourceMetricsApp::REGISTRATION_ID_KEY, -1);

   if( m_fFreeVersion )
   {
      if( m_iRegNumber < 0 )
      {
         SMSplashPanelFree oDlg(this, m_pMainWnd);
         int               iResult;

         m_fShowFreeSplash = true;              // assume user likes it <g>
         iResult = oDlg.DoModal();
         if( not m_fShowFreeSplash )         // turn off splash
         {
            WriteProfileInt(CSourceMetricsApp::OPTION_SETTINGS, CSourceMetricsApp::REGISTRATION_ID_KEY, 0);
         }
         if( iResult == ID_SMEXIT )
         {
            m_pMainWnd->DestroyWindow();
            m_pMainWnd = NULL;
            fResult = FALSE;                    // user wants to exit
         }
      }
   }
   else
   {
      if( m_iRegNumber == 0 )
      {
         // make it easy to reset the registration number in the registry
         m_iRegNumber = -1;
      }
      if( not IsRegistered() )
      {
         SMSplashPanel  oDlg(-m_iRegNumber, this, m_pMainWnd);
         int            iSplashResult = oDlg.DoModal();

         // show user the run count (returns IDCANCEL if user registers successfully, ID_SMEXIT to exit)
         if( iSplashResult != IDCANCEL )
         {
            m_iRegNumber = min(m_iRegNumber, -1);     // if user entered something, convert it to a use count
            WriteProfileInt(CSourceMetricsApp::OPTION_SETTINGS, CSourceMetricsApp::REGISTRATION_ID_KEY,
                              CSourceMetricsApp::m_iRegNumber - 1);
            if( iSplashResult == ID_SMEXIT )
            {
               m_pMainWnd->DestroyWindow();
               m_pMainWnd = NULL;
               fResult = FALSE;     // user wants to exit
            }
         }
      }
   }
   return fResult;
}

// ***************************************************************************
// let user enter a registration ID
void
CSourceMetricsApp::Register() 
{
   CRegisterDlg   oDlg;
   
   if( m_fFreeVersion )
   {
      // toggle the splash state
      bool  fShowSplash = not ShowFreewareSplash();

      SetShowFreewareSplash(fShowSplash);
      WriteProfileInt(CSourceMetricsApp::OPTION_SETTINGS,
                            CSourceMetricsApp::REGISTRATION_ID_KEY, -(int)fShowSplash);
   }
   else if( oDlg.DoModal() == IDOK )
   {
      CString  sRegNo = oDlg.GetRegistrationNo();
      int      iRegNo = atoi(sRegNo);
      CString  sCaption;
      CString  sMsg;

      // test for a valid registration number
      sCaption.LoadString(IDS_REG_NUMBER_CAPTION);
      if( IsRegistered(iRegNo) )
      {
         // number is valid: store it in the Windows registry
         if( WriteProfileInt(CSourceMetricsApp::OPTION_SETTINGS, CSourceMetricsApp::REGISTRATION_ID_KEY, iRegNo) )
         {
            SetRegistrationID(iRegNo);
            sMsg.LoadString(IDS_REG_NUMBER_SUCCESS);
            m_pMainWnd->MessageBox(sMsg, sCaption, MB_ICONINFORMATION | MB_OK);
         }
         else
         {
            sMsg.LoadString(IDS_REG_WRITE_ERROR);
            m_pMainWnd->MessageBox(sMsg, sCaption, MB_ICONINFORMATION | MB_OK);
         }
      }
      else
      {
         sCaption.LoadString(IDS_REG_NUMBER_CAPTION);
         sMsg.LoadString(IDS_REG_NUMBER_ERROR);

         m_pMainWnd->MessageBox(sMsg, sCaption, MB_ICONERROR | MB_OK);
      }
   }
}

// ***************************************************************************
// check to see if the registration ID is valid
bool
CSourceMetricsApp::IsRegistered(int iRegNo) const
{
   CString  sRegNo;
   bool     fResult = false;     // assume it's invalid

   // test for a valid registration number
   sRegNo.Format("%d", iRegNo);
   if( (sRegNo.GetLength() == 8)
   and ( sRegNo[1] != sRegNo[2] )
   and ( sRegNo[4] != sRegNo[7] )
   and ( sRegNo[5] != sRegNo[6] )
   and ((sRegNo[1] + sRegNo[2] + sRegNo[4] + sRegNo[5] + sRegNo[6] + sRegNo[7]) == '5' * 6 )
   and (sRegNo[0] == ('0' + m_iMajorVersion))   // first digit must equal major version number
   and (iRegNo > 0 ) )
   {
      fResult = true;
   }
   return fResult;
}

// ***************************************************************************
// read from the ini/registry and parse a token separated string into individual strings
BOOL
CSourceMetricsApp::GetProfileStringList(LPCTSTR lpszSection, LPCTSTR lpszEntry,
                                        CStringArray & saStrings, CString sToken,
                                        CString sDefaultExtensions)
{
   CString  sSeparatedString = GetProfileString(lpszSection, lpszEntry, sDefaultExtensions);
   int      iTokenOffset;
   BOOL     fResult = FALSE;        // assume failure

   if( sSeparatedString.GetLength() > 0 )    // must have at least one entry
   {
      int      i = 0;      // string array index
      CString  sItem;      // list string

      while( (iTokenOffset = sSeparatedString.FindOneOf(sToken)) >= 0 )
      {
         sItem = sSeparatedString.Left(iTokenOffset);         // extract next string
         if( i < saStrings.GetSize() )
         {
            saStrings[i] = sItem;
         }
         else
         {
            saStrings.Add(sItem);
         }
         sSeparatedString = sSeparatedString.Mid(iTokenOffset + 1);  // remove it from source
         ++i;
      }
      if( not sSeparatedString.IsEmpty() )
      {
         // include the segment following last token
         if( i < saStrings.GetSize() )
         {
            saStrings[i] = sSeparatedString;
         }
         else
         {
            saStrings.Add(sSeparatedString);
         }
      }
      fResult = TRUE;
   }
   return fResult;
}

// ***************************************************************************
// build a token separated string from a string list and write to the ini/registry
BOOL
CSourceMetricsApp::WriteProfileStringList(LPCTSTR lpszSection, LPCTSTR lpszEntry,
                                          CStringArray & saStrings, CString sToken)
{
   CString  sSeparatedString;
   int      iStringCount = saStrings.GetSize();

   for( int i = 0; i < iStringCount; ++i )
   {
      sSeparatedString += saStrings[i];
      sSeparatedString += sToken;
   }
   return WriteProfileString(lpszSection, lpszEntry, sSeparatedString);
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_sVersion;
	CString	m_sRegistrationNumber;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
   CDibButton  m_DibLogo;

	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
   CString  sVersion(CSourceMetricsApp::m_sVersion);
   CSourceMetricsApp *  poApp = dynamic_cast<CSourceMetricsApp *>(AfxGetApp());

   m_DibLogo.LoadDib(IDB_CAMPWOOD_LOGO, true);

	//{{AFX_DATA_INIT(CAboutDlg)
	m_sVersion = _T("");
	m_sRegistrationNumber = _T("");
	//}}AFX_DATA_INIT

   sVersion.Replace(", ", ".");
   m_sVersion.Format("Version %s   [Built at %s on %s]", sVersion, __TIME__, __DATE__ );
   if( poApp->IsFreeVersion() )
   {
      m_sRegistrationNumber = "";
   }
   else
   {
      if( poApp->IsRegistered() )
      {
         m_sRegistrationNumber.Format("Registration ID = %d", poApp->GetRegistrationID());
      }
      else
      {
         m_sRegistrationNumber = _T("Registration ID = <Unregistered Copy>");
      }
   }
   return;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_ABOUT_VERSION, m_sVersion);
	DDX_Text(pDX, IDC_ABOUT_SERIAL_NUMBER, m_sRegistrationNumber);
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
   if( not m_DibLogo.SubclassDlgItem(IDC_LOGO_PICTURE, this) )
   {
      EndDialog(IDCANCEL);
      return FALSE;
   }
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CSourceMetricsApp commands

// App command to run the dialog
void CSourceMetricsApp::OnAppAbout()
{
	CAboutDlg aboutDlg;

   aboutDlg.DoModal();
}

void CSourceMetricsApp::OnFileOptions() 
{
   COptionsPropertySheet oPropertyDlg(IDS_OPTIONS_CAPTION, AfxGetMainWnd());

   oPropertyDlg.DoModal();

   // cancel context help set in dialog
   m_pAppMainFrame->m_dwPromptContext = 0;
}

int CSourceMetricsApp::ExitInstance() 
{
	return CWinApp::ExitInstance();
}

void CSourceMetricsApp::WinHelp(DWORD dwData, UINT nCmd) 
{
   CString  sStatusMessage;
   int      iHelpID = dwData bitand 0xFFFF;  // control or menu item ID is in lower 16 bits

#if _DEBUG
   if( m_pAppMainFrame != NULL )
   {
      CStatusBar *   poStatusBar = &m_pAppMainFrame->m_wndStatusBar;

      // post the number until the help IDs have all been debugged
      sStatusMessage.Format("Help request ID: %d; Help Command: %d", iHelpID, nCmd);
      poStatusBar->SetPaneText(0, sStatusMessage);
   }
#endif
   if( m_fFreeVersion and (iHelpID == ID_REGISTER_BTN) )
   {
      iHelpID = ID_ABOUT_FREEWARE;
   }	
	CWinApp::WinHelp(iHelpID, nCmd);
}

CDocument* CSourceMetricsApp::OpenDocumentFile(LPCTSTR lpszFileName) 
{
   CDocument * poDoc = CWinApp::OpenDocumentFile(lpszFileName);
   m_pAppMainFrame->MDICascade();        // TODO: find out why MDI child frame doesn't go to upper left

   return poDoc;
}

void CSourceMetricsApp::OnUpdateRegisterBtn(CCmdUI* pCmdUI) 
{
   if( m_fFreeVersion )
   {
      UINT  iCheckFlag;

      pCmdUI->SetText("Show Splash Panel");
	   pCmdUI->Enable(true);
      if( (pCmdUI->m_pMenu != NULL) and (pCmdUI->m_pMenu->m_hMenu != NULL) )
      {
         if( ShowFreewareSplash() )
         {
            iCheckFlag = MF_CHECKED;
         }
         else
         {
            iCheckFlag = MF_UNCHECKED;
         }
         pCmdUI->m_pMenu->CheckMenuItem(ID_REGISTER_BTN, MF_BYCOMMAND bitor iCheckFlag);
      }
   }
   else
   {
	   pCmdUI->Enable(not IsRegistered());
   }
}

BOOL CSourceMetricsApp::OnIdle(LONG lCount) 
{
	// show splash panel once if appropriate
   if( m_fShowSplash )
   {
      ShowSplashPanel();
      m_fShowSplash = false;
   }	
	return CWinApp::OnIdle(lCount);
}

