#ifndef  SourceMetrics_H
#define	SourceMetrics_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       SourceMetrics.h	[ SourceMetrics.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Main header file for the SourceMonitor application
//
//***************************************************************************

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"         // main symbols

class CSourceMetricsApp : public CWinApp
{
public:
	CSourceMetricsApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSourceMetricsApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	virtual void WinHelp(DWORD dwData, UINT nCmd = HELP_CONTEXT);
	virtual CDocument* OpenDocumentFile(LPCTSTR lpszFileName);
	virtual BOOL OnIdle(LONG lCount);
	//}}AFX_VIRTUAL

// Implementation
   enum PRINT_MARGINS { TOP_MARGIN, BOTTOM_MARGIN, LEFT_MARGIN, RIGHT_MARGIN, INTERCOLUMN_MARGIN };
   enum PRINT_FONT { FONT_NAME, FONT_SIZE, FONT_STYLE };
	COleTemplateServer   m_server;
   CDocTemplate *       m_pCkpointTemplate;
   CDocTemplate *       m_pFreqGraphTemplate;
   CDocTemplate *       m_pHistGraphTemplate;
   CMainFrame *         m_pAppMainFrame;
   static short         m_iMajorVersion;     // compiled version of the program
   static short         m_iMinorVersion;
   static CString       m_sVersion;          // full version string from resource (diplayed in About box)

   bool  IsRegistered() const             { return IsRegistered(m_iRegNumber); }
   bool  IsRegistered(int regno) const;
   void  Register();
   int   GetRegistrationID() const        { return m_iRegNumber; }
   void  SetRegistrationID(int regno)     { m_iRegNumber = regno; }
   bool  IsInitialized()                  { return m_fInitialized; }
   bool  ShowFreewareSplash()             { return m_fShowFreeSplash; }
   void  SetShowFreewareSplash(bool show) { m_fShowFreeSplash = show; }
   bool  IsFreeVersion()                  { return m_fFreeVersion; }

   BOOL  GetProfileStringList(LPCTSTR lpszSection, LPCTSTR lpszEntry, CStringArray & saStrings,
                              CString sToken, CString sDefaultExtensions);
   BOOL  WriteProfileStringList(LPCTSTR lpszSection, LPCTSTR lpszEntry,
                              CStringArray & saStrings, CString sToken);
   static TCHAR * OPTION_SETTINGS;           // key for all options
   static TCHAR * SOURCE_VIEWER;             // command line that calls source code viewer program
   static TCHAR * REPORT_ERRORS;             // integer flag: 0 if user doesn't want to see parser error reports
   static TCHAR * METRICS_LABELS_KEY;        // ini/registry settings subkey for language labels
   static TCHAR * PROJECT_VIEW_COLUMN_ORDER; // subkey for project view display column order
   static TCHAR * CKPT_VIEW_COLUMN_ORDER;    // subkey for checkpoint view display column order
   static TCHAR * LANGUAGE_EXTENSIONS;       // subkey for language file extensions filter
   static TCHAR * FREQ_GRAPH_METRIC;         // subkey for name of the metric to plot in frequency graph
   static TCHAR * FREQ_GRAPH_COLOR;          // subkey for color to use for bars in frequency graph
   static TCHAR * HIST_GRAPH_METRIC;         // subkey for name of the metric to plot in history graph
   static TCHAR * HIST_GRAPH_COLOR;          // subkey for color to use for bars in history graph
   static TCHAR * PRINT_MARGINS_KEY;         // print margins (top, bottom, left, right, intercolumn)
   static TCHAR * PRINT_FONT_KEY;            // print font data (face name, size in points, style)
   static TCHAR * REGISTRATION_ID_KEY;       // ID number of registered copy of the program

	//{{AFX_MSG(CSourceMetricsApp)
	afx_msg void OnAppAbout();
	afx_msg void OnFileOptions();
	afx_msg void OnUpdateRegisterBtn(CCmdUI* pCmdUI);
	//}}AFX_MSG
   afx_msg void  OnShowSplash();
   DECLARE_MESSAGE_MAP()

private:
   int         m_iRegNumber;                 // number of times unregistered program has run if not registered
   bool        m_fShowSplash;
   bool        m_fInitialized;
   bool        m_fShowFreeSplash;
   bool        m_fFreeVersion;
   bool        ShowSplashPanel();
   bool        SpecialCommand();
};

/////////////////////////////////////////////////////////////////////////////
#endif						// SourceMetrics_H
      
