//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       SourceMetricsDoc.cpp	[ SourceMetricsDoc.h ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Implementation of the CSourceMetricsDoc class
//
//***************************************************************************

#include "stdafx.h"
#include "SourceMetrics.h"
#include "SourceMetricsDoc.h"
#include "NewProjectWizard.h"
#include "SMCpp.h"
#include "SMVisualBasic.h"
#include "SMJava.h"
#include "SMHTML.h"
#include "SMDelphi.h"
#include "CreateCheckpointDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning( disable: 4245)

/////////////////////////////////////////////////////////////////////////////
// CSourceMetricsDoc

IMPLEMENT_DYNCREATE(CSourceMetricsDoc, CDocument)

BEGIN_MESSAGE_MAP(CSourceMetricsDoc, CDocument)
	//{{AFX_MSG_MAP(CSourceMetricsDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CSourceMetricsDoc, CDocument)
	//{{AFX_DISPATCH_MAP(CSourceMetricsDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//      DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_ISource to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {6B0F5082-66F9-11D0-B63D-00A0240C90F6}
static const IID IID_ISource =
{ 0x6b0f5082, 0x66f9, 0x11d0, { 0xb6, 0x3d, 0x0, 0xa0, 0x24, 0xc, 0x90, 0xf6 } };

BEGIN_INTERFACE_MAP(CSourceMetricsDoc, CDocument)
	INTERFACE_PART(CSourceMetricsDoc, IID_ISource, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSourceMetricsDoc construction/destruction

CSourceMetricsDoc::CSourceMetricsDoc()
   : m_iCurrentCheckpoint(-1), m_iPageHeight(14400), m_iPageWidth(11520), m_sProjectName(""), m_sProjectDirectory("")

{
	EnableAutomation();
	AfxOleLockApp();
   m_oViewMap.InitHashTable(7);
   m_iMargins.SetSize(5);
}

CSourceMetricsDoc::~CSourceMetricsDoc()
{
	AfxOleUnlockApp();
}

BOOL CSourceMetricsDoc::OnNewDocument()
{
   CSourceMetricsApp *
                  poApp = dynamic_cast<CSourceMetricsApp *>(AfxGetApp());
   BOOL fResult = FALSE;   // assume failure

	if( CDocument::OnNewDocument() )
   {
      CNewProjectWizard wizard(IDS_NEW_PROJ_WIZ_CAPTION, AfxGetMainWnd());

      wizard.SetWizardMode();
      wizard.SetProjectName(m_sProjectName);
      wizard.SetProjectDir(m_sProjectDirectory);
      m_sProjectName = "";                   // clear for next time
      m_sProjectDirectory = "";
      if( wizard.DoModal() != IDCANCEL )
      {
         CString        sPathName;
         SMLanguage *   poLanguage;
         CFile          oRWTestFile;
         CFileException oFileException;      // dummy for file create test

         if( wizard.m_sProjectDirectory.Right(1) != _T("\\") )
         {
            wizard.m_sProjectDirectory += _T("\\");
         }
         sPathName = wizard.m_sProjectDirectory + wizard.m_sProjectName + _T(".smp");
         SetPathName(sPathName, TRUE);
         m_oProject.SetVersion(CSourceMetricsApp::m_iMajorVersion, CSourceMetricsApp::m_iMinorVersion);
         m_oProject.Name(wizard.m_sProjectName);
         m_oProject.Directory(wizard.m_sProjectDirectory);
         m_oProject.IncludeSubdirectories(wizard.m_fIncludeSubdirectories);
         switch( wizard.m_iLanguageID )
         {
         case IDC_LANGUAGE_CPP:
            poLanguage = new SMCpp(Exemplar());
            break;
         case IDC_LANGUAGE_VB:
            poLanguage = new SMVisualBasic(Exemplar());
            break;
         case IDC_LANGUAGE_PASCAL:
            poLanguage = new SMDelphi(Exemplar());
            break;
         case IDC_LANGUAGE_JAVA:
            poLanguage = new SMJava(Exemplar());
            break;
         case IDC_LANGUAGE_HTML:
            poLanguage = new SMHTML(Exemplar());
            break;
         default:
            // language not implemented
            ASSERT(FALSE);
         }
         m_oProject.SetLanguage(poLanguage);

         // now create a new checkpoint if that's what the user wants
         if( wizard.m_fCreateCheckpoint )
         {
            CStringList oCkptFiles;       // containers for new checkpoint file lists
            CStringList oOtherFiles;

            AfxGetMainWnd()->BeginWaitCursor(); 
            if( m_oProject.GetNewCheckpointFiles(oCkptFiles, oOtherFiles) )
            {
               CCreateCheckpointDlg oDlg(AfxGetMainWnd(), oCkptFiles, oOtherFiles);
               CString              sSection(CSourceMetricsApp::OPTION_SETTINGS);

               sSection += poLanguage->Name();
               oDlg.m_sName = wizard.m_sCheckpointName;
               oDlg.m_sFilter = poApp->GetProfileString(sSection, CSourceMetricsApp::LANGUAGE_EXTENSIONS,
                                                         poLanguage->DefaultExtensions());
               if( oDlg.DoModal() == IDOK )
               {
	               m_oProject.CreateCheckpoint(oDlg.m_sName, oCkptFiles, AfxGetMainWnd());
               }
            }
            AfxGetMainWnd()->EndWaitCursor(); 
         }
         OnSaveDocument(sPathName);
         fResult = TRUE;
      }
      poApp->m_pAppMainFrame->MDICascade();  // TODO: find out why MDI child frame doesn't go to upper left

      // cancel context help set in dialog
      poApp->m_pAppMainFrame->m_dwPromptContext = 0;
   }
	return fResult;
}

void CSourceMetricsDoc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDocument::DeleteContents();
}

/////////////////////////////////////////////////////////////////////////////
// CSourceMetricsDoc diagnostics

#ifdef _DEBUG
void CSourceMetricsDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSourceMetricsDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

// **************************************************************************
// CSourceMetricsDoc commands

// **************************************************************************
// Set selected checkpoint based on checkpoint list index
//
void
CSourceMetricsDoc::SetView(long key)
{
   SMCheckpoint   oCkpt;

   if( m_oProject.GetCheckpointByIndex(m_iCurrentCheckpoint, oCkpt) )
   {
      m_oViewMap.SetAt(key, m_iCurrentCheckpoint);
   }
}

// **************************************************************************
// Remove checkpoint from the list of views open on its behalf
//
void
CSourceMetricsDoc::UnsetView(long key)
{
   m_oViewMap.RemoveKey(key);
}

// **************************************************************************
// Check to see if at least one view is open for a checkpoint with a given index
//
bool
CSourceMetricsDoc::IsView(int index) const
{
   POSITION oPosition;
   long     lKey;             // containers for map contents
   long     lValue;
   bool     fResult = false;  // assume failure

   oPosition = m_oViewMap.GetStartPosition();
   while( oPosition != NULL )
   {
      m_oViewMap.GetNextAssoc(oPosition, lKey, lValue);
      if( lValue == index )
      {
         fResult = true;
         break;
      }
   }
   return fResult;
}

// **************************************************************************
// Close all current views for checkpoint with a given index
//
void
CSourceMetricsDoc::CloseViews(int index)
{
   POSITION oMapPosition;
   ViewMap  oViewMap;   // make a copy 'cause closing views delete themselves
   long     lKey;       // containers for map contents
   long     lValue;

   // first make a copy of the map
   oMapPosition = m_oViewMap.GetStartPosition();
   while( oMapPosition != NULL )
   {
      m_oViewMap.GetNextAssoc(oMapPosition, lKey, lValue);
      oViewMap.SetAt(lKey, lValue);
   }
   // now it's safe to close the windows
   oMapPosition = oViewMap.GetStartPosition();
   while( oMapPosition != NULL )
   {
      oViewMap.GetNextAssoc(oMapPosition, lKey, lValue);
      if( lValue == index )
      {
         // find the view with the mapped handle
         POSITION oViewPosition = GetFirstViewPosition();
         CView *  poView;

         while( oViewPosition != NULL )
         {
            poView = GetNextView(oViewPosition);
            if( poView->m_hWnd == (HWND)lKey )
            {
               CDocument::RemoveView(poView);
               poView->GetParentFrame()->SendMessage(WM_CLOSE, 0, 0);
               break;               // only one view will have the target handle
            }
         }
      }
   }
}

//////////////////////////////////////////////////////////////////////////////////////
// Print view helper methods

// ***********************************************************************************
// set margin and font options
//
void
CSourceMetricsDoc::SetPrintOptions(CDC * pDC)
{
   int            i;                // loop index
   CSourceMetricsApp *
                  poApp = dynamic_cast<CSourceMetricsApp *>(AfxGetApp());
   CStringArray   saMargins;
   CStringArray   saFontData;
   CString        sFontStyle;
   int            iXOffset;         // printer offset from edge of page to where it can actually print
   int            iYOffset;         // printer offset from edge of page to where it can actually print

   saMargins.SetSize(5);            // 5 margins: Top, Bottom, Left, Right, Intercolumn
   saFontData.SetSize(3);           // 3 font items: Face Name, Size (points), Style

   for( i = 0; i < 4; ++i )
   {
      saMargins[i] = _T("0.5");     // set defaults for 4 edge margins
   }
   // set intercolumn margin default
   saMargins[CSourceMetricsApp::INTERCOLUMN_MARGIN] = _T("0.1");
   poApp->GetProfileStringList(CSourceMetricsApp::OPTION_SETTINGS, CSourceMetricsApp::PRINT_MARGINS_KEY,
                                  saMargins, CString(_T(",;")), CString(_T("")));
   for( i = 0; i < 5; ++i )
   {
      m_iMargins[i] = (int)(atof(saMargins[i]) * 10.0) * 144;     // convert to twips
   }
   // subtract the physically unprintable margins
   iXOffset = (int)((float(pDC->GetDeviceCaps(PHYSICALOFFSETX)) / float(pDC->GetDeviceCaps(LOGPIXELSX))) * 1440);
   iYOffset = (int)((float(pDC->GetDeviceCaps(PHYSICALOFFSETY)) / float(pDC->GetDeviceCaps(LOGPIXELSY))) * 1440);
   AdjustOffset(m_iMargins[CSourceMetricsApp::TOP_MARGIN], iYOffset);
   AdjustOffset(m_iMargins[CSourceMetricsApp::BOTTOM_MARGIN], iYOffset);
   AdjustOffset(m_iMargins[CSourceMetricsApp::LEFT_MARGIN], iXOffset);
   AdjustOffset(m_iMargins[CSourceMetricsApp::RIGHT_MARGIN], iXOffset);

   // specify default font
   saFontData[CSourceMetricsApp::FONT_NAME] = _T("Arial");
   saFontData[CSourceMetricsApp::FONT_SIZE] = _T("10");
   saFontData[CSourceMetricsApp::FONT_STYLE] = _T("Regular");
   poApp->GetProfileStringList(CSourceMetricsApp::OPTION_SETTINGS, CSourceMetricsApp::PRINT_FONT_KEY,
                                  saFontData, CString(_T(",;")), CString(_T("")));
   m_sFontName = saFontData[CSourceMetricsApp::FONT_NAME];
   m_iFontTwips = (int)(atof(saFontData[CSourceMetricsApp::FONT_SIZE]) * 20.0);  // 20 times height in points
   sFontStyle = saFontData[CSourceMetricsApp::FONT_STYLE];
   if( sFontStyle.Find(_T("Italic")) >= 0 )
   {
      m_bFontItalic = TRUE;
   }
   else
   {
      m_bFontItalic = FALSE;
   }
   // set regular as the default weight
   m_iFontWeight = FW_REGULAR;
   if( sFontStyle.Find(_T("Bold")) >= 0 )
   {
      m_iFontWeight = FW_BOLD;
   }
   else if( sFontStyle.Find(_T("Thin")) >= 0 )
   {
      m_iFontWeight = FW_THIN;
   }
   else if( sFontStyle.Find(_T("Light")) >= 0 )
   {
      m_iFontWeight = FW_LIGHT;
   }
   else if( sFontStyle.Find(_T("Medium")) >= 0 )
   {
      m_iFontWeight = FW_MEDIUM;
   }
   else if( sFontStyle.Find(_T("Heavy")) >= 0 )
   {
      m_iFontWeight = FW_HEAVY;
   }
}

// ***********************************************************************************
// adjust margin for printer's physical non-printing border
//
void
CSourceMetricsDoc::AdjustOffset(DWORD & dwPageMargin, int iOffset)
{
   int   iMargin;          // scratch to simplify max call

   iMargin = dwPageMargin - iOffset;
   dwPageMargin = max(iMargin, 0);
}

// ***********************************************************************************
// print page header
// return number of lines printed after the top margin
//
void
CSourceMetricsDoc::PrintPageHeader(CDC * pDC)
{
   int      iFirstColumn = GetPrintStartCol();
   int      iColumnLimit = GetPrintLimitCol(iFirstColumn);
   int      iColWidth;
   CSize    oTextSize;
   int      iCurrentX = m_iMargins[CSourceMetricsApp::LEFT_MARGIN];
   int      iCurrentY = - (int)m_iMargins[CSourceMetricsApp::TOP_MARGIN];
   int      iBorderOffset = m_iLineHeight + m_iLineHeight / 4;
   CString  sHeader;
   CPen     oPen(PS_SOLID, m_iLineHeight / 10, RGB(0, 0, 0));
   CPen *   poOldPen;

   // print top of page line
   pDC->TextOut(iCurrentX, iCurrentY, m_saPageHeaders[m_iPrintColumns]);
   iCurrentY -= m_iLineHeight * 2;    // move down two lines
   poOldPen = pDC->SelectObject(&oPen);

   // now do the data column headers, one at a time
   pDC->TextOut(iCurrentX, iCurrentY, m_saPageHeaders[0]);
   iColWidth = m_iaColumnWidths[0];
   pDC->MoveTo(iCurrentX, iCurrentY - iBorderOffset);
   iCurrentX += iColWidth;
   pDC->LineTo(iCurrentX - m_iMargins[CSourceMetricsApp::INTERCOLUMN_MARGIN], iCurrentY - iBorderOffset);
   for( int m = iFirstColumn; m < iColumnLimit; ++m )
   {
      int   iTextOffset;   // offset needed to right justify text in its column

      iColWidth = m_iaColumnWidths[m];
      sHeader = m_saPageHeaders[m];
      oTextSize = pDC->GetTextExtent(sHeader);
      if( oTextSize.cx < iColWidth )
      {
         iTextOffset = iColWidth - m_iMargins[CSourceMetricsApp::INTERCOLUMN_MARGIN] - oTextSize.cx;
      }
      else
      {
         iTextOffset = 0;
      }
      pDC->TextOut(iCurrentX + iTextOffset, iCurrentY, sHeader);
      pDC->MoveTo(iCurrentX + iTextOffset, iCurrentY - iBorderOffset);
      iCurrentX += iColWidth;
      pDC->LineTo(iCurrentX - m_iMargins[CSourceMetricsApp::INTERCOLUMN_MARGIN], iCurrentY - iBorderOffset);
   }
   pDC->SelectObject(poOldPen);
}

// ***********************************************************************************
// print page footer
void
CSourceMetricsDoc::PrintPageFooter(CDC *pDC)
{
   CString  sFooterLine;
   CString  sFooterFormat;
   int      iFooterY;         // vertical offset to footer text

   sFooterFormat.LoadString(IDS_PRINT_FOOTER_FORMAT);
   sFooterLine.Format(sFooterFormat, m_iCurrentPage, m_iLastPage);
   iFooterY = - m_iFooterHeight - (FOOTER_LINES - 1) * m_iLineHeight;
   pDC->TextOut((m_iPageWidth - (pDC->GetTextExtent(sFooterLine)).cx) / 2, iFooterY, sFooterLine);
}

// ***********************************************************************************
// get first print column for current page
int
CSourceMetricsDoc::GetPrintStartCol()
{
   int   iColumnCountIndex = (m_iCurrentPage - 1) % m_iPagesPerCkpt;
   int   iResult = 1;         // always have that one repeating column on the left

   if( iColumnCountIndex != 0 )
   {
      for( int i = 0; i < iColumnCountIndex; ++i )
      {
         iResult += m_iaPageColumns[i] - 1;
      }
   }
   return iResult;
}

// ***********************************************************************************
// get print column limit for current page
int
CSourceMetricsDoc::GetPrintLimitCol(int iFirstColumn)
{
   int   iColumnCountIndex = (m_iCurrentPage - 1) % m_iPagesPerCkpt;

   return m_iaPageColumns[iColumnCountIndex] + iFirstColumn - 1;
}

// ***********************************************************************************
// prepare the headers and such for printing a view
void
CSourceMetricsDoc::BeginPrinting(CDC *       pDC,
                                 CPrintInfo* pInfo,
                                 CListCtrl * poListCtrl,
                                 int         iColumns,
                                 CString &   sTitle)
{
   int         i;                   // loop index (reused)
   CTime       oDate(CTime::GetCurrentTime());
   CString     sPrintedOn;
   CString     sHeaderLine;
   int         iMaxItem;            // length in twips of longest item in 0th column of control
   int         iLeftColumnIndex;
   CDWordArray iaColumnOrder;       // raw order numbers as read from the header control
   int         iPageWidthUsed;
   int         iPrintWidth;
   int         iPageColumns;        // columns per page
   LV_COLUMN   oColumnData;
   CString     sColumnHeader;
   CDWordArray iaHeaderOrder;       // inversion of m_iaColumnOrder used to set headers
   CString     sItemHeader;
   CSize       oPrintSize;
   CPoint      oColumnWidthPoint(0, 0);
   TEXTMETRIC  oTextMetrics;
   float       floatScaleFactor;
   CFont *     poOldFont;           // save old font while printing

   SetPrintOptions(pDC);
   m_poListCtrl = poListCtrl;
   m_iListItems = m_poListCtrl->GetItemCount();
   m_iPrintColumns = iColumns;
   m_poPrintFont = new CFont;
   pDC->SetMapMode(MM_TWIPS);
   m_iPageWidth = (int)((float(pDC->GetDeviceCaps(HORZRES)) / float(pDC->GetDeviceCaps(LOGPIXELSX))) * 1440);
   m_iPageHeight = (int)((float(pDC->GetDeviceCaps(VERTRES)) / float(pDC->GetDeviceCaps(LOGPIXELSY))) * 1440);
   iPrintWidth = m_iPageWidth - m_iMargins[CSourceMetricsApp::LEFT_MARGIN]
                              - m_iMargins[CSourceMetricsApp::RIGHT_MARGIN]
                              + m_iMargins[CSourceMetricsApp::INTERCOLUMN_MARGIN];
   m_poPrintFont->CreateFont(-m_iFontTwips,
                     0, 0, 0,                               // default width, slant and tilt
                     m_iFontWeight,
                     m_bFontItalic, FALSE,                  // never underlined
                     FALSE,                                 // no strikethrough
                     ANSI_CHARSET,                          // name uses ansi characters
                     OUT_DEFAULT_PRECIS,                    // get best font match available
                     CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
                     DEFAULT_PITCH bitor FF_DONTCARE,
                     m_sFontName);
   poOldFont = pDC->SelectObject(m_poPrintFont);

   // build the strings printed at the top of each page
   m_saPageHeaders.SetSize(m_iPrintColumns + 1);       // use last string for the page header
   m_iaColumnWidths.SetSize(m_iPrintColumns);
   sPrintedOn.LoadString(IDS_PRINT_ON_DATE);
   sHeaderLine.Format("%s (%s %s)", sTitle, sPrintedOn, oDate.Format("%d %b %Y"));
   m_saPageHeaders.SetAt(m_iPrintColumns, sHeaderLine); // last item is the common top line on every page

   // get the current user's column arrangement and build a table of column headers
   m_iaColumnOrder.SetSize(m_iPrintColumns);
   m_poListCtrl->SendMessage(LVM_GETCOLUMNORDERARRAY, (WPARAM)m_iPrintColumns, (LPARAM)m_iaColumnOrder.GetData());

   // create inverted order list for storage of headers and build table of column widths
   iaHeaderOrder.SetSize(m_iPrintColumns);
   for( i = 0; i < m_iPrintColumns; ++i )
   {
      iaHeaderOrder[m_iaColumnOrder[i]] = i;
   }
   iLeftColumnIndex = iaHeaderOrder[0];

   // set fixed left column column header first
   oColumnData.mask = LVCF_TEXT;
   oColumnData.pszText = sColumnHeader.GetBuffer(1024);
   oColumnData.cchTextMax = 1023;
   m_poListCtrl->GetColumn(iLeftColumnIndex, &oColumnData);
   sColumnHeader.ReleaseBuffer();
   m_saPageHeaders.SetAt(iLeftColumnIndex, sColumnHeader);
   oPrintSize = pDC->GetTextExtent(sColumnHeader);

   // compute the screen to printed page scaling factor
   iMaxItem = oPrintSize.cx;        // start with the column's label width
   for( i = 0; i < m_iListItems; ++i )
   {
      sItemHeader = m_poListCtrl->GetItemText(i, iLeftColumnIndex);
      oPrintSize = pDC->GetTextExtent(sItemHeader);
      iMaxItem = max(iMaxItem, oPrintSize.cx);
   }
   oColumnWidthPoint.x = m_poListCtrl->GetColumnWidth(iLeftColumnIndex);
   pDC->DPtoLP(&oColumnWidthPoint);
   floatScaleFactor = float(iMaxItem) / float(oColumnWidthPoint.x);

   // build table of column labels and widths
   iaHeaderOrder.SetSize(m_iPrintColumns);
   oColumnData.pszText = sColumnHeader.GetBuffer(1024);
   for( i = 0; i < m_iPrintColumns; ++i )
   {
      int   iColumnIndex = iaHeaderOrder[i];

      m_poListCtrl->GetColumn(i, &oColumnData);
      m_saPageHeaders.SetAt(iColumnIndex, oColumnData.pszText);
      oColumnWidthPoint.x = m_poListCtrl->GetColumnWidth(i);
      pDC->DPtoLP(&oColumnWidthPoint);
      m_iaColumnWidths[iColumnIndex] =
         (DWORD)((oColumnWidthPoint.x * floatScaleFactor) + m_iMargins[CSourceMetricsApp::INTERCOLUMN_MARGIN]);
   }
   sColumnHeader.ReleaseBuffer();
   iPageWidthUsed = m_iaColumnWidths[0];        // put leftmost label on every page
   m_iaPageColumns.RemoveAll();
   iPageColumns = 1;
   m_iPagesPerCkpt = 1;                         // if values not too wide, use just one page
   for( i = 1; i < m_iPrintColumns; ++i )
   {
      int iColumnWidth;

      iColumnWidth = m_iaColumnWidths[i];
      if( (iPageWidthUsed + iColumnWidth) > iPrintWidth )
      {
         // filled one page: add another
         m_iaPageColumns.Add(iPageColumns);
         ++m_iPagesPerCkpt;
         iPageWidthUsed = m_iaColumnWidths[0];  // put leftmost label on every page
         iPageColumns = 1;
      }
      iPageWidthUsed += iColumnWidth;
      ++iPageColumns;
   }
   m_iaPageColumns.Add(iPageColumns);           // and the number of columns on the last page

   // compute the number of pages to be printed
   pDC->GetTextMetrics(&oTextMetrics);
   m_iLineHeight = oTextMetrics.tmHeight + oTextMetrics.tmExternalLeading;
   m_iFooterHeight = m_iPageHeight              // total physical page height - bottom margin
                        + (int)((float(pDC->GetDeviceCaps(PHYSICALOFFSETY)) * 1440.0)
                                             / float(pDC->GetDeviceCaps(LOGPIXELSY)))
                        - m_iMargins[CSourceMetricsApp::BOTTOM_MARGIN];
   m_iLinesPerPage = (m_iPageHeight - m_iMargins[CSourceMetricsApp::TOP_MARGIN]
                                    - m_iMargins[CSourceMetricsApp::BOTTOM_MARGIN]
                                    - (m_iLineHeight * HEADER_LINES)) / m_iLineHeight;
   m_iLastPage = (m_iListItems / m_iLinesPerPage) + 1;
   m_iLastPage *= m_iPagesPerCkpt;           // set the actual number of pages
   pInfo->SetMaxPage(m_iLastPage);
   pDC->SelectObject(poOldFont);
}


// ***********************************************************************************
// print one page of view data
bool
CSourceMetricsDoc::PrintPage(CDC* pDC, CPrintInfo* pInfo) 
{
   int      iFirstFile;       // index to first file to appear on current print page
   int      iPrintLines;
   int      iFirstColumn;
   int      iColumnLimit;
   CFont *  poOldFont;        // save old font while printing
   CPoint   oPrintAt(m_iMargins[CSourceMetricsApp::LEFT_MARGIN], 0);
   CString  sItem;
   bool     fResult;

   pDC->SetMapMode(MM_TWIPS);
   poOldFont = pDC->SelectObject(m_poPrintFont);
   m_iCurrentPage = pInfo->m_nCurPage;
   iFirstColumn = GetPrintStartCol();
   iColumnLimit = GetPrintLimitCol(iFirstColumn);
   PrintPageHeader(pDC);            // print some header lines
   oPrintAt.y = - (int)m_iMargins[CSourceMetricsApp::TOP_MARGIN] - (m_iLineHeight * (HEADER_LINES + 1));
   iFirstFile = ((m_iCurrentPage - 1) / m_iPagesPerCkpt) * m_iLinesPerPage;
   if( m_iCurrentPage > (m_iLastPage - m_iPagesPerCkpt) )
   {
      iPrintLines = m_iListItems - iFirstFile;
   }
   else
   {
      iPrintLines = m_iLinesPerPage;
   }
   // output the checkpoints, one per line
   for( int i = 0; i < iPrintLines; ++i )
   {
      CSize oTextSize;
      int   iRow = i + iFirstFile;

      // always start with leftmost value
      sItem = m_poListCtrl->GetItemText(iRow, m_iaColumnOrder[0]);
      pDC->TextOut(oPrintAt.x, oPrintAt.y, sItem);
      oPrintAt.x += m_iaColumnWidths[0];
      for( int m = iFirstColumn; m < iColumnLimit; ++m )
      {
         int   iColWidth;
         int   iTextOffset;   // offset needed to right justify text in its column

         iColWidth = m_iaColumnWidths[m];
         sItem = m_poListCtrl->GetItemText(iRow, m_iaColumnOrder[m]);
         oTextSize = pDC->GetTextExtent(sItem);
         if( oTextSize.cx < iColWidth )
         {
            iTextOffset = iColWidth - m_iMargins[CSourceMetricsApp::INTERCOLUMN_MARGIN] - oTextSize.cx;
         }
         else
         {
            iTextOffset = 0;
         }
         pDC->TextOut(oPrintAt.x + iTextOffset, oPrintAt.y, sItem);
         oPrintAt.x += iColWidth;
      }
      oPrintAt.x = m_iMargins[CSourceMetricsApp::LEFT_MARGIN];
      oPrintAt.y -= m_iLineHeight;
   }
   // complete the page
   PrintPageFooter(pDC);
   pDC->SelectObject(poOldFont);
   if( ((((m_iCurrentPage - 1) % m_iPagesPerCkpt) - m_iPagesPerCkpt) == 1)
   and (iPrintLines < m_iLinesPerPage) )
   {
      fResult = false;             // everything has been printed
   }
   else
   {
      fResult = true;
   }
   return fResult;
}

// ***********************************************************************************
// clean up from printing
void
CSourceMetricsDoc::EndPrinting() 
{
   delete m_poPrintFont;
}

// ***********************************************************************************
// write metrics data to a CSV file
void
CSourceMetricsDoc::ExportMetrics(CWnd * pParentWnd, int iCheckpointIndex /* = -2 */)
{
   CString  sDefaultFileName = m_oProject.Name() + _T(".csv");
   CString  sDefaultDirectory = m_oProject.Directory();
   CString  sSaveAsCaption;
   CString  sFileFilter;
   TCHAR *  pcSeparator;         // pointer used to replace | with NULL in filter string

   bool     fCaughtException = false;

   CFileDialog oSaveAsDlg(FALSE, NULL, NULL, OFN_OVERWRITEPROMPT bitor OFN_HIDEREADONLY, NULL, pParentWnd);

   // build filter with '|' separators, then replace them with NULL
   sFileFilter.LoadString(IDS_EXPORT_FILE_FILTER);
   pcSeparator = sFileFilter.GetBuffer(0);
   while( (pcSeparator = _tcschr(pcSeparator + 1, '|')) != NULL )
   {
      *pcSeparator = '\0';                // replace all '|' characters with NULL
   }
   sFileFilter.ReleaseBuffer();
   oSaveAsDlg.m_ofn.lpstrFilter = sFileFilter;
   if( oSaveAsDlg.m_ofn.nMaxFile > (unsigned)sDefaultFileName.GetLength() )
   {
      _tcscpy(oSaveAsDlg.m_ofn.lpstrFile, sDefaultFileName);
   }
   oSaveAsDlg.m_ofn.lpstrInitialDir = sDefaultDirectory.GetBuffer(MAX_PATH);
   if( iCheckpointIndex >= 0 )      // see if we're doing one checkpoint or the whole project
   {
      sSaveAsCaption.LoadString(IDS_EXPORT_CKPT_SAVEAS_CAPTION);
   }
   else
   {
      sSaveAsCaption.LoadString(IDS_EXPORT_PROJ_SAVEAS_CAPTION);
   }
   oSaveAsDlg.m_ofn.lpstrTitle = sSaveAsCaption.GetBuffer(0);
   if( oSaveAsDlg.DoModal() == IDOK )
   {
      CStdioFile     oExportFile;
      CFileException oFileException;
      CString        sFileName = oSaveAsDlg.GetPathName();
      CString        sBlockLabel;         // for block depth column headers

      try
      {
         CWaitCursor    oWaitCursor;
         CStringArray   oColumnHeaders;
         CStringArray   oFixedLineValues;
         CDWordArray    oBlockDepths;
         CString        sItem;            // scratch for fixed strings
         CString        sLineBuffer;
         int            iColumns;
         int            iLastColumnIndex;
         SMCheckpoint   oCkpt;            // scratch for metrics data retrieval
         SMLanguage *   poLanguage = m_oProject.GetLanguage()->MakeNew();
         int            iFirstCkptIndex;
         int            iCkptCount;
         SMFile         oFile;            // scratch for metrics data retrieval

         oExportFile.Open(sFileName, CFile::modeCreate bitor CFile::modeWrite bitor CFile::shareDenyNone, &oFileException);

         // get the headers from the project itself after inserting the fixed column labels first
         sItem.LoadString(IDS_PROJECT_NAME_LABEL);
         oColumnHeaders.Add(sItem);
         sItem.LoadString(IDS_PROJECT_VIEW_CKPT_LABEL);
         oColumnHeaders.Add(sItem);
         sItem.LoadString(IDS_PROJECT_VIEW_DATE_LABEL);
         oColumnHeaders.Add(sItem);
         sItem.LoadString(IDS_CKPT_VIEW_FILES_LABEL);
         oColumnHeaders.Add(sItem);

         // get the column header labels, then  discard the language exemplar
         poLanguage->GetDetails(m_oProject.Version(), oFixedLineValues, oBlockDepths,
                                                true, true, oColumnHeaders);
         delete poLanguage;

         // finally put header labels at the end for the block depth statemnts counts
         sBlockLabel.LoadString(IDS_EXPORT_BLOCK_DEPTH_LABEL);
         for( int b = 0; b < oBlockDepths.GetSize(); ++ b )
         {
            sItem.Format("%s %d", sBlockLabel, b);
            oColumnHeaders.Add(sItem);
         }
         // output the column headers as the first line
         iColumns = oColumnHeaders.GetSize();
         iLastColumnIndex = iColumns - 1;
         for( int i = 0; i < iColumns; ++i )
         {
            sItem = oColumnHeaders[i];
            sLineBuffer += sItem;
            if( i < iLastColumnIndex )
            {
               sLineBuffer += _T(",");
            }
         }
         sLineBuffer += _T("\n");
         oExportFile.WriteString(sLineBuffer);

         // output the metrics data lines
         if( iCheckpointIndex >= 0 )      // see if we're doing one checkpoint or the whole project
         {
            iFirstCkptIndex = iCheckpointIndex;
            iCkptCount = 1;               // just do this one
         }
         else
         {
            iFirstCkptIndex = 0;
            iCkptCount = m_oProject.CheckpointCount();
         }
         for( int c = iFirstCkptIndex; c < iCkptCount; ++c )
         {
            CStringArray   oLineValues;               // values to be written in a comma separated line

            m_oProject.GetCheckpointByIndex(c, oCkpt);

            // preload the value array with the project and checkpoint data
            oFixedLineValues.RemoveAll();
            oFixedLineValues.Add(m_oProject.Name());  // every line has the project name
            sItem = (oCkpt.Date()).Format("%d %b %Y");
            oFixedLineValues.Add(oCkpt.Name());       // add the checkpoint name and date
            oFixedLineValues.Add(sItem);

            // add one line per checkpoint file to the export file
            for( int f = 0; f < oCkpt.FileCount(); ++f )
            {
               oLineValues.Copy(oFixedLineValues);
               oCkpt.GetFileByIndex(f, oFile);
               oLineValues.Add(oFile.PathName());
               oFile.m_poLanguage->GetDetails(m_oProject.Version(), oLineValues, oBlockDepths,
                                                true, false, oColumnHeaders);
               for( int l = 0; l < oBlockDepths.GetSize(); ++ l )
               {
                  sItem.Format("%d", oBlockDepths[l]);
                  oLineValues.Add(sItem);
               }
               sLineBuffer.Empty();
               for( int col = 0; col < iColumns; ++col )
               {
                  sItem = oLineValues[col];
                  if( sItem.Find(',') >= 0 )          // must quote values with embedded commas
                  {
                     CString  sTemp;

                     sTemp.Format("\"%s\"", sItem);
                     sItem = sTemp;
                  }
                  if( col < iLastColumnIndex )
                  {
                     sItem += _T(",");
                  }
                  sLineBuffer += sItem;
               }
               sLineBuffer += _T("\n");
               oExportFile.WriteString(sLineBuffer);
            }
         }
         oExportFile.Close();
      }
      catch(CFileException exception)
      {
         fCaughtException = true;
      }
      catch(...)
      {
         fCaughtException = true;
      }
      if( fCaughtException )
      {
         CString  sCaption;
         CString  sErrorFormat;
         CString  sErrorMessage;

         sCaption.LoadString(IDS_PROJ_FILE_ERROR_CAPTION);
         sErrorFormat.LoadString(IDS_EXPORT_FILE_OPEN_FORMAT);
         sErrorMessage.Format(sErrorFormat, sFileName);
         pParentWnd->MessageBox(sErrorMessage, sCaption, MB_OK bitor MB_ICONERROR);
      }
   }
   sDefaultDirectory.ReleaseBuffer();
   sSaveAsCaption.ReleaseBuffer();
}

/////////////////////////////////////////////////////////////////////////////
// CSourceMetricsDoc serialization

BOOL CSourceMetricsDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
   CStdioFile     oFile;
   CFileException oFileException;
   BOOL           fResult = FALSE;        // assume failure
	
   // see if the file can be saved: if not, tell the user
   if( oFile.Open(lpszPathName,
                        CFile::modeCreate bitor CFile::modeWrite bitor CFile::shareDenyNone,
                        &oFileException) == 0 )
   {
      CString  sCaption;
      CString  sErrorFormat;
      CString  sErrorMessage;
      TCHAR    cOpenError[MAX_PATH];

      sCaption.LoadString(IDS_PROJ_FILE_ERROR_CAPTION);
      oFileException.GetErrorMessage(cOpenError, MAX_PATH);
      sErrorFormat.LoadString(IDS_PROJ_SAVE_ERROR_FORMAT);
      sErrorMessage.Format(sErrorFormat, lpszPathName, cOpenError);
      AfxGetMainWnd()->MessageBox(sErrorMessage, sCaption, MB_OK bitor MB_ICONERROR);
      SetModifiedFlag(FALSE);                   // try to spare the user another save attempt
   }
   else
   {
      oFile.Close();                            // free up the file so CDocument can write to it.
      fResult = CDocument::OnSaveDocument(lpszPathName);
   }
	return fResult;
}

void CSourceMetricsDoc::Serialize(CArchive& ar)
{
   m_oProject.Serialize(ar);
}

BOOL CSourceMetricsDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if( not CDocument::OnOpenDocument(lpszPathName) )
   {
		if( not (dynamic_cast<CSourceMetricsApp *>(AfxGetApp()))->IsInitialized() )
      {
         // if still initializing, let user create a new project if none exists as requested
         CString  sPathname(lpszPathName);
         int      iOffset = sPathname.ReverseFind('\\');

         if( iOffset >= 0 )
         {
            m_sProjectName = sPathname.Mid(iOffset + 1);
            m_sProjectDirectory = sPathname.Mid(0, iOffset);
         }
         return OnNewDocument();
      }
      else
      {
         return FALSE;
      }
   }
	return TRUE;
}
