/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
 */

#ifndef _DataSinkTpHandler_H
#define _DataSinkTpHandler_H

#include "StdAfx.h"
#include "IDataPath.h"

#include "FileObj.h" // the dump file

// {BCB9DFB2-406F-11d3-AEF9-000000000000}
static const GUID CLSID_DataSinkTpHandler = 
{ 0xbcb9dfb2, 0x406f, 0x11d3, { 0xae, 0xf9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };

#include "ITestPoint.h"
#include "CUnknown.h"
/*
	This handler supplies either an IDataSink2 interface for a client needing a test point,
	 or IDataSinkWithReset interface.
	The sink currently implemented is a simple file on the disk, but 
	there is no objection to change it.
	File name is determind from the file name appearing in the "File" value
	in the registry, the PID and TID of the current client.
*/
class DataSinkTpHandler : public CUnknown,
						 public ITestPoint,
						 public IDataSink2
{
public:

	 // creation 
	static HRESULT CreateInstance(IUnknown * pUnknownOuter, CUnknown **ppNewComponent); 

	// -- ITestPoint
	HRESULT Set(const IN GUID& idOfTestPoint,
				const IN char* parameterLocation );


	// -- IDataSink2
	HRESULT Write( char* buff, ULONG size, ULONG *pcbWritten)
	{return m_pSink->Write(buff, size, pcbWritten); }

	HRESULT Write_( char* buff, ULONG size)
	{return m_pSink->Write_(buff,size);}

	HRESULT Flush()
	{return m_pSink->Flush();}

private:
	// IDelegatingUnknown 
	DECLARE_IUNKNOWN  
		
	// INondelegating 
	HRESULT __stdcall NondelegatingQueryInterface( const IID& iid, void ** ppv); 

	DataSinkTpHandler(IUnknown* pUnknpwnOuter);
	/*virtual*/ ~DataSinkTpHandler();

	IDataSink2			*m_pSink;
	FILE_OBJECT			m_DumpFile; 
};

#endif
