/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
 */

// disable warning level 4 caused by microsoft in Visual C++ v5.0
#pragma warning( disable: 4514) // unreferenced inline function has been removed
#pragma warning( disable: 4201) // nonstandard extension used : nameless struct/union

#include "CFactory.h"

// put here all the interfaces you wish to put in the DLL
#include "ITestPoint.h" 

// put here all the headers implementing the above interfaces
#include "TestPointManager.h"
#include "DataSinkTpHandler.h"


//
// This file contains the component server code.
// The FactoryDataArray contains the components that 
// can be served.
//

// Each component derived from CUnknown defines a static function
// for creating the component with the following prototype. 
// HRESULT CreateInstance(IUnknown* pUnknownOuter, 
//                        CUnknown** ppNewComponent) ;
// This function is used to create the component.
//

//
// The following array contains the data used by CFactory
// to create components. Each element in the array contains
// the CLSID, the pointer to the creation function, and the name
// of the component to place in the Registry.
//
CFactoryData g_FactoryDataArray[] =
{
	{&CLSID_TestPointManager, 
		TestPointManager::CreateInstance, 
		"Vsoft's TestPoint manager", // Friendly name
		"Vsoft.testPointManager.1",                  // ProgID
		"Vsoft.testPointManager"},                   // Version-independent ProgID

	{&CLSID_DataSinkTpHandler, 
		DataSinkTpHandler::CreateInstance, 
		"Test point Handler for IDataSink2", // Friendly name
		"Vsoft.DataSinkHandler.1",                  // ProgID
		"Vsoft.DataSinkHandler"},
} ;

int g_cFactoryDataEntries
	= sizeof(g_FactoryDataArray) / sizeof(CFactoryData) ;
