/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
 */

#include "ITestPoint.h"
#include "CUnknown.h"

/*
The TpManager implements ITestPointManager.
The role of the manager is to support querying status of test points and 
instantiating handlers for a given TP.
*/
class TestPointManager : public CUnknown, public ITestPointManager
{
public:
	 // creation 
	static HRESULT CreateInstance(IUnknown * pUnknownOuter, CUnknown **ppNewComponent); 

	HRESULT IsActive( const IN GUID & idOfTestPoint);

	HRESULT GetNameOfTp( const IN GUID & idOfTestPoint, // ID of the TP
			IN	 UINT bufferSize,		// maximum size of buffer 
			OUT  char* pNameOfTp		// name of the TP will be placed here
			);

	HRESULT SetActive(const IN GUID & idOfTestPoint , IN bool isActive) ;
	
	HRESULT QueryInterfaceForTp(const IN GUID & idOfTestPoint , 
										OUT IUnknown ** pUnknown);

	HRESULT RegisterTestPoint(const IN GUID & idOfTestPoint ,
									  const IN char * szNameOfThisTpInstance, // friendly name of this instance of the TP
									  const IN bool bIsActive,	// Is this instance of TP active immediatly.
									  OUT   DWORD &  dwCookie // Pointer to a value that identifies the 
													 //class object registered; later used by 
													 //the RevokeTestPoint function to revoke 
													 //the registration.
									  );



private:
	// IDelegatingUnknown 
	DECLARE_IUNKNOWN   

	// INondelegating 
	HRESULT __stdcall NondelegatingQueryInterface( const IID& iid, void ** ppv); 

	TestPointManager(IUnknown* pUnknpwnOuter);
	virtual ~TestPointManager();


	char * m_pTpRootPath; 
};
