/* Copyright (C) 1999, Vsoft Ltd. All Rights Reserved.
 *
 *   Usage Restrictions
 *
 * License is granted to copy, to use, and to make and to use derivative
 * works for research and evaluation purposes only.
 *
 *   Disclaimer of Warranty
 *
 * These software programs are available to the user without any license
 * fee or royalty on an "as is" basis.  Vsoft Ltd. disclaims any and
 * all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any 
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and
 * user's customers, employees, agents, transferees, successors, and
 * assigns.
 *
 * Comments & Questions:
 * mailto:noam@vsoft.com  . Please put "TestPoint" in the subject line.
 */

#include "ITestPoint.h"
#include "stdio.h"
#include "FileObj.h"
#include "SourceTestPoint.h"

// {BCB9DFB3-406F-11d3-AEF9-000000000000}
static const GUID MyFirstTp1 = 
{ 0xbcb9dfb3, 0x406f, 0x11d3, { 0xae, 0xf9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 } };


int main(int ac, char ** av)
{
	printf("\nThis application demonstrates the usage of TestPoints.\nThe file supplied in the command line is copied to 'sinkOut.bin' and if\nthere is an active testpoint, to the testpoint dump file as well. \n");
	if( ac != 2)
	{
		printf("usage: %s some_file\n", av[0] );
		return 1;
	}
	 
	CoInitialize(0);
	{
		// simulate reading from a source,writing to a sink, possibly dumping to a testpoint as well.
		HRESULT hr;
		FILE_OBJECT aSource, aSink;
		hr = aSink.CreateFile("sinkOut.bin",GENERIC_WRITE,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL);
		if(FAILED(hr))
			return hr;
		hr = aSource.CreateFile(av[1],GENERIC_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL);
		if(FAILED(hr))
			return hr;

		IDataSource2 * pSource = NULL;
		char buff[1100];

		// use a SinkTestPoint

		// {{connect the TP if needed
		IDataSink2 * pNewSink = NULL;
		SinkTestPoint sinkTp;

		hr = sinkTp.Connect(MyFirstTp1, &aSink, &pNewSink);
		if(S_OK != hr)
		{
			printf("SinkTp returned 0x%X.\n", hr);
			// no need for any other action, since the connection is made anyway
		}
		// TestPoint handling}}

		pSource = &aSource;
		while(!pSource->AtEnd())
		{
			pSource->Read_(buff,1000);
			pNewSink->Write_(buff,1000);
		}
		
	}
	// you MUST destruct the SinkTestPoint object before Couninit() !
	CoUninitialize();
	return 0;
}