#ifndef ViewSourceDlg_H
#define ViewSourceDlg_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       ViewSourceDlg.h	[ ViewSourceDlg.cpp ]
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Defines a detail display class, CViewSourceDlg, derived from CDialog
//
//***************************************************************************

/////////////////////////////////////////////////////////////////////////////
// CViewSourceDlg dialog

class CViewSourceDlg : public CDialog
{
// Construction
public:
	CViewSourceDlg(CWnd* pParent = NULL);   // standard constructor

   bool  SetFileName(CString sFileName);
   void  EnableDeepestButton(CString sLabel, int iLineNumber);
   void  EnableBiggestModule(CString sLabel, int iLineNumber);

// Dialog Data
	//{{AFX_DATA(CViewSourceDlg)
	enum { IDD = IDD_VIEW_SOURCE_FILE };
	CButton	m_btnClose;
	CButton	m_btnDeepestBlock;
	CButton	m_btnBiggestMethod;
	//}}AFX_DATA

   CRichEditCtrl  m_richEditSource;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CViewSourceDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
   void     HighlightLine(int iLineNumber);
   static DWORD CALLBACK
            EditControlStreamInCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG FAR *pcb); 

   bool     m_fInitialized;               // controls size change processing
   CString  m_sFileName;
   CString  m_sSourceCode;
   CString  m_sDeepestLabel;
   int      m_iDeepestBlockLineNumber;
   CString  m_sBiggestLabel;
   int      m_iBiggestModuleLineNumber;
   bool     m_fEnableDeepestButton;
   bool     m_fEnableBiggestButton;

	// Generated message map functions
	//{{AFX_MSG(CViewSourceDlg)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBiggestMethodButton();
	afx_msg void OnDeepestBlockButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // ViewSourceDlg_H
