/*---------------------------------------------------------------------------

               Copyright (c) 1994 - 1999 SandStone Technology Inc.
                          All rights reserved

      THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
      OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
      DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
#include "stdafx.h"

#include<new.h>
#include<ssexcept.hpp>
#if defined( __BORLANDC__)
#     pragma warn -aus
#endif

#  define SSExceptionNew                32
#  define SSExceptionMsgLength          512
#  define SSExceptionBufferSize         256
#  define SSExceptionOutOfStorageId     0xffffffff
#  define SSExceptionOutOfStorageString "SSException0001e: Out of storage"
#  define SSExceptionMsgSprintf         "SSException0002e: sprintf msg too long"

   static SSExceptionInfo* spInfo = 0;

#  if ( _MSC_VER == 800) || ( _MSC_VER >= 900)

	int SSExceptionNewHandler( size_t)
		{
		SSExceptionOutOfStorage zExcept;
		if ( getSSExceptionInfo().isThrowPointer())
			SSTHROW0( &zExcept);
		else
			SSTHROW1( zExcept);
		return 0;
		}

   void setSSExceptionNewHandler( void)
      {
      _set_new_handler(( _PNH) SSExceptionNewHandler);
      }
 
#  else

   void SSExceptionNewHandler( void)
      {
      SSExceptionOutOfStorage zExcept;
	  if ( getSSExceptionInfo().isThrowPointer())
	     SSTHROW0( &zExcept);
	  else
	     SSTHROW1( zExcept);
      }

   void setSSExceptionNewHandler( void)
      {
      set_new_handler( SSExceptionNewHandler);
      }
 
#endif 

	SSExceptionImplementDynamic( SSException, CException)
	SSExceptionImplementDynamic( SSExceptionOutOfStorage, SSException)

   SSExceptionInfo& getSSExceptionInfo( void)
      {
      if ( !spInfo)
         spInfo = new SSExceptionInfo;
      return *spInfo;
      }

   SSExceptionInfo::SSExceptionInfo( void) : oException( SSExceptionDefault),
   	  oThrowPointer( SSExceptionThrowPointerDefault)
      {
      }

	SSBooleanValue SSExceptionInfo::hasException( void) const
		{
		return oException;
		}

	SSBooleanValue SSExceptionInfo::setException( SSBooleanValue qSet)
		{
		SSBooleanValue zSet = oException;
		oException = qSet;
		return zSet;
		}

	SSBooleanValue SSExceptionInfo::isThrowPointer( void)
		{
		return oThrowPointer;
		}

	SSBooleanValue SSExceptionInfo::setThrowPointer( SSBooleanValue qSet)
		{
		SSBooleanValue zSet = oThrowPointer;
		oThrowPointer = qSet;
		return zSet;
		}

	void SSException::throwException( const char* qpszMsg)
		{
		if ( getSSExceptionInfo().hasException())
			{
			if ( getSSExceptionInfo().isThrowPointer())
         {
				SSException* zpException = new SSException( qpszMsg, 0);
				SSTHROW0( zpException);
         }
			else
				{
				SSException zException( qpszMsg, 0);
				SSTHROW1( zException);
				}
			}
		}

	void SSExceptionPresent::throwException( SSUnsigned32 qulError,
		const char* qpszMsg)
		{
		if ( getSSExceptionInfo().hasException())
			{
			if ( getSSExceptionInfo().isThrowPointer())
         {
				opException = new SSException( qpszMsg, qulError);
				SSTHROW0( opException);
         }
			else
				{
				SSException zException( qpszMsg, qulError);
				SSTHROW1( zException);
				}
			}
		}

	void SSException::throwException( const char* qpszMsg, int qParm)
		{
		char achMsg[ SSExceptionMsgLength];
		int iLen = sprintf( achMsg, qpszMsg, qParm);
		if ( iLen >= SSExceptionMsgLength)
			throwException( SSExceptionSprintf, SSExceptionMsgSprintf);
		if ( getSSExceptionInfo().hasException())
			{
			if ( getSSExceptionInfo().isThrowPointer())
         {
				SSException* zpException = new SSException( achMsg, 0);
				SSTHROW0( zpException);
         }
			else
				{
				SSException zException( achMsg, 0);
				SSTHROW1( zException);
				}
			}
		}

	void SSException::throwException( SSUnsigned32 qMsg, const char* qpszMsg)
		{
		if ( getSSExceptionInfo().hasException())
			{
			if ( getSSExceptionInfo().isThrowPointer())
         {
				SSException* zpException = new SSException( qpszMsg, qMsg);
				SSTHROW0( zpException);
         }
			else
				{
				SSException zException( qpszMsg, qMsg);
				SSTHROW1( zException);
				}
			}
		}

	void SSExceptionPresent::throwException( SSUnsigned32 qulError,
		const char* qpszMsg, SSUnsigned32 qulParm)
		{
		char achMsg[ SSExceptionMsgLength];
		int iLen = sprintf( achMsg, qpszMsg, qulParm);
		if ( iLen >= SSExceptionMsgLength)
			throwException( SSExceptionSprintf, SSExceptionMsgSprintf);
		if ( getSSExceptionInfo().hasException())
			{
			if ( getSSExceptionInfo().isThrowPointer())
         {
				opException = new SSException( achMsg, qulError);
				SSTHROW0( opException);
         }
			else
				{
				SSException zException( achMsg, qulError);
				SSTHROW1( zException);
				}
			}
      }

	void SSExceptionPresent::throwException( SSUnsigned32 qulError,
		const char* qpszMsg, const char* qpszParm)
	{
	    char achMsg[ SSExceptionMsgLength];
		int iLen = sprintf( achMsg, qpszMsg, qpszParm);
		if ( iLen >= SSExceptionMsgLength)
			throwException( SSExceptionSprintf, SSExceptionMsgSprintf);
  		if ( getSSExceptionInfo().hasException())
		{
			if ( getSSExceptionInfo().isThrowPointer())
         {
			    opException = new SSException( achMsg, qulError);
			    SSTHROW0( opException);
         }
			else
			{
			   SSException zException( achMsg, qulError);
				SSTHROW1( zException);
			}
		}
	}

	void SSExceptionPresent::throwException( SSUnsigned32 qulError,
		const char* qpszMsg, const char* qpszParm, SSUnsigned32 qulParm)
		{
		char achMsg[ SSExceptionMsgLength];
		int iLen = sprintf( achMsg, qpszMsg, qpszParm, qulParm);
		if ( iLen >= SSExceptionMsgLength)
			throwException( SSExceptionSprintf, SSExceptionMsgSprintf);
		if ( getSSExceptionInfo().hasException())
			{
			if ( getSSExceptionInfo().isThrowPointer())
         {
				SSTHROW0( opException);
				opException = new SSException( achMsg, qulError);
         }
			else
				{
				SSException zException( achMsg, qulError);
				SSTHROW1( zException);
				}
			}
		}

	void SSExceptionPresent::throwException( SSUnsigned32 qulError,
		const char* qpszMsg, SSUnsigned32 qulParm0, SSUnsigned32 qulParm1,
		const char* qpszParm2)
		{
		char achMsg[ SSExceptionMsgLength];
		int iLen = sprintf( achMsg, qpszMsg, qulParm0, qulParm1, qpszParm2);
		if ( iLen >= SSExceptionMsgLength)
			throwException( SSExceptionSprintf, SSExceptionMsgSprintf);
		if ( getSSExceptionInfo().hasException())
			{
			if ( getSSExceptionInfo().isThrowPointer())
         {
				opException = new SSException( achMsg, qulError);
				SSTHROW0( opException);
         }
			else
				{
				SSException zException( achMsg, qulError);
				SSTHROW1( zException);
				}
			}
		}

	void SSException::setText( const char* qpszText)
		{
		SSUnsigned32 zulLength = strlen( qpszText);
		if ( zulLength > SSExceptionTextLength)
			{
			memcpy( oachText, qpszText, SSExceptionTextLength);
			oachText[ SSExceptionTextLength] = '\0';
			}
		else
			strcpy( oachText, qpszText);
		}

	SSExceptionOutOfStorage::SSExceptionOutOfStorage( void) :
		SSException( SSExceptionOutOfStorageString, SSExceptionOutOfStorageId)
		{
		}
/*---------------------------------------------------------------------------

					Copyright (c) 1994 - 1999 SandStone Technology Inc.
								  All rights reserved

		THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
		OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
		DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
