/*---------------------------------------------------------------------------

					Copyright (c) 1994 - 1999 SandStone Technology Inc.
								  All rights reserved

		THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
		OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
		DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
#include "stdafx.h"

#include<errno.h>
#include<stdio.h>
#include<stdlib.h>
#include<limits.h>
#include<sssto.hpp>
#include<sslex.hpp>
#include<ssdbcs.hpp>
#include<sslifo.hpp>
#include<sslextb.hpp>
#if defined( _Windows) || defined( __WIN32__) || defined( WIN32) || defined( _WINDOWS)
#  include<windows.h>
#  pragma warning( disable: 4291)
#endif
#if defined( __BORLANDC__)
#     pragma warn -aus
#     pragma warn -ccc
#     pragma warn -rch
#endif

#if !defined( SS16BIT)
#  define SSLexBufferMax   0xffffffff
#  define SSLexTableThresh 0xffffffff
#else
#  define SSLexBufferMax   0x0000ff00
#  define SSLexTableThresh 0x00010000
#endif

	void SSAux( void);
	class SSLexIterator;
	class SSLexFinalState;
	class SSLexTableHeader;
	class SSLexPairTableRow;
	class SSLexPairTableIndex;
	class SSLexLexTableHeader;
	class SSLexPairTableHeader;
	class SSLexPairTableRowEntry;
	struct SSLexPairTableIndexMap;
	struct SSLexPairTableHeaderMap;

#  if ( _MSC_VER == 800) || defined( SSNOTEMPLATE)
#     include<sslifolx.hpp>
		typedef SSLexPairTableRow SSHuge*            SSLexPairTableRowHuge;
#  else
		typedef SSLifoArray< SSLexExpressionListPtr> SSLexExpressionListStack;
		typedef SSHuge SSLexPairTableRow*            SSLexPairTableRowHuge;
#  endif

#  define SSLexTableTypeNewPair 0x53534c58
#  define SSCharToUnsigned32( c) ( *(( SSUnsigned32*) c))

	class SSLexTableHeader
		{
		public:
			enum SSLexTableType
				{
				unknown,
				pair,
				newPair = 0x53534c58
				};

         SSBooleanValue    open( void);
			SSUnsigned32      type( void) const { return oulType;}
			SSLexFinalState&  lookupFinal( SSUnsigned32) const;
         SSUnsigned32      size( void) const { return oulSize;}
         SSUnsigned32      lookupState( SSUnsigned32, SSUnsigned32) const;

		protected:
         union
            {
            SSUnsigned32   oulType;
            SSLexTableType oType;
            };
         SSUnsigned32      oulSize;
         SSUnsigned32      aoulReserved[ 8];
      };

   class SSLexLexTableHeader
      {
      public:
			SSUnsigned32                     size( void) const
															{ return oulSize;}
			SSUnsigned32                     type( void) const
															{ return oulType;}
      	SSUnsigned32							keywordSize( void) const
         												{ return oaulReserved[ 0];}
		private:
			SSUnsigned32                        oulSize;
			union
				{
				SSLexTableHeader::SSLexTableType oType;
				SSUnsigned32                     oulType;
				};
			SSUnsigned32                        oaulReserved[ 7];
		};

	class SSLexPairTableHeader : public SSLexTableHeader
		{
		friend class SSLexTable;
		public:
			SSUnsigned32           rows( void) const
				{ return oulRows;}
			void                   open( void);
			SSLexFinalState*       final( void) const
				{ return opFinal;}
			SSLexPairTableIndex*   index( void) const
				{ return opIndex;}
			SSLexFinalState&       lookupFinal( SSUnsigned32) const;
			SSUnsigned32           lookupState( SSUnsigned32, SSUnsigned32) const;
			void                   convert( SSLexPairTableHeaderMap*, SSUnsigned32);
		private:
			SSUnsigned32           oulRows;
			SSUnsigned32           oulPush;
			union
				{
				SSLexPairTableIndex* opIndex;
				SSUnsigned32         oulIndex;
				};
			union
				{
				SSLexFinalState*    opFinal;
				SSUnsigned32        oulFinal;
				};
			SSUnsigned32           ulReserved[ 8];
      };

   struct SSLexPairTableHeaderMap
   {
	   char		oType[ 4];
	   char		oSize[ 4];
	   char		oReserved0[ 32];
	   char		oRows[ 4];
	   char		oPush[ 4];
	   char		oIndex[ 4];
	   char		oFinal[ 4];
	   char		oReserved1[ 32];
   };

   class SSLexPairTableRowEntry
      {
      public:
         SSUnsigned32 end( void) const
            { return oulEnd;}
         SSUnsigned32 start( void) const
            { return oulStart;}
         SSUnsigned32 state( void) const
				{ return oulState;}
		private:
         SSUnsigned32 oulStart;
         SSUnsigned32 oulEnd;
         SSUnsigned32 oulState;
      };

   class SSLexPairTableRow
      {
      public:
         SSUnsigned32            size( void) const
				{ return oulSize;}
         SSLexPairTableRowEntry* entry( void) const
            { return ( SSLexPairTableRowEntry*) ( this + 1);}
      private:
			SSUnsigned32            oulSize;
      };

   class SSLexPairTableIndex
      {
      friend class SSLexPairTableHeader;
      public:
			SSLexPairTableRow*    row( void) const
				{ return opRow;}
         SSUnsigned32          rowOffset( void) const
            { return oulRow;}
		void convert( SSLexPairTableIndexMap*, SSUnsigned32);
      private:
         union
            {
            SSLexPairTableRow* opRow;
            SSUnsigned32       oulRow;
            };
      };

   struct SSLexPairTableIndexMap
   {
	   char	oRow[ 4];
   };

   SSLexConsumer::SSLexConsumer( SSLexConsumerType qType) : oType( qType), 
      oDbcs( locateDbcsInfo()), oulIndex( 0), oulStart( 0), opchBuff( 0),
      oEndOfData( SSFalse), oulConsumed( 0), oulLine( 0), oulOffset( 0),
		oulScanLine( 1), oulScanOffset( 1), oulBuff( 0), oulLength( 0),
		oulBof( SSLexTokenBof), oulMark( 0), oulShift( 0), oReversedUnicode( 1)
		{
		}

	SSBooleanValue SSLexConsumer::operator++( int qDummy)
		{
		qDummy;//Unreferenced
		if ( oEndOfData) return SSFalse;
		oulCurrent = oulBof;
		if ( oulCurrent)
			{
			if ( oType == unicode && oulIndex < oulLength)
				{
				if ( !memcmp( opchBuff, "\xfe\xff", 2))
					{
					oReversedUnicode = 0;
					oulIndex += 2;
					}
				else if ( !memcmp( opchBuff, "\xff\xfe", 2))
					oulIndex += 2;
				}
			oulBof = 0;
			return SSTrue;
			}
		if ( oulIndex >= oulLength)
			{
			SSUnsigned32 zulLength = nextBuffer();
			 oEndOfData = !zulLength;
			if ( oEndOfData)
				return SSFalse;
			else
				oulLength += zulLength;
			}

		switch ( oType)
			{
			case binary:
				singleByte();
				break;
			case character:
				if ( dbcs().isLeadByte( opchBuff[ oulIndex]))
				{
					doubleByte();
					oulScanOffset++;
				}
				else
					singleByte();
				break;
			case unicode:
				unicodeByte();
				break;
			}

		oulConsumed++;
		if ( oulCurrent == '\n')
			oulScanLine++, oulScanOffset = 1;
		else
			oulScanOffset++;

		return SSTrue;
		}

	void SSLexConsumer::unicodeByte( void)
		{
		if ( oReversedUnicode)
			oulCurrent = (( SSUnicode*) opchBuff)[ ( SSIndex) oulIndex / 2];
		else
			{
			oulCurrent = ( SSUnsigned32) *( opchBuff + oulIndex + 1) & 0x000000ff;
			oulCurrent <<= 8;
			oulCurrent |= ( SSUnsigned32) *( opchBuff + oulIndex) & 0x000000ff;
			}
		oulIndex += 2;
		}

	SSBooleanValue SSLexConsumer::shiftBuffer( SSUnsigned32& qulRead, SSUnsigned32& qulFill)
	{
		qulRead = oulLength - oulStart;
		if ( oulStart == 0 && oulLength == 0)
		{
			qulRead = 0;
			qulFill = oulBuff;
        }
		else if ( oulStart == 0)
			 return SSTrue;
		else if ( qulRead)//= oulLength - oulStart)
		{
			oulShift += qulRead;
			memmove( opchBuff, opchBuff + oulStart, qulRead);
			qulFill = oulBuff - qulRead;
			oulIndex -= oulStart;
			oulLength -= oulStart;
			oulMark += oulStart;
			oulStart = 0;
		}
		else
		{
			oulShift += oulLength;
			qulRead = oulLength = oulIndex = oulStart = 0;
			qulFill = oulBuff;
        }

		return SSFalse;
	}

	SSBooleanValue SSLexConsumer::expandBuffer( SSUnsigned32& qulRead,
      SSUnsigned32& qulFill)
      {
		if ( oulInc == 0) return SSTrue;
		if ( oulBuff > SSLexBufferMax)
			return SSTrue;
		unsigned long zulBuff = oulBuff + oulInc;
		if ( zulBuff > SSLexBufferMax)
			zulBuff = SSLexBufferMax;
      char* zpchBuff = new char[ zulBuff];
      memcpy( zpchBuff, opchBuff, oulBuff);
      qulRead = oulLength;
		delete [] opchBuff;
		opchBuff = zpchBuff;
		qulFill = zulBuff - oulLength;
		oulBuff = zulBuff;
		return SSFalse;
      }

	SSLexConsumer::~SSLexConsumer( void)
		{
      if ( opchBuff) delete [] opchBuff;
		}

	SSLexFileConsumer::SSLexFileConsumer( void) : opFile( 0)
		{
		}
		
	SSLexFileConsumer::SSLexFileConsumer( const char* qpszFile,
		SSLexConsumerType qType, SSUnsigned32 qulBuff, SSUnsigned32 qulInc) :
		SSLexConsumer( qType)
		{
		oulBuff = qulBuff;
		oulInc = qulInc;

      char* zpszMode;
      switch ( type())
         {
         case binary:
				zpszMode = SSLexFileModeBinary;
            break;
         case unicode:
            zpszMode = SSLexFileModeUnicode;
            break;
         case character:
				zpszMode = SSLexFileModeCharacter;
				break;
         }

      opFile = fopen( qpszFile, zpszMode);
      if ( !opFile)
         {
         throwException( SSExceptionLexFileOpen, SSLexMsgFileOpen,
            qpszFile, errno);
         return;
         }

		fseek( opFile, 0L, SEEK_END);
		SSUnsigned32 zulBuff = ftell( opFile);
		oulFile = zulBuff;
		fseek( opFile, 0L, SEEK_SET);
		if ( oulBuff == SSLexConsumerAll)
			oulBuff = zulBuff;
		else if ( oulBuff > zulBuff)
			oulBuff = zulBuff;

		if ( !oulBuff)
			{
			fclose( opFile);
			throwException( SSExceptionLexFileLength, SSLexMsgFileLength,
				qpszFile, 0);
			return;
			}

		if ( oulBuff > SSLexBufferMax)
			{
			if ( !oulInc)
				oulInc = oulBuff - SSLexBufferMax;
			oulBuff = SSLexBufferMax;
			}

		if ( oulInc > SSLexBufferMax)
			oulInc = SSLexBufferMax;

		opchBuff = new char[ oulBuff];
		oulLength = fread( opchBuff, 1, oulBuff, opFile);
		oulFile -= oulLength;
		if ( !oulFile || ( oulLength < oulBuff)) close();
		}

	SSLexAutoFileConsumer::SSLexAutoFileConsumer( const char* qpszFile,
		SSUnsigned32 qulBuff, SSUnsigned32 qulInc)
		{
		oulBuff = qulBuff;
		oulInc = qulInc;

		opFile = fopen( qpszFile, "rb");
		if ( !opFile)
			{
			throwException( SSExceptionLexFileOpen, SSLexMsgFileOpen,
				qpszFile, errno);
			return;
			}

		char zachTest[ 2];
		SSUnsigned32 zulLen = fread( zachTest, 1, 2, opFile);
		if ( zulLen > 1)
			{
			if ( !memcmp( zachTest, "\xfe\xff", 2))
				oType = unicode;
			else if ( !memcmp( zachTest, "\xff\xfe", 2))
				oType = unicode;
			}
		close();

		char* zpszMode;
		switch ( type())
			{
			case binary:
				zpszMode = SSLexFileModeBinary;
				break;
			case unicode:
            zpszMode = SSLexFileModeUnicode;
            break;
         case character:
				zpszMode = SSLexFileModeCharacter;
				break;
         }

      opFile = fopen( qpszFile, zpszMode);
		if ( !opFile)
			{
			throwException( SSExceptionLexFileOpen, SSLexMsgFileOpen,
				qpszFile, errno);
			return;
			}

		fseek( opFile, 0L, SEEK_END);
		SSUnsigned32 zulBuff = ftell( opFile);
		oulFile = zulBuff;
		fseek( opFile, 0L, SEEK_SET);
		if ( oulBuff == SSLexConsumerAll)
			oulBuff = zulBuff;
		else if ( oulBuff > zulBuff)
			oulBuff = zulBuff;

		if ( !oulBuff)
			{
			fclose( opFile);
			throwException( SSExceptionLexFileLength, SSLexMsgFileLength,
				qpszFile, 0);
			return;
			}

		if ( oulBuff > SSLexBufferMax)
			{
			if ( !oulInc)
				oulInc = oulBuff - SSLexBufferMax;
			oulBuff = SSLexBufferMax;
			}

		if ( oulInc > SSLexBufferMax)
			oulInc = SSLexBufferMax;

		opchBuff = new char[ oulBuff];
		oulLength = fread( opchBuff, 1, oulBuff, opFile);
		oulFile -= oulLength;
		if ( !oulFile || ( oulLength < oulBuff)) close();
		}

	SSUnsigned32 SSLexFileConsumer::nextBuffer( void)
		{
		if ( !opFile)
			return 0;

      SSUnsigned32 zulRead, zulFill;
      if ( shiftBuffer( zulRead, zulFill) && expandBuffer( zulRead, zulFill))
			{
			char zchTest;
			if ( fread( &zchTest, 1, 1, opFile))
				throwException( SSExceptionLexLexemeLength,
					SSLexMsgLexemeLength, oulLength);
			else
				close();
			return 0;
			}

		SSUnsigned32 zulLength = fread( opchBuff + zulRead, 1, zulFill, opFile);
		oulFile -= zulLength;
		if ( !oulFile || !zulLength || ( zulLength < zulFill)) close();
		return zulLength;
		}

	SSLexFileConsumer::~SSLexFileConsumer( void)
		{
		if ( opFile) fclose( file());
		}

	SSLexStringConsumer::SSLexStringConsumer( const char* qpszString,
		SSLexConsumerType qType) : SSLexConsumer( qType)
		{
		oulInc = 0;
		oulBof = 0;
		oulBuff = oulLength = strlen( qpszString);
		if ( oulLength > SSLexBufferMax)
			oulBuff = oulLength = SSLexBufferMax - 1;
		opchBuff = new char[ oulLength + 1];
		strcpy( opchBuff, qpszString);
		oEndOfData = oulLength ? SSFalse : SSTrue;
		}

	SSLexStringConsumer::SSLexStringConsumer( wchar_t* qpszString) :
		SSLexConsumer( SSLexConsumer::unicode)
		{
		oulInc = 0;
		oulBof = 0;
		oulBuff = oulLength = wcslen( qpszString) * 2;
		if ( oulLength > SSLexBufferMax)
			oulBuff = oulLength = SSLexBufferMax - 1;
		opchBuff = new char[ oulLength + 2];
		wcscpy(( wchar_t*) opchBuff, qpszString);
		oEndOfData = oulLength ? SSFalse : SSTrue;
		}

	SSUnsigned32 SSLexStringConsumer::nextBuffer( void)
		{
		return 0;
		}

	SSLexTable::SSLexTable( const char* qpszFile) : oapExpressionList( 0), oapKeywordList( 0), oulKeywordList( 0)
		{
		FILE* zpFile = fopen( qpszFile, "rb");
		if ( !zpFile)
			{
			throwException( SSExceptionLexFileOpen, SSLexMsgFileOpen,
				qpszFile, errno);
			return;
			}

		opTable = mallocSS( sizeof( SSLexLexTableHeader));
		if ( !fread( opTable, 1, sizeof( SSLexLexTableHeader), zpFile))
			{
			freeSS( opTable);
			fclose( zpFile);
			throwException( SSExceptionLexFileLength, SSLexMsgFileLength, qpszFile, errno);
			return;
			}
#if defined( SSBIGENDIAN)
#  include<ssltblx0.cpp>
#endif

		SSLexLexTableHeader* zpTable = ( SSLexLexTableHeader*) opTable;
		if ( zpTable->type() != SSLexTableHeader::unknown)
			if ( zpTable->type() != SSLexTableTypeNewPair)
				{
				freeSS( opTable);
				fclose( zpFile);
				throwException( SSExceptionLexTable, SSLexMsgTable, qpszFile);
				return;
				}

		oulExpressionList = zpTable->size();
		oapExpressionList = new SSLexExpressionListPtr[ zpTable->size()];
		for ( unsigned int i = 0; i < zpTable->size(); i++)
			{
			SSLexPairTableHeader zPairHeader;
			SSUnsigned32 zulTell = ftell( zpFile);
			if ( !fread( &zPairHeader, 1, sizeof zPairHeader, zpFile))
				{
				freeSS( opTable);
				fclose( zpFile);
				throwException( SSExceptionLexFileLength, SSLexMsgFileLength, qpszFile, errno);
				return;
				}
#if defined( SSBIGENDIAN)
#  include<ssltblx1.cpp>
#endif
			void* zpPairTable = mallocSSSpecial( zPairHeader.size());
			fseek( zpFile, zulTell, SEEK_SET);
			if ( !readSSFile( zpPairTable, zPairHeader.size(), zpFile))
				{
				freeSS( opTable);
				fclose( zpFile);
				throwException( SSExceptionLexFileLength, SSLexMsgFileLength, qpszFile, errno);
				return;
				}
#if defined( SSBIGENDIAN)
#  include<ssltblx2.cpp>
#endif

#if defined( SSCONVERTTABLE)
			convert(( SSLexPairTableHeader*&) zpPairTable);
#endif

			if ((( SSLexTableHeader*) zpPairTable)->open())
				{
				freeSS( opTable);
				fclose( zpFile);
				throwException( SSExceptionLexTable, SSLexMsgTable, qpszFile);
				return;
				}
			oapExpressionList[ i] = new SSLexExpressionList(( void*) zpPairTable);
			}

		readKeyword( zpTable, zpFile, qpszFile);
		fclose( zpFile);
		SSAux();
		}

	void SSLexTable::readKeyword( SSLexLexTableHeader* qpTable, FILE* qpFile, const char* qpszFile)
   	{
      if ( !qpTable->keywordSize()) return;
      oulKeywordList = qpTable->keywordSize();
		oapKeywordList = ( SSLexKeywordTable**) new SSLexKeywordListPtr[ qpTable->keywordSize()];
      for ( unsigned int i = 0; i < qpTable->keywordSize(); i++)
      	{
         SSLexKeywordTable zKey;
			SSUnsigned32 zulTell = ftell( qpFile);
			if ( !fread( &zKey, 1, sizeof( SSLexKeywordTable), qpFile))
         	throwException( SSExceptionLexKeywordRead, SSLexMsgKeywordRead, qpszFile);
#if defined( SSBIGENDIAN)
		    SSLittleToBigEndian( &zKey, sizeof zKey);
#endif
         oapKeywordList[ i] = ( SSLexKeywordTable*) malloc( zKey.size());
			fseek( qpFile, zulTell, SEEK_SET);
         if ( !fread( oapKeywordList[ i], 1, zKey.size(), qpFile))
         	throwException( SSExceptionLexKeywordRead, SSLexMsgKeywordRead, qpszFile);
#if defined( SSBIGENDIAN)
		 memcpy( oapKeywordList[ i], &zKey, sizeof zKey);
#endif
#if defined( SSCONVERTTABLE) || defined( SSBIGENDIAN)
		 convert( oapKeywordList, i);
#endif
         formatKeyword( oapKeywordList[ i]);
         }
      }

   void SSLexTable::formatKeyword( SSLexKeywordTable* qpTable)
   	{
   	SSLexKeywordIndex* zpIndex = ( SSLexKeywordIndex*) ( qpTable + 1);
      for ( unsigned int i = 0; i < qpTable->indexSize(); i++, zpIndex++)
      	{
         zpIndex->setKeyword(( char*) (( char*) qpTable + zpIndex->keywordIndex()));
         zpIndex->setKeywordWide(( wchar_t*) (( char*) qpTable + zpIndex->keywordWideIndex()));
         }
   	}

   void SSLexTable::findKeyword( SSUnsigned32 qIndex, SSLexLexeme* qpLexeme, SSLexConsumer::SSLexConsumerType qType)
   	{
   	if ( qIndex >= oulKeywordList)
      	throwException( SSExceptionLexKeywordIndex, SSLexMsgKeywordIndex, qIndex);
   	SSLexKeywordTable* zpTable = oapKeywordList[ qIndex];
		SSLexKeywordIndex* zpBase = ( SSLexKeywordIndex*) ( zpTable + 1);

      SSUnsigned32 zBot = 0;
      SSUnsigned32 zTop = zpTable->indexSize();
      while ( zTop > zBot)
      	{
         int zRet;
         SSUnsigned32 zCurrent = zBot + (( zTop - zBot) / 2);
         if ( qType == SSLexConsumer::unicode)
         	{
	        if ( zpBase[ zCurrent].isNocase())
			{
#if !defined(__BORLANDC__)
				wcslwr( qpLexeme->asUnicode());
#else
				_wcslwr(( wchar_t*) qpLexeme->asUnicode());
#endif
   			 	zRet = wcscmp(( wchar_t*) qpLexeme->asConstUnicode(), zpBase[ zCurrent].keywordWide());
			}
      		else
            {
         		zRet = wcscmp(( wchar_t*) qpLexeme->asConstUnicode(), zpBase[ zCurrent].keywordWide());
				}
            }
         else
         	{
	        if ( zpBase[ zCurrent].isNocase())
			{
				strlwr( qpLexeme->asChar());
   			 	zRet = strcmp( qpLexeme->asChar(), zpBase[ zCurrent].keyword());
			}
      		else
         		zRet = strcmp( qpLexeme->asChar(), zpBase[ zCurrent].keyword());
            }
         if ( zRet < 0)
         	{
            if ( zBot == zCurrent) break;
            zTop = zCurrent;
            }
         else if ( zRet == 0)
         	{
            qpLexeme->setToken( zpBase[ zCurrent].token());
            qpLexeme->setParseToken( zpBase[ zCurrent].parseToken());
            return;
            }
         else
         	{
         	if ( zTop == zCurrent + 1) break;
            zBot = zCurrent;
            }
         }
      }

#  if defined( _Windows) || defined( __WIN32__) || defined( WIN32) || defined( _WINDOWS)
	SSLexTable::SSLexTable( const char* qpszFile, SSBooleanValue qVal) :
		oapExpressionList( 0), oapKeywordList( 0), oulKeywordList( 0)
		{
		qVal;//Unreferenced
#  if defined( __WIN32__) || defined( WIN32)
		HFILE zFile = _lopen( qpszFile, OF_READ);
#  else
		HFILE zFile = _lopen( qpszFile, READ);
#  endif
		if ( zFile == HFILE_ERROR)
			{
			throwException( SSExceptionLexFileOpen, SSLexMsgFileOpen,
				qpszFile, ( SSUnsigned32) HFILE_ERROR);
			return;
			}

		opTable = mallocSS( sizeof( SSLexLexTableHeader));
		if ( _lread( zFile, opTable, sizeof( SSLexLexTableHeader)) == HFILE_ERROR)
			{
			freeSS( opTable);
			_lclose( zFile);
			throwException( SSExceptionLexFileLength, SSLexMsgFileLength, qpszFile, ( SSUnsigned32) HFILE_ERROR);
			return;
			}
		SSLexLexTableHeader* zpTable = ( SSLexLexTableHeader*) opTable;
		if ( zpTable->type() != SSLexTableHeader::unknown)
			if ( zpTable->type() != SSLexTableTypeNewPair)
				{
				freeSS( opTable);
				_lclose( zFile);
				throwException( SSExceptionLexTable, SSLexMsgTable, qpszFile);
				return;
				}

		oulExpressionList = zpTable->size();
		oapExpressionList = new SSLexExpressionListPtr[ zpTable->size()];
		for ( unsigned int i = 0; i < zpTable->size(); i++)
			{
			SSLexPairTableHeader zPairHeader;
			SSUnsigned32 zulTell = _llseek( zFile, 0, 1);
			if ( _lread( zFile, &zPairHeader, sizeof zPairHeader) == HFILE_ERROR)
				{
				freeSS( opTable);
				_lclose( zFile);
				throwException( SSExceptionLexFileLength, SSLexMsgFileLength, qpszFile, ( SSUnsigned32) HFILE_ERROR);
				return;
				}
			void* zpPairTable = mallocSSSpecial( zPairHeader.size());
			_llseek( zFile, zulTell, 0);
			if ( _hread( zFile, ( SSCharHuge) zpPairTable, zPairHeader.size()) == HFILE_ERROR)
				{
				freeSS( opTable);
				_lclose( zFile);
				throwException( SSExceptionLexFileLength, SSLexMsgFileLength, qpszFile, ( SSUnsigned32) HFILE_ERROR);
				return;
				}
			if ((( SSLexTableHeader*) zpPairTable)->open())
				{
				freeSS( opTable);
				_lclose( zFile);
				throwException( SSExceptionLexTable, SSLexMsgTable, qpszFile);
				return;
				}
			oapExpressionList[ i] = new SSLexExpressionList(( void*) zpPairTable);
			}

		readKeyword( zpTable, zFile, qpszFile);
		_lclose( zFile);
		SSAux();
		}

	void SSLexTable::readKeyword( SSLexLexTableHeader* qpTable, HFILE qFile, const char* qpszFile)
   	{
		if ( !qpTable->keywordSize()) return;
		oulKeywordList = qpTable->keywordSize();
		oapKeywordList = ( SSLexKeywordTable**) new SSLexKeywordListPtr[ qpTable->keywordSize()];
		for ( unsigned int i = 0; i < qpTable->keywordSize(); i++)
		{
			SSLexKeywordTable zKey;
			SSUnsigned32 zulTell = _llseek( qFile, 0, 1);
			if ( _hread( qFile, ( SSCharHuge) &zKey, sizeof( SSLexKeywordTable)) == HFILE_ERROR)
				throwException( SSExceptionLexKeywordRead, SSLexMsgKeywordRead, qpszFile);

#if defined( SSBIGENDIAN)
			SSLittleToBigEndian( &zKey, sizeof zKey);
#endif

			oapKeywordList[ i] = ( SSLexKeywordTable*) malloc( zKey.size());
			_llseek( qFile, zulTell, 0);
			if ( _hread( qFile, ( SSCharHuge) oapKeywordList[ i], zKey.size()) == HFILE_ERROR)
				throwException( SSExceptionLexKeywordRead, SSLexMsgKeywordRead, qpszFile);

#if defined( SSBIGENDIAN)
			memcpy( oapKeywordList[ i], &zKey, sizeof zKey);
#endif

#if defined( SSCONVERTTABLE) || defined( SSBIGENDIAN)
			convert( oapKeywordList, i);
#endif

			formatKeyword( oapKeywordList[ i]);
		}
	}

	SSLexTable::SSLexTable( unsigned int qhInst, const char* qpszName,
		const char* qpszType) :	oapExpressionList( 0), oapKeywordList( 0), oulKeywordList( 0)
		{
		HGLOBAL zhRes;
		SSCharHuge zpRes = 0;
		HINSTANCE zhInst = ( HINSTANCE) qhInst;
		HRSRC zRsc = ::FindResourceA( zhInst, qpszName, qpszType);
		if ( zRsc)
		{
			zhRes = LoadResource( zhInst, zRsc);
			if ( zhRes)
				zpRes = ( SSCharHuge) LockResource( zhRes);
		}
		else
		{
#if defined( _MSC_VER) && defined( _DEBUG)
//			LPVOID lpMessageBuffer;
//			FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMessageBuffer,  0,  NULL);
//			CString z_msg;
//			z_msg += ( char*) lpMessageBuffer;
//			LocalFree( lpMessageBuffer);
#endif
		}


		if ( !zpRes)
			{
			throwException( SSExceptionLexResource, SSLexMsgResource, qpszName);
			return;
			}

		format( zpRes, qpszName);
		FreeResource( zhRes);
		}
#  endif

	SSLexTable::SSLexTable( void* qpTable, const char* qpszName)
		{
		format(( SSCharHuge) qpTable, qpszName);
		}

	void SSLexTable::format( SSCharHuge zpRes, const char* qpszName)
		{
		opTable = mallocSS( sizeof( SSLexLexTableHeader));
		memcpy( opTable, zpRes, sizeof( SSLexLexTableHeader));
		zpRes += sizeof( SSLexLexTableHeader);
#if defined( SSBIGENDIAN)
#  include<ssltblx0.cpp>
#endif

		SSLexLexTableHeader* zpTable = ( SSLexLexTableHeader*) opTable;
		if ( zpTable->type() != SSLexTableHeader::unknown)
			if ( zpTable->type() != SSLexTableTypeNewPair)
				{
				freeSS( opTable);
				throwException( SSExceptionLexTable, SSLexMsgTable, qpszName);
				return;
				}

		oulExpressionList = zpTable->size();
		oapExpressionList = new SSLexExpressionListPtr[ zpTable->size()];
		for ( unsigned int i = 0; i < zpTable->size(); i++)
			{
			SSLexPairTableHeader zPairHeader;
			copySSResource(( SSCharHuge) &zPairHeader, zpRes, sizeof( zPairHeader));
#if defined( SSBIGENDIAN)
#  include<ssltblx1.cpp>
#endif
			SSCharHuge zpPairTable = ( SSCharHuge) mallocSSSpecial( zPairHeader.size());
			copySSResource( zpPairTable, zpRes, zPairHeader.size());
			zpRes += zPairHeader.size();

#if defined( SSBIGENDIAN)
#  include<ssltblx2.cpp>
#endif

#if defined( SSCONVERTTABLE)
			convert(( SSLexPairTableHeader*&) zpPairTable);
#endif

			if ((( SSLexTableHeader*) zpPairTable)->open())
				{
				freeSS( opTable);
				throwException( SSExceptionLexTable, SSLexMsgTable, qpszName);
				return;
				}
			oapExpressionList[ i] = new SSLexExpressionList(( void*) zpPairTable);
			}

		readKeyword( zpTable, zpRes);
		SSAux();
		}

	void SSLexTable::readKeyword( SSLexLexTableHeader* qpTable, SSCharHuge qpPos)
   	{
		if ( !qpTable->keywordSize()) return;
		oulKeywordList = qpTable->keywordSize();
		oapKeywordList = ( SSLexKeywordTable**) new SSLexKeywordListPtr[ qpTable->keywordSize()];
		for ( unsigned int i = 0; i < qpTable->keywordSize(); i++)
		{
			SSLexKeywordTable zKey;
			copySSResource(( SSCharHuge) &zKey, qpPos, sizeof zKey);

#if defined( SSBIGENDIAN)
			SSLittleToBigEndian( &zKey, sizeof zKey);
#endif

			oapKeywordList[ i] = ( SSLexKeywordTable*) malloc( zKey.size());
			copySSResource(( SSCharHuge) oapKeywordList[ i], qpPos, zKey.size());
			qpPos += zKey.size();

#if defined( SSBIGENDIAN)
			memcpy( oapKeywordList[ i], &zKey, sizeof zKey);
#endif

#if defined( SSCONVERTTABLE) || defined( SSBIGENDIAN)
			convert( oapKeywordList, i);
#endif

			formatKeyword( oapKeywordList[ i]);
		}
	}

   SSLexTable::~SSLexTable( void)
      {
	  unsigned int i = 0;
      for ( i = 0; i < oulExpressionList; i++)
         delete oapExpressionList[ i];
      delete [] oapExpressionList;
      for ( i = 0; i < oulKeywordList; i++)
         free( oapKeywordList[ i]);
      delete [] oapKeywordList;
      freeSS( opTable);
      }

	void copySSResource( SSCharHuge qpStor, SSCharHuge qpRes, SSUnsigned32 qulTot)
		{
#	if defined( SSFlat)
		SSUnsigned32 zulThresh = SSLexTableThresh;
#	else
		SSUnsigned32 zulMax = SSOffset( qpStor) > SSOffset( qpRes) ?
			SSOffset( qpStor) : SSOffset( qpRes);
		SSUnsigned32 zulThresh = 65536 - zulMax;
#  endif
		do
			{
			if ( qulTot > zulThresh)
				{
				SSUnsigned32 zulLen = zulThresh;
				qulTot -= zulThresh;
				if ( zulLen == SSLexTableThresh)
					{
					SSUnsigned32 zulHalf = zulLen / 2;
					memcpy( qpStor, qpRes, zulHalf);
					qpRes += zulHalf;
					qpStor += zulHalf;
					memcpy( qpStor, qpRes, zulHalf);
					qpRes += zulHalf;
					qpStor += zulHalf;
					}
				else
					{
					memcpy( qpStor, qpRes, zulLen);
					qpRes += zulLen;
					qpStor += zulLen;
					}
#	if defined( SSFlat)
				zulThresh = SSLexTableThresh;
#	else
				zulMax = SSOffset( qpStor) > SSOffset( qpRes) ?
					SSOffset( qpStor) : SSOffset( qpRes);
				zulThresh = 65536 - zulMax;
#  endif
				}
			else
				{
				memcpy( qpStor, qpRes, qulTot);
				qpRes += qulTot;
				qulTot = 0;
				}
			}
		while ( qulTot);
		}

	SSUnsigned32 readSSFile( void* qpStor, SSUnsigned32 qulLen, FILE* qpFile)
		{
		SSUnsigned32 zulRead;
		SSUnsigned32 zulLen = qulLen;
#	if defined( SSFlat)
		SSUnsigned32 zulThresh = SSLexTableThresh;
#	else
		SSUnsigned32 zulThresh = 65536 - SSOffset( qpStor);
#  endif
		SSCharHuge zpStor = ( SSCharHuge) qpStor;

		do
			{
			if ( qulLen > zulThresh)
				{
				qulLen -= zulThresh;
				if ( zulThresh == SSLexTableThresh)
					{
					SSUnsigned32 zulHalf = zulThresh / 2;
					zulRead = fread( zpStor, 1, zulHalf, qpFile);
					if ( !( zulRead))
						return 0;
					zpStor += zulRead;
					zulRead = fread( zpStor, 1, zulHalf, qpFile);
					if ( !( zulRead))
						return 0;
					zpStor += zulRead;
					}
				else
					{
					zulRead = fread( zpStor, 1, zulThresh, qpFile);
					if ( !( zulRead))
						return 0;
					zpStor += zulRead;
					}
				zulThresh = SSLexTableThresh;
				}
			else
				{
				zulLen = qulLen;
				qulLen = 0;
				zulRead = fread( zpStor, 1, zulLen, qpFile);
				if ( !( zulRead))
					return 0;
				zpStor += zulRead;
				}
			}
		while ( qulLen);
		return 1;
		}

	SSBooleanValue SSLexTableHeader::open( void)
		{
		if ( type() == pair || type() == SSLexTableTypeNewPair)
			{
			(( SSLexPairTableHeader*) this)->open();
			return SSFalse;
			}
		else
			return SSTrue;
		}

	void SSLexPairTableHeader::open( void)
		{
		opIndex = ( SSLexPairTableIndex*) (( char*) this + oulIndex);
      opFinal = ( SSLexFinalState*) (( char*) this + oulFinal);
		for ( unsigned int i = 0; i < rows(); i++)
         {
         SSLexPairTableRowHuge zpRow = ( SSLexPairTableRowHuge)
            (( SSCharHuge) this + opIndex[ i].rowOffset());
         opIndex[ i].opRow = zpRow;
         }
		}

   inline SSUnsigned32 SSLexPairTableHeader::lookupState( SSUnsigned32 qulRow,
      SSUnsigned32 qulTrans) const
      {
      SSLexPairTableRow* zpRow = ( opIndex + qulRow)->row();
      SSLexPairTableRowEntry* zpEntry = zpRow->entry();
      for ( unsigned int i = 0; i < zpRow->size(); i++, zpEntry++)
         {
         if ( qulTrans < zpEntry->start()) return SSLexStateInvalid;
         if ( qulTrans <= zpEntry->end()) return zpEntry->state();
         }
		return SSLexStateInvalid;
      }

   inline SSUnsigned32 SSLexTableHeader::lookupState( SSUnsigned32 qulRow,
      SSUnsigned32 qulTrans) const
      {
      return (( SSLexPairTableHeader*) this)->lookupState( qulRow, qulTrans);
      }

   inline SSLexFinalState& SSLexPairTableHeader::lookupFinal( 
		SSUnsigned32 qulState) const
      {
      return opFinal[ qulState];
      }

   inline SSLexFinalState& SSLexTableHeader::lookupFinal( 
		SSUnsigned32 qulState) const
		{
		return (( SSLexPairTableHeader*) this)->lookupFinal( qulState);
		}

	SSLexIterator::SSLexIterator( void* qpDummy, SSBooleanValue qWhere) :
		SSLexExpressionList( qpDummy, qWhere)
		{
		}

	SSLexIterator::SSLexIterator( SSCharHuge& qpLar, const char* qpszName, SSBooleanValue qConvert) :
		SSLexExpressionList( 0)
		{
		SSCharHuge zpRes = qpLar;
		if ( qpszName)
			{
			SSLexPairTableHeader zPairHeader;
			memcpy( &zPairHeader, zpRes, sizeof( zPairHeader));
#if defined( SSBIGENDIAN)
			if ( qConvert)
			{
#  include<ssltblx1.cpp>
			}
#endif
			SSCharHuge zpPairTable = ( SSCharHuge) mallocSSSpecial( zPairHeader.size());
			copySSResource( zpPairTable, zpRes, zPairHeader.size());
			qpLar += zPairHeader.size();
#if defined( SSBIGENDIAN)
			if ( qConvert)
			{
#  include<ssltblx2.cpp>
			}
#endif

#if defined( SSCONVERTTABLE)
			SSLexTable::convert(( SSLexPairTableHeader*&) zpPairTable);
#endif

			if ((( SSLexTableHeader*) zpPairTable)->open())
				{
				freeSSSpecial( zpPairTable, (( SSLexTableHeader*) zpPairTable)->size());
				throwException( SSExceptionLexTable, SSLexMsgTable, qpszName);
				return;
				}
			opTable = zpPairTable;
			}
		}

	SSBooleanValue SSLexIterator::lookupNext( SSUnsigned32& qulState,
		SSUnsigned32 qulTrans) const
		{
		qulState = (( SSLexTableHeader*) opTable)->lookupState( qulState, qulTrans);
		return qulState == SSLexStateInvalid ? SSFalse : SSTrue;
		}

	SSLexFinalState& SSLexIterator::lookupFinal( SSUnsigned32 qulState) const
		{
		return (( SSLexTableHeader*) opTable)->lookupFinal( qulState);
		}

	SSLex::SSLex( const char* qpszFile) : opConsumer( 0), opTable( 0),
		opIterator( 0), oOwnConsumer( SSFalse), oOwnTable( SSFalse),
		oulLexemesValid( 0)
		{
		open();
		SSTryIn
			{
			if ( qpszFile)
				setConsumer( qpszFile);
			}
		SSCatchIn( zExcept)
			{
			delete ( SSLexExpressionListStack*) opExpressionListStack;
			SSRethrow( zExcept);
			}
		SSCatchEndIn
		}

	SSLex::SSLex( const char* qpszConsumer, const char* qpszTable) :
		oOwnConsumer( SSFalse), oOwnTable( SSFalse), oulLexemesValid( 0),
		opTable( 0), opConsumer( 0)
		{
		open();
		SSTryIn
			{
			setTable( qpszTable);
			setConsumer( qpszConsumer);
			}
		SSCatchIn( zExcept)
			{
			if ( oOwnTable) delete opTable;
			if ( oOwnConsumer) delete opConsumer;
			delete ( SSLexExpressionListStack*) opExpressionListStack;
			SSRethrow( zExcept);
			}
		SSCatchEndIn
		}

	SSLex::SSLex( SSLexConsumer& qConsumer, SSLexTable& qTable) :
		oOwnConsumer( SSFalse), oOwnTable( SSFalse), oulLexemesValid( 0),
		opTable( 0), opConsumer( 0)
		{
		open();
		setTable( qTable);
		setConsumer( qConsumer);
		}

	void SSLex::setTable( const char* qpszTable)
		{
		opTable = new SSLexTable( qpszTable);
		if ( setException( opTable->getException())) return;
		oOwnTable = SSTrue;
		pushExpressionList( *opTable->expressionList());
		}

	void SSLex::setConsumer( const char* qpszFile)
		{
		opConsumer = new SSLexFileConsumer( qpszFile);
		if ( setException( opConsumer->getException())) return;
		oOwnConsumer = SSTrue;
		}

	void SSLex::open( void)
		{
		opExpressionListStack = new SSLexExpressionListStack;
		}

	void SSLex::reset( void)
		{
		SSLexExpressionListStack* zpStack =
			( SSLexExpressionListStack*) opExpressionListStack;
		zpStack->pop( zpStack->elements());
		pushExpressionList( *opTable->expressionList());
		}

	SSLexLexeme* SSLex::error( SSLexConsumer& qConsumer)
		{
		qConsumer;//Unreferenced
		SSLexLexeme* zpLexeme = consumer()->lexemeToCurrent();
		throwException( SSExceptionLexError, SSLexMsgError, zpLexeme->line(),
			zpLexeme->offset(), zpLexeme->asConstChar());
		return 0;
		}

	SSLexLexeme* SSLex::complete( SSLexConsumer& qConsumer,
      SSUnsigned32 qulToken, SSLexMark& qMark)
      {
      return qConsumer.lexemeToMark( qMark, qulToken);
      }

	SSLexLexeme* SSLex::ignore( SSLexConsumer& qConsumer,
      SSUnsigned32 qulToken, SSLexMark& qMark)
      {
      qulToken;//Unreferenced
      qConsumer.flushLexeme( qMark);
      return 0;
      }

	SSLexLexeme* SSLex::operator++( int qiDummy)
	{
		qiDummy;//Unreferenced
		if ( !opTable || !opConsumer)
		{
			throwException( SSExceptionLexMissingParm, SSLexMsgMissingParm);
			return 0;
		}

		SSLexMark zFinal;
		SSLexMark zContext;
		SSLexLexeme* zpLexeme;
		SSBooleanValue zConsume;
		SSLexFinalState prevFinal;
		SSLexFinalState contextFinal;

		for ( ;;)
        {
			oulState = 0;
			zpLexeme = 0;
			zConsume = SSFalse;
			prevFinal = iterator().lookupFinal( oulState);
			if ( prevFinal.id())
				zFinal = consumer()->mark();
			while (  ( *consumer())++)
			{
				zConsume = SSTrue;
				consumer()->adjustMark( zFinal);
				consumer()->adjustMark( zContext, SSTrue);
				if ( !iterator().lookupNext( oulState, consumer()->current()))
					break;
				if ( iterator().lookupFinal( oulState).isFinal())
					{
					zFinal = consumer()->mark();
					prevFinal = iterator().lookupFinal( oulState);
            }
            if ( iterator().lookupFinal( oulState).isContextStart())
               zContext = consumer()->mark();
         }
         consumer()->adjustMark( zFinal);
		 consumer()->adjustMark( zContext, SSTrue);

         if ( !zConsume) break;
		 if ( prevFinal.isContextEnd())
			consumer()->flushEndOfLine( zFinal);
         if ( prevFinal.isIgnore())
			{
//          consumer()->flushLexeme( zFinal);
            if ( prevFinal.isPop() && prevFinal.isPush())
               gotoExpressionList( *table()->expressionList( prevFinal.push()));
            else if ( prevFinal.isPop()) 
               popExpressionList();
            else if ( prevFinal.isPush())
               pushExpressionList( *table()->expressionList( prevFinal.push()));
			if ( hasException()) return 0;
			zpLexeme = ignore( *consumer(), prevFinal.token(), zFinal);
			if ( !zpLexeme) continue;
            oulLexemesValid++;
            if ( prevFinal.isParseToken())
            	zpLexeme->setParseToken( prevFinal.parseToken());
            if ( prevFinal.isKeyword())
            	findKeyword( zpLexeme, prevFinal.keyword(), consumer()->type());
            }
         else if ( !prevFinal.isFinal())
            {
            zpLexeme = error( *consumer());
            if ( zpLexeme) break;
            if ( hasException()) return 0;
            consumer()->flushLexeme();
				continue;
            }
         else
            {
            if ( prevFinal.isPop() && prevFinal.isPush())
               gotoExpressionList( *table()->expressionList( prevFinal.push()));
            else if ( prevFinal.isPop()) 
               popExpressionList();
            else if ( prevFinal.isPush())
               pushExpressionList( *table()->expressionList( prevFinal.push()));
            if ( hasException()) return 0;
            if ( prevFinal.isStartOfLine())
				if ( consumer()->line() != 0 && consumer()->offset() != 0)
					consumer()->flushStartOfLine( zFinal);
			zpLexeme = complete( *consumer(), prevFinal.token(), zFinal);
			if ( !zpLexeme) continue;
            oulLexemesValid++;
            if ( prevFinal.isParseToken())
            	zpLexeme->setParseToken( prevFinal.parseToken());
            if ( prevFinal.isKeyword())
            	findKeyword( zpLexeme, prevFinal.keyword(), consumer()->type());
            }

         break;
         }

      return zpLexeme;
      }

	void SSLex::findKeyword( SSLexLexeme* qpLexeme, SSUnsigned32 qTable, SSLexConsumer::SSLexConsumerType qType)
	{
		opTable->findKeyword( qTable, qpLexeme, qType);
	}

   SSBooleanValue SSLex::gotoExpressionList( SSLexExpressionList& qList)
      {
		SSLexExpressionList* zpList = &qList;    
      SSLexExpressionListStack* zpStack = 
         ( SSLexExpressionListStack*) opExpressionListStack;
      zpStack->pop();
      if ( setException( zpStack->getException())) return SSTrue;
      zpStack->push( zpList);
      if ( setException( zpStack->getException())) return SSTrue;
      opIterator = ( SSLexIterator*) &qList;
      return SSFalse;
      }

   SSBooleanValue SSLex::pushExpressionList( SSLexExpressionList& qList)
      {
		SSLexExpressionList* zpList = &qList;
      SSLexExpressionListStack* zpStack = 
         ( SSLexExpressionListStack*) opExpressionListStack;
		zpStack->push( zpList);
      if ( setException( zpStack->getException())) return SSTrue;
      opIterator = ( SSLexIterator*) &qList;
      return SSFalse;
      }

   SSBooleanValue SSLex::popExpressionList( void)
      {
      SSLexExpressionListStack* zpStack = 
         ( SSLexExpressionListStack*) opExpressionListStack;
      zpStack->pop();
      if ( setException( zpStack->getException())) return SSTrue;
      opIterator = ( SSLexIterator*) *zpStack->top();
      if ( setException( zpStack->getException())) return SSTrue;
      return SSFalse;
      }
 
	SSLex::~SSLex( void)
		{
		if ( oOwnTable) delete opTable;
		if ( oOwnConsumer) delete opConsumer;
		delete ( SSLexExpressionListStack*) opExpressionListStack;
		}

	void SSLexLexeme::refFree( void)
      {
      delete this;
      }

   SSUnsigned32 SSLexLexeme::asUnsigned32( SSBooleanValue& qOver) const
      {
      SSUnsigned32 zulLexeme = strtoul( asConstChar(), 0, 10);
      qOver = zulLexeme == ULONG_MAX && errno == ERANGE ? SSTrue : SSFalse;
      return zulLexeme;
      }

   const char* SSLex::tokenToConstChar( SSUnsigned32 qulToken)
      {
	   qulToken;//Unreferenced
      return SSLexTokenNotFound;
      }

   SSLexLexeme* SSLexConsumer::lexemeToMark( SSLexMark& qMark,
      SSUnsigned32 qulToken)
      {
		SSUnsigned32 zulLength = lexemeLength( qMark);
      SSLexLexeme* zpLexeme = new( zulLength) SSLexLexeme( *this, qulToken,
         qMark, SSTrue);
      zpLexeme->refDec( SSFalse);
      flushLexeme( qMark);
      return zpLexeme;
      }

   SSLexLexeme* SSLexConsumer::lexemeToCurrent( void)
      {
      SSLexLexeme* zpLexeme;
      SSUnsigned32 zulLength = oulIndex - oulStart;
      if ( type() == unicode)
         zpLexeme = new( zulLength) SSLexLexeme( zulLength, 0,
            ( SSUnicode*) ( opchBuff + oulStart), oulLine, oulOffset);
      else
         zpLexeme = new( zulLength) SSLexLexeme( zulLength, 0,
            opchBuff + oulStart, oulLine, oulOffset);
	  zpLexeme->setRealOffset( oulShift + oulStart);
      zpLexeme->refDec( SSFalse);
      flushLexeme();
      return zpLexeme;
      }

   SSLexLexeme::SSLexLexeme( SSLexConsumer& qConsumer,
      SSUnsigned32 qulToken, SSLexMark& qMark, SSBooleanValue qBuff) :
      oulLength( qConsumer.lexemeLength( qMark)),
      oulLine( qConsumer.line()), oulOffset( qConsumer.offset()),
      oulToken( qulToken), oOwn( !qBuff), oulParseToken( 0),
	  oulRealOffset( qConsumer.shifted() + qConsumer.start())
      {
      oType = qConsumer.type() == SSLexConsumer::unicode ?
         unicode : character;
      if ( qBuff)
         opchBuff = ( char*) ( this + 1);
      else
         opchBuff = new char[ oulLength + SSLexMinimumCharacterSize];
      memcpy( opchBuff, qConsumer.lexemeBuffer(), oulLength);
      memset( opchBuff + oulLength, 0, SSLexMinimumCharacterSize);
      }

   SSLexLexeme::SSLexLexeme( SSUnsigned32 qulLength,
      SSUnsigned32 qulToken, const char* qpchBuff, SSUnsigned32 qulLine,
      SSUnsigned32 qulOffset, SSBooleanValue qBuff) : oulLength( qulLength),
      oulLine( qulLine), oulOffset( qulOffset), oulToken( qulToken),
      oOwn( !qBuff), oulParseToken( 0), oulRealOffset( 0)
      {
      oType = character;
      if ( qBuff)
         opchBuff = ( char*) ( this + 1);
      else
         opchBuff = new char[ oulLength + SSLexMinimumCharacterSize];
      memcpy( opchBuff, qpchBuff, qulLength);
      memset( opchBuff + qulLength, 0, SSLexMinimumCharacterSize);
      }

   SSLexLexeme::SSLexLexeme( SSUnsigned32 qulLength,
      SSUnsigned32 qulToken, SSUnsigned32 qulLine, SSUnsigned32 qulOffset,
      SSBooleanValue qBuff) : oulLength( qulLength), oulLine( qulLine),
      oulOffset( qulOffset), oulToken( qulToken), oOwn( !qBuff), oulParseToken( 0),
	  oulRealOffset( 0)
      {
      oType = character;
      if ( qBuff)
         opchBuff = ( char*) ( this + 1);
      else
         opchBuff = new char[ oulLength + SSLexMinimumCharacterSize];
      }

   SSLexLexeme::SSLexLexeme( SSUnsigned32 qulLength,
      SSUnsigned32 qulToken, const SSUnicode* qpchBuff, SSUnsigned32 qulLine,
      SSUnsigned32 qulOffset, SSBooleanValue qBuff) : oulLength( qulLength),
      oulLine( qulLine), oOwn( !qBuff), oulOffset( qulOffset),
      oulToken( qulToken), oulParseToken( 0), oulRealOffset( 0)
      {
      oType = unicode;
      if ( qBuff)
         opchBuff = ( char*) ( this + 1);
      else
         opchBuff = new char[ oulLength + SSLexMinimumCharacterSize];
      memcpy( opchBuff, qpchBuff, qulLength);
      memset( opchBuff + qulLength, 0, SSLexMinimumCharacterSize);
      }

   SSLexLexeme::~SSLexLexeme( void)
      {
      if ( oOwn && opchBuff) delete [] opchBuff;
      }

   SSBooleanValue SSLex::isCurrentExpressionList( SSUnsigned32 qulIterator)
      {
      SSLexLexTableHeader* zpHeader = ( SSLexLexTableHeader*) opTable->table();
      if ( qulIterator >= zpHeader->size())
         {
			throwException( SSExceptionLexExpressionList, SSLexMsgIterator, qulIterator);
			return SSFalse;
			}
      SSLexExpressionList* zpList = opIterator;
      return opTable->expressionList( qulIterator) == zpList ? SSTrue : SSFalse;
      }

   SSUnsigned32 SSLex::getCurrentExpressionList( void)
      {
      SSLexLexTableHeader* zpHeader = ( SSLexLexTableHeader*) opTable;
      for ( unsigned int i = 0; i < zpHeader->size(); i++)
		  if ( opTable->expressionList( i) == opIterator)
			  return i;
      throwException( SSExceptionLexGetExpressionList, SSLexMsgGetExpressionList);
	  return 0;
      }

   SSLexExpressionList* SSLexTable::expressionList( SSUnsigned32 qulIndex)
      {
      SSLexLexTableHeader* zpHeader = ( SSLexLexTableHeader*) opTable;
      if ( qulIndex >= zpHeader->size())
         {
			throwException( SSExceptionLexExpressionList, SSLexMsgIterator, qulIndex);
			return 0;
			}
      return oapExpressionList[ qulIndex];
      }

   void SSLexConsumer::addBuffer( char* qpchBuff, SSUnsigned32 qulBuff)
		{
		SSUnsigned32 zulRead = oulLength;
		SSUnsigned32 zulFill = oulBuff - oulLength;

		if ( qulBuff > zulFill)
			if ( shiftBuffer( zulRead, zulFill) && expandBuffer( zulRead, zulFill))
				{
				throwException( SSExceptionLexLexemeLength, SSLexMsgLexemeLength,
					oulLength);
				return;
				}

		while ( zulFill < qulBuff)
			if ( expandBuffer( zulRead, zulFill))
				{
				throwException( SSExceptionLexLexemeLength, SSLexMsgLexemeLength,
					oulLength);
				return;
				}

		memcpy( opchBuff + zulRead, qpchBuff, qulBuff);
		oulLength += qulBuff;
		}

   SSLexExpressionList::~SSLexExpressionList( void)
		{
		if ( oFree)
			freeSSSpecial( opTable, (( SSLexTableHeader*) opTable)->size());
      }

	void SSLexTable::convert( SSLexPairTableHeader*& qpTable)
	{
		SSUnsigned32 zulNew = sizeof( SSLexPairTableHeader) + sizeof( SSLexPairTableIndex) * qpTable->rows();
		SSUnsigned32 zulSize = zulNew + qpTable->size();
		SSLexPairTableHeader* zpNew = ( SSLexPairTableHeader*) mallocSS( zulSize);
		SSLexPairTableHeader* zpMove = ( SSLexPairTableHeader*) (( char*) zpNew + zulNew);
		memcpy( zpMove, qpTable, qpTable->size());
		zpNew->convert(( SSLexPairTableHeaderMap*) qpTable, zulNew);
		SSLexPairTableIndex* zpIndex = ( SSLexPairTableIndex*) ( zpNew + 1);
		SSLexPairTableIndexMap* zpIndexMap = ( SSLexPairTableIndexMap*) (( char*) qpTable + qpTable->oulIndex);
		for ( unsigned int i = 0; i < zpNew->rows(); i++, zpIndex++, zpIndexMap++)
			zpIndex->convert( zpIndexMap, zulNew);
		void* zpDelete = qpTable;
		qpTable = zpNew;
		freeSS( zpDelete);
	}

	void SSLexTable::convert( SSLexKeywordTable** qpKeyArray, int qIndex)
	{
		SSLexKeywordTable* zpKey = qpKeyArray[ qIndex];
		SSUnsigned32 zulNew = sizeof( SSLexKeywordTable) + sizeof( SSLexKeywordIndex) * zpKey->indexSize();
		SSUnsigned32 zulSize = zulNew + zpKey->size();
		SSLexKeywordTable* zpNew = ( SSLexKeywordTable*) mallocSS( zulSize);
		SSLexKeywordTable* zpMove = ( SSLexKeywordTable*) (( char*) zpNew + zulNew);
		memcpy( zpMove, zpKey, zpKey->size());
		SSLexKeywordIndex* zpIndex = ( SSLexKeywordIndex*) ( zpNew + 1);
		SSLexKeywordIndexMap* zpIndexMap = ( SSLexKeywordIndexMap*) ( zpKey + 1);
		for ( unsigned int i = 0; i < zpKey->indexSize(); i++, zpIndex++)
			zpIndex->convert( zpIndexMap, zulNew);
		void* zpDelete = zpKey;
		qpKeyArray[ qIndex] = zpNew;
		freeSS( zpDelete);
	}

	void SSLexKeywordIndex::convert( SSLexKeywordIndexMap* qpMap, SSUnsigned32 qShift)
	{
		memcpy( &oToken, &qpMap->oToken, sizeof qpMap->oToken);
		memcpy( &oKeyword, &qpMap->oKeyword, sizeof qpMap->oKeyword);
		memcpy( &oParseToken, &qpMap->oParseToken, sizeof qpMap->oParseToken);
		memcpy( &oKeywordWide, &qpMap->oKeywordWide, sizeof qpMap->oKeywordWide);
		memcpy( &oReserved, &qpMap->oReserved, sizeof qpMap->oReserved);
#if defined( SSBIGENDIAN)
		SSLittleToBigEndian( &oToken, sizeof oToken);
		SSLittleToBigEndian( &oKeyword, sizeof oKeyword);
		SSLittleToBigEndian( &oParseToken, sizeof oParseToken);
		SSLittleToBigEndian( &oKeywordWide, sizeof oKeywordWide);
		SSLittleToBigEndian( &oReserved, sizeof oReserved);
#endif
//		oToken = SSCharToUnsigned32( qpMap->oToken);
//		oKeyword = SSCharToUnsigned32( qpMap->oKeyword) + qShift;
//		oParseToken = SSCharToUnsigned32( qpMap->oParseToken);
//		oKeywordWide = SSCharToUnsigned32( qpMap->oKeywordWide) + qShift;
	}

   void SSLexPairTableHeader::convert( SSLexPairTableHeaderMap* qpMap, SSUnsigned32 qShift)
   {
	   oulType = SSCharToUnsigned32( qpMap->oType);
	   oulSize = SSCharToUnsigned32( qpMap->oSize);
	   memcpy( SSLexTableHeader::aoulReserved, qpMap->oReserved0, sizeof qpMap->oReserved0);
	   oulRows = SSCharToUnsigned32( qpMap->oRows);
	   oulPush = SSCharToUnsigned32( qpMap->oPush);
	   oulIndex = sizeof( SSLexPairTableHeader);
	   oulFinal = SSCharToUnsigned32( qpMap->oFinal) + qShift;
	   memcpy( ulReserved, qpMap->oReserved1, sizeof qpMap->oReserved1);
   }

   void SSLexPairTableIndex::convert( SSLexPairTableIndexMap* qpMap, SSUnsigned32 qShift)
   {
	   oulRow = SSCharToUnsigned32( qpMap->oRow) + qShift;
   }

/*---------------------------------------------------------------------------

               Copyright (c) 1994-1999 SandStone Technology Inc.
                          All rights reserved

      THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
      OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
      DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
