/*---------------------------------------------------------------------------

               Copyright (c) 1994-1997 SandStone Technology Inc.
                          All rights reserved

----------------------------------------------------------------------------*/
#if !defined( SSLEX)
#  define SSLEX
#if defined( _Windows) || defined( __WIN32__) || defined( WIN32) || defined( _WINDOWS)
#  pragma warning( disable: 4291)
#endif
#  include<stdio.h>
#  include<malloc.h>
#  include<sssto.hpp>
#  include<ssref.hpp>
#  include<ssglobal.h>
#  include<ssdbcs.hpp>
#  include<ssexcept.hpp>

#  define SSLexConsumerDefaultInc   0
#  define SSLexConsumerAll          0xffffffff
#  define SSLexConsumerDefaultSize  SSLexConsumerAll

#  define SSLexFileModeCharacter    "r"
#  define SSLexFileModeBinary       "rb"
#  define SSLexFileModeUnicode      "rb"

#  define SSLexMinimumCharacterSize 2
#  define SSLexTokenBof             0xffffffff
#  define SSLexStateInvalid         0xffffffff
#  define SSLexTokenNotFound        "SSLexTokenNotFound"

#  define SSLexMsgFileOpen          "SSLex0101e: Error opening file, %s, %ld"
#  define SSLexMsgFileLength        "SSLex0102e: Invalid file length or read error, %s, %ld"
#  define SSLexMsgLexemeLength      "SSLex0103e: Lexeme too long, %ld"
#  define SSLexMsgTable             "SSLex0104e: Invalid table, %s"
#  define SSLexMsgError             "SSLex0105e: Invalid token, Line %ld, Offset %ld, %s"
#  define SSLexMsgIterator          "SSLex0106e: Invalid expression list index, %ld"
#  define SSLexMsgMissingParm       "SSLex0107e: Table or consumer missing, required"
#  define SSLexMsgResource          "SSLex0108e: Resource not found, %s"
#  define SSLexMsgKeywordRead			"SSLex0109e: Unable to read keyword table, %s"
#  define SSLexMsgKeywordIndex		"SSLex0110e: Invalid keyword index, %ld"
#  define SSLexMsgGetExpressionList "SSLex0111e: getExpressionList failed"

	class SSClass SSLex;
	class SSClass SSLexMark;
	class SSClass SSLexTable;
	class SSClass SSLexLexeme;
	class SSClass SSLexConsumer;
	class SSClass SSLexIterator;
   class SSClass SSLexKeywordTable;
	class SSClass SSLexFileConsumer;
	class SSClass SSLexStringConsumer;
	class SSClass SSLexExpressionList;
   class SSClass SSLexLexTableHeader;
	class SSClass SSLexAutoFileConsumer;
	class SSLexPairTableHeader;

   void SSAux( void);
   typedef SSLexKeywordTable* SSLexKeywordListPtr;
   typedef SSLexExpressionList* SSLexExpressionListPtr;

	class SSClass SSLexMark
		{
		friend class SSLexConsumer;

		public:
			SSInline SSConstr SSLexMark( void);
			SSUnsigned32      line( void) { return oulLine;}
			SSUnsigned32      offset( void) { return oulOffset;}

		private:
			SSUnsigned32      oulMark;
			SSUnsigned32      oulLine;
			SSUnsigned32      oulOffset;
		};

	class SSClass SSLexExpressionList : public SSExceptionPresent
		{
		public:
			SSInline SSConstr SSLexExpressionList( void*, SSBooleanValue = SSTrue);
			SSDestr  			SSLexExpressionList( void);

		protected:
			SSBooleanValue    oFree;
			void*             opTable;
		};

	class SSClass SSLexLexeme : public SSRefCount, public SSExceptionPresent
		{
		public:

			enum SSLexLexemeType
				{
				unicode,
				character
				};

			SSInline SSConstr   SSLexLexeme( void);
			SSInline SSConstr   SSLexLexeme( SSUnsigned32);
			SSInline SSConstr   SSLexLexeme( SSUnsigned32, SSUnsigned32);
			SSConstr            SSLexLexeme( SSLexConsumer&, SSUnsigned32,
										  SSLexMark&, SSBooleanValue = SSFalse);
			SSConstr            SSLexLexeme( SSUnsigned32, SSUnsigned32,
										  SSUnsigned32, SSUnsigned32,
										  SSBooleanValue = SSFalse);
			SSConstr            SSLexLexeme( SSUnsigned32, SSUnsigned32,
										  const char*, SSUnsigned32, SSUnsigned32,
										  SSBooleanValue = SSFalse);
			SSConstr            SSLexLexeme( SSUnsigned32, SSUnsigned32,
										  const SSUnicode*, SSUnsigned32, SSUnsigned32,
										  SSBooleanValue = SSFalse);

			SSInline void*               operator new( size_t);
			SSInline void                operator delete( void*);
			SSInline void*               operator new( size_t, SSUnsigned32);

			SSInline SSLexLexemeType     type( void) const;
			SSInline SSUnsigned32        line( void) const;
			SSInline SSUnsigned32        token( void) const;
			SSInline SSUnsigned32        offset( void) const;
			SSInline SSUnsigned32        length( void) const;
	        SSInline SSUnsigned32		 realToken( void) const { return oulToken;}
		    SSInline SSUnsigned32		 parseToken( void) const { return oulParseToken;}
	        SSInline SSUnsigned32		 realOffset( void) const { return oulRealOffset;}

			SSInline void                setBuffer( char*);
			SSInline void                setLine( SSUnsigned32);
			SSInline void                setToken( SSUnsigned32);
			SSInline void                setOffset( SSUnsigned32);
			SSInline void                setLength( SSUnsigned32);
			SSInline void                setType( SSLexLexemeType);
			SSInline void				 setRealToken( SSUnsigned32 qulTok) { oulToken = qulTok;}
			SSInline void				 setParseToken( SSUnsigned32 qulTok) { oulParseToken = qulTok;}
			SSInline void                setRealOffset( SSUnsigned32 qulOff) { oulRealOffset = qulOff;}

			SSInline char*               asChar( void) const;
			SSInline SSUnicode*          asUnicode( void) const;
			SSInline const char*         asConstChar( void) const;
			SSInline const SSUnicode*    asConstUnicode( void) const;
			SSInline 					 operator const char*( void);
			SSInline 					 operator const SSUnicode*( void);
			SSInline SSBooleanValue      isEqualLexeme( SSLexLexeme&) const;
			SSUnsigned32                 asUnsigned32( SSBooleanValue&) const;

			void                         refFree( void);
			virtual SSDestr              SSLexLexeme( void);

		protected:
			SSBooleanValue      oOwn;
			SSLexLexemeType     oType;
			SSUnsigned32        oulLine;
			SSUnsigned32        oulToken;
			char*               opchBuff;
			SSUnsigned32        oulLength;
			SSUnsigned32        oulOffset;
			SSUnsigned32		oulRealOffset;
	        SSUnsigned32		oulParseToken;
		};

	class SSClass SSLexConsumer : public SSExceptionPresent
		{
		public:

			enum SSLexConsumerType
				{
				binary,
				unicode,
				character
				};

			SSConstr                   SSLexConsumer( SSLexConsumerType = character);

			SSInline SSLexMark         mark( void);
			SSBooleanValue             operator++( int);
			SSInline SSLexConsumerType type( void) const;
			SSInline SSDbcsInfo&       dbcs( void) const;
			SSInline void              singleByte( void);
			SSInline void              doubleByte( void);
			SSInline void              flushLexeme( void);
			void			           unicodeByte( void);
			SSInline SSUnsigned32	   start( void) const;
			SSInline SSUnsigned32 	   index( void) const;
			SSInline SSUnsigned32	   shifted( void) const;
			SSInline SSUnsigned32      current( void) const;
			SSInline SSUnsigned32      consumed( void) const;
			virtual SSUnsigned32       nextBuffer( void) = 0;
			SSLexLexeme*               lexemeToCurrent( void);
			SSInline SSBooleanValue    endOfData( void) const;
			SSInline void              flushLexeme( SSLexMark&);
			SSInline void			   flushEndOfLine( SSLexMark&);
			SSInline void              flushStartOfLine( SSLexMark&);
			void                       addBuffer( char*, SSUnsigned32);
			SSLexLexeme*               lexemeToMark( SSLexMark&, SSUnsigned32);
			SSBooleanValue             shiftBuffer( SSUnsigned32&, SSUnsigned32&);
			SSBooleanValue             expandBuffer( SSUnsigned32&, SSUnsigned32&);
			SSInline void              adjustMark( SSLexMark&, SSBooleanValue = SSFalse);

			SSInline char*             buffer( void);
			SSInline SSUnsigned32      bufferInc( void);
			SSInline SSUnsigned32      line( void) const;
			SSInline void              setBuffer( char*);
			SSInline SSUnsigned32      offset( void) const;
			SSInline SSUnsigned32      bufferLength( void);
			SSInline void              setEndOfData( void);
			SSInline SSUnsigned32      lexemeLength( void) const;
			SSInline char*             lexemeBuffer( void) const;
			SSInline void              setBufferInc( SSUnsigned32);
			SSInline void              setDataLength( SSUnsigned32);
			SSInline SSUnsigned32      lexemeLength( SSLexMark&) const;
			SSInline void              setBufferLength( SSUnsigned32);

			virtual SSDestr            SSLexConsumer( void);

		protected:
			SSDbcsInfo&            oDbcs;
			SSLexConsumerType      oType;
			SSUnsigned32           oulBof;
			SSUnsigned32           oulInc;
			SSUnsigned32           oulLine;
			SSUnsigned32           oulBuff;
			SSUnsigned32           oulMark;
			SSUnsigned32           oulShift;
			char*                  opchBuff;
			SSUnsigned32           oulStart;
			SSUnsigned32           oulIndex;
			SSUnsigned32           oulLength;
			SSUnsigned32           oulOffset;
			SSUnsigned32           oulCurrent;
			SSBooleanValue         oEndOfData;
			SSUnsigned32           oulConsumed;
			SSUnsigned32           oulScanLine;
			SSUnsigned32           oulMarkLine;
			SSUnsigned32           oulScanOffset;
			SSUnsigned32           oulMarkOffset;
			int					   oReversedUnicode;
		};

	class SSClass SSLexTable : public SSExceptionPresent
		{
		public:
			SSConstr               SSLexTable( const char*);
			SSConstr               SSLexTable( void*, const char*);
			SSConstr               SSLexTable( const char*, SSBooleanValue);
			SSConstr               SSLexTable( unsigned int, const char*, const char*);

			SSInline void*         table( void);
			void                   format( SSCharHuge, const char*);
			SSLexExpressionList*   expressionList( SSUnsigned32 = 0);
	        void                   formatKeyword( SSLexKeywordTable*);
			void                   readKeyword( SSLexLexTableHeader*, SSCharHuge);
#if defined( _Windows) || defined( __WIN32__) || defined( WIN32) || defined( _WINDOWS)
			void                   readKeyword( SSLexLexTableHeader*, HFILE, const char*);
#endif
			void                   readKeyword( SSLexLexTableHeader*, FILE*, const char*);
			void                   findKeyword( SSUnsigned32, SSLexLexeme*, SSLexConsumer::SSLexConsumerType);

			SSDestr                SSLexTable( void);

			static void            convert( SSLexPairTableHeader*&);
			void                   convert( SSLexKeywordTable**, int);

		private:
			void*                  opTable;
			SSLexKeywordTable**    oapKeywordList;
			SSUnsigned32           oulKeywordList;
			SSLexExpressionList**  oapExpressionList;
			SSUnsigned32           oulExpressionList;
		};

	class SSClass SSLexFileConsumer : public SSLexConsumer
		{
		public:
			SSConstr				SSLexFileConsumer( void);
			SSConstr				SSLexFileConsumer( const char*,
									  SSLexConsumerType = character,
									  SSUnsigned32 = SSLexConsumerDefaultSize,
									  SSUnsigned32 = SSLexConsumerDefaultInc);

			SSInline void			close( void);
			SSInline FILE*			file( void) const;
			SSUnsigned32			nextBuffer( void);

			virtual SSDestr			SSLexFileConsumer( void);

		protected:
			FILE*                  opFile;
			SSUnsigned32           oulFile;
		};

	class SSClass SSLexAutoFileConsumer : public SSLexFileConsumer
		{
		public:
			SSConstr               SSLexAutoFileConsumer( const char*,
											  SSUnsigned32 = SSLexConsumerDefaultSize,
											  SSUnsigned32 = SSLexConsumerDefaultInc);
		};

	class SSClass SSLexStringConsumer : public SSLexConsumer
		{
		public:
			SSConstr              SSLexStringConsumer( const char*,
											 SSLexConsumerType = character);
			SSConstr              SSLexStringConsumer( wchar_t*);

			SSUnsigned32          nextBuffer( void);
		};

	class SSClass SSLex : public SSExceptionPresent
		{
		public:
			SSConstr                SSLex( const char* = 0);
			SSConstr                SSLex( const char*, const char*);
			SSConstr                SSLex( SSLexConsumer&, SSLexTable&);

			SSInline void           setTable( SSLexTable&);
			void                    setTable( const char*);
			void                    setConsumer( const char*);
			SSInline void           setConsumer( SSLexConsumer&);

			void                    reset( void);
			SSLexLexeme*            operator++( int);
			SSInline SSLexTable*    table( void) const;
			SSInline SSUnsigned32   lexemesValid( void);
			SSInline SSLexConsumer* consumer( void) const;
			SSBooleanValue          popExpressionList( void);
			SSUnsigned32            getCurrentExpressionList( void);
			SSBooleanValue          isCurrentExpressionList( SSUnsigned32);
			SSBooleanValue          pushExpressionList( SSLexExpressionList&);
			SSBooleanValue          gotoExpressionList( SSLexExpressionList&);

			virtual SSLexLexeme*    error( SSLexConsumer&);
			virtual const char*     tokenToConstChar( SSUnsigned32);
			virtual SSLexLexeme*    ignore( SSLexConsumer&, SSUnsigned32, SSLexMark&);
			virtual SSLexLexeme*    complete( SSLexConsumer&, SSUnsigned32, SSLexMark&);
	      	virtual void			findKeyword( SSLexLexeme*, SSUnsigned32, SSLexConsumer::SSLexConsumerType);

			virtual SSDestr         SSLex( void);

		protected:
			SSLexTable*             opTable;
			SSUnsigned32            oulState;
			SSBooleanValue          oOwnTable;
			SSLexConsumer*          opConsumer;
			SSBooleanValue          oOwnConsumer;
			SSUnsigned32            oulLexemesValid;

		protected:
			void                    open( void);
			SSInline SSLexIterator& iterator( void) const;

			SSLexIterator*          opIterator;
			void*                   opExpressionListStack;
		};

#  if ( _MSC_VER == 800) || defined( SSNOTEMPLATE)                            
#		include<ssreflex.hpp>
#  else
   	typedef SSRef< SSLexLexeme>  SSLexLexemeRef;
#  endif

#if defined( SSBIGENDIAN)
#  include<ssltb.hpp>
#endif

#  include<sslex.inl>

#endif
