/*---------------------------------------------------------------------------

					Copyright (c) 1994-1997 SandStone Technology Inc.
								  All rights reserved

		THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
		OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
		DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
#if !defined( SSLEXTBHPP)
#  define SSLEXTBHPP
#  include<sslex.hpp>

#  define SSLexFinalStateFlagsContextStart 0x00000001
#  define SSLexFinalStateFlagsStartOfLine  0x00000002
#  define SSLexFinalStateFlagsPop          0x00000008
#  define SSLexFinalStateFlagsFinal        0x00000010
#  define SSLexFinalStateFlagsPush         0x00000020
#  define SSLexFinalStateFlagsIgnore       0x00000040
#  define SSLexFinalStateFlagsContextEnd   0x00000080
#  define SSLexFinalStateFlagsReduce		 0x00000100
#	define SSLexFinalStateFlagsKeyword      0x00000200
#	define SSLexFinalStateFlagsParseToken   0x00000400

	SSUnsigned32 readSSFile( void*, SSUnsigned32, FILE*);
	void         copySSResource( SSCharHuge, SSCharHuge, SSUnsigned32);

	struct SSLexKeywordIndexMap;

	class SSClass SSLexFinalState
      {
      friend class SSLexTable;

      public:
         SSConstr          SSLexFinalState( void);

         void              reset( void);

         SSUnsigned32      id( void) const;
         SSUnsigned32      push( void) const;
         SSUnsigned32      token( void) const;
         SSUnsigned32		keyword( void) const;
         SSUnsigned32		parseToken( void) const;

         SSBooleanValue    isPop( void) const;
         SSBooleanValue    isPush( void) const;
         SSBooleanValue    isFinal( void) const;
         SSBooleanValue    isIgnore( void) const;
         SSBooleanValue    isReduce( void) const;
         SSBooleanValue		isKeyword( void) const;
			SSBooleanValue    isContextEnd( void) const;
         SSBooleanValue		isParseToken( void) const;
         SSBooleanValue    isStartOfLine( void) const;
         SSBooleanValue    isContextStart( void) const;

      protected:
         SSUnsigned32      oulId;
         SSUnsigned32      oulPush;
			SSUnsigned32      oulFlags;
         SSUnsigned32      oulReserved[ 4];
      };

   SSInline void SSLexFinalState::reset( void)
      {
      oulId = 0;
      oulPush = 0;
      oulFlags = 0;
      }

   SSInline SSUnsigned32 SSLexFinalState::token( void) const
      {
      return oulId;
      }

   SSInline SSBooleanValue SSLexFinalState::isStartOfLine( void) const
      {
      return oulFlags & SSLexFinalStateFlagsStartOfLine ? SSTrue : SSFalse;
      }

   SSInline SSLexFinalState::SSLexFinalState( void) : oulId( 0), oulPush( 0),
      oulFlags( 0)
		{
      }

   SSInline SSUnsigned32 SSLexFinalState::id( void) const
      {
      return oulId;
      }

   SSInline SSUnsigned32 SSLexFinalState::keyword( void) const
      {
      return oulReserved[ 0];
      }

   SSInline SSUnsigned32 SSLexFinalState::parseToken( void) const
      {
      return oulReserved[ 1];
      }

   SSInline SSBooleanValue SSLexFinalState::isPop( void) const
      {
      return oulFlags & SSLexFinalStateFlagsPop ? SSTrue : SSFalse;
      }

   SSInline SSBooleanValue SSLexFinalState::isPush( void) const
      {
      return oulFlags & SSLexFinalStateFlagsPush ? SSTrue : SSFalse;
      }

   SSInline SSBooleanValue SSLexFinalState::isFinal( void) const
      {
      return oulFlags & SSLexFinalStateFlagsFinal ? SSTrue : SSFalse;
      }

	SSInline SSBooleanValue SSLexFinalState::isIgnore( void) const
      {
      return oulFlags & SSLexFinalStateFlagsIgnore ? SSTrue : SSFalse;
      }

	SSInline SSBooleanValue SSLexFinalState::isKeyword( void) const
      {
      return oulFlags & SSLexFinalStateFlagsKeyword ? SSTrue : SSFalse;
      }

   SSInline SSBooleanValue SSLexFinalState::isContextStart( void) const
      {
      return oulFlags & SSLexFinalStateFlagsContextStart ? SSTrue : SSFalse;
      }

   SSInline SSBooleanValue SSLexFinalState::isParseToken( void) const
      {
      return oulFlags & SSLexFinalStateFlagsParseToken ? SSTrue : SSFalse;
      }

   SSInline SSBooleanValue SSLexFinalState::isContextEnd( void) const
      {
      return oulFlags & SSLexFinalStateFlagsContextEnd ? SSTrue : SSFalse;
      }

	SSInline SSBooleanValue SSLexFinalState::isReduce( void) const
		{
		return oulFlags & SSLexFinalStateFlagsReduce ? SSTrue : SSFalse;
      }

	SSInline SSUnsigned32 SSLexFinalState::push( void) const
      {
      return oulPush;
		}

   class SSClass SSLexIterator : public SSLexExpressionList
      {
      public:
			SSConstr             SSLexIterator( SSCharHuge&, const char*, SSBooleanValue = SSTrue);
			SSConstr             SSLexIterator( void*, SSBooleanValue = SSTrue);

			SSLexFinalState&     lookupFinal( SSUnsigned32) const;
			SSBooleanValue       lookupNext( SSUnsigned32&, SSUnsigned32) const;
		};

	class SSLexKeywordTable
		{
		public:
										SSLexKeywordTable( void) { oSize = 0; oIndexSize = 0;}

         void						format( void);
     		SSUnsigned32			size( void) { return oSize;}
     		SSUnsigned32			indexSize( void) { return oIndexSize;}
   		void						setSize( SSUnsigned32 qSize) { oSize = qSize;}
   		void						setIndexSize( SSUnsigned32 qIndexSize) { oIndexSize = qIndexSize;}
      	void						init( void) { oSize = 0; oIndexSize = 0; memset( oReserved, 0, sizeof oReserved);}

		protected:
      	SSUnsigned32			oSize;
         SSUnsigned32			oIndexSize;
	   	SSUnsigned32			oReserved[ 8];
		};

#  if defined( _MSC_VER)
#     pragma pack(1)
#  endif
   class SSLexKeywordIndex
   	{
      public:
      								SSLexKeywordIndex( void) { oToken = 0; opKeyword = 0; oKeyword = 0; oNocase = 0; oParseToken = 0;}

   		SSUnsigned32&			token( void) { return oToken;}
         unsigned char			isNocase( void) { return oNocase;}
      	const char*				keyword( void) { return opKeyword;}
         SSUnsigned32			keywordIndex( void) { return oKeyword;}
   		SSUnsigned32&			parseToken( void) { return oParseToken;}
      	wchar_t*					keywordWide( void) { return opKeywordWide;}
         SSUnsigned32			keywordWideIndex( void) { return oKeywordWide;}
         void						setNocase( unsigned char qVal) { oNocase = qVal;}
      	void						setToken( SSUnsigned32 qToken) { oToken = qToken;}
      	void						setKeyword( char* qpKeyword) { opKeyword = qpKeyword;}
      	void						setKeywordIndex( SSUnsigned32 qKeyword) { oKeyword = qKeyword;}
      	void						setParseToken( SSUnsigned32 qToken) { oParseToken = qToken;}
      	void						setKeywordWide( wchar_t* qpKeyword) { opKeywordWide = qpKeyword;}
      	void						setKeywordWideIndex( SSUnsigned32 qKeyword) { oKeywordWide = qKeyword;}
		void						convert( SSLexKeywordIndexMap*, SSUnsigned32);

      protected:
      	SSUnsigned32			oToken;
      	unsigned char			oNocase;
        	SSUnsigned32			oKeyword;
         char*						opKeyword;
         SSUnsigned32			oParseToken;
         SSUnsigned32			oKeywordWide;
         wchar_t*					opKeywordWide;
         SSUnsigned32			oReserved[ 4];
      };
#  if defined( _MSC_VER)
#     pragma pack()
#  endif

	struct SSLexKeywordIndexMap
	{
		char			oToken[ 4];
		unsigned char	oNocase;
		char			oKeyword[ 4];
		char			opKeyword[ 4];
		char			oParseToken[ 4];
		char			oKeywordWide[ 4];
		char			opKeywordWide[ 4];
		char			oReserved[ 16];
	};

#endif
