/*---------------------------------------------------------------------------

					Copyright (c) 1994 - 1997 SandStone Technology Inc.
								  All rights reserved

		THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
		OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
		DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
#if !defined( SSLIFO)
#  define SSLIFO
#  include<ssexcept.hpp>
#  if defined( __BORLANDC__)
#     pragma warn -inl
#  endif

#  define SSLifoArraySize 32
#  define SSLifoArrayInc  32
#  define SSLifoMsgFull   "SSLifo0001e: Stack full"
#  define SSLifoMsgTop    "SSLifo0002e: No top, stack empty"
#  define SSLifoMsgArray  "SSLifo0003e: Invalid index"
#  define SSLifoMsgPop    "SSLifo0004e: Cannot pop empty stack"   

#  if !( _MSC_VER == 800) && !defined( SSNOTEMPLATE)

   template< class T> class SSLifoArray : public SSExceptionPresent
      {
      public:
         SSConstr         SSLifoArray( SSUnsigned32 = SSLifoArraySize,
                             SSUnsigned32 = SSLifoArrayInc);
         SSConstr         SSLifoArray( const SSLifoArray< T>&);

         SSBooleanValue   push( T&);
         T*               top( void);
         SSUnsigned32     size( void) const;
         SSBooleanValue   isEmpty( void) const;
         SSUnsigned32     elements( void) const;
         SSBooleanValue   pop( SSUnsigned32 = 1);
         T*               operator[]( SSUnsigned32);
         void             copy( const SSLifoArray< T>&);
         SSLifoArray< T>& operator=( const SSLifoArray< T>&);

         SSDestr          SSLifoArray( void);

      private:
         T*               opTop;
         SSUnsigned32     oulInc;
         SSUnsigned32     oulTop;
         T*               opArray;
         SSUnsigned32     oulSize;
      };

   template< class T> SSInline SSLifoArray< T>::SSLifoArray( SSUnsigned32 qulSize,
      SSUnsigned32 qulInc)
      {
      opTop = opArray = new T[ qulSize];
      oulSize = qulSize;
      oulInc = qulInc;
      oulTop = 0;
      opTop--;
      }

   template< class T> SSInline SSLifoArray< T>::SSLifoArray(
      const SSLifoArray< T>& qStack)
      {
      copy( qStack);
      }

   template< class T> SSInline void SSLifoArray< T>::copy(
      const SSLifoArray< T>& qStack)
      {
      opTop = opArray = new T[ qStack.size()];
      for ( unsigned int i = 0; i < qStack.elements(); i++)
         opArray[ i] = qStack.opArray[ i];
	  oulTop = qStack.elements();
	  if ( oulTop)
         opTop += oulTop - 1;
      oulSize = qStack.size();
      oulInc = qStack.oulInc;
      }

   template< class T> SSInline SSLifoArray< T>& SSLifoArray< T>::operator=(
      const SSLifoArray< T>& qArray)
      {
      T* zpArray = opArray;
      copy( qArray);
      delete [] zpArray;
      return *this;
      }

   template< class T> SSInline SSBooleanValue SSLifoArray< T>::
      isEmpty( void) const
      {
      return oulTop == 0 ? SSTrue : SSFalse;
      }

   template< class T> SSInline SSUnsigned32 SSLifoArray< T>::size( void) const
      {
      return oulSize;
      }

   template< class T> SSInline SSUnsigned32 SSLifoArray< T>::
      elements( void) const
      {
      return oulTop;
      }

   template< class T> SSInline SSBooleanValue SSLifoArray< T>::push( T& qT)
      {
      if ( oulTop + 1 > oulSize)
         {
         if ( !oulInc) 
            {
            throwException( SSExceptionLifoFull, SSLifoMsgFull);
            return SSTrue;
            }
         T* zpNew = new T[ oulSize + oulInc];
         for ( unsigned int i = 0; i < oulSize; i++)
            zpNew[ i] = opArray[ i];
         delete [] opArray;
         opArray = zpNew;
         oulSize += oulInc;
         opTop = &opArray[ oulTop - 1];
         }

      oulTop++;
      opTop++;
      *opTop = qT;
      return SSFalse;
      }

   template< class T> SSInline SSBooleanValue SSLifoArray< T>::pop(
      SSUnsigned32 qulNum)
      {
      if ( qulNum > oulTop) 
         {
         throwException( SSExceptionLifoPop, SSLifoMsgPop);
         return SSFalse;
         }
      opTop -= qulNum;
      oulTop -= qulNum;
		return SSTrue;
      }

   template< class T> SSInline T* SSLifoArray< T>::top( void)
      {
      if ( !oulTop)
         {
         throwException( SSExceptionLifoTop, SSLifoMsgTop);
         return 0;
         }
      return opTop;
      }

   template< class T> SSInline T* SSLifoArray< T>::operator[](
      SSUnsigned32 qulIndex)
      {
      if ( qulIndex + 1 > oulTop) 
         {
         throwException( SSExceptionLifoArray, SSLifoMsgArray, qulIndex);
         return 0;
         }
      return &opTop[ -(( SSSigned32) qulIndex)];
      }

   template< class T> SSInline SSLifoArray< T>::~SSLifoArray( void)
      {
      delete [] opArray;
      } 
      
#  endif
#endif
/*---------------------------------------------------------------------------

               Copyright (c) 1994-1997 SandStone Technology Inc.
                          All rights reserved

      THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
      OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
      DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
