/*---------------------------------------------------------------------------

               Copyright (c) 1994 - 1997 SandStone Technology Inc.
                          All rights reserved

      THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
      OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
      DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
   template< class T> SSInline SSUnsigned32 SSSetArray< T>::size( void) const
      {
      return oulIndex;
      }

   template< class T> SSInline void SSSetArray< T>::removeAll( void)
      {
      oulIndex = 0;
      }

   template< class T> SSInline SSSetArray< T>::SSSetArray( SSUnsigned32 qulSize,
      SSUnsigned32 qulInc) : oulSize( qulSize), oulInc( qulInc),
      oulIndex( 0)
      {
      opArray = new T[ qulSize];
      }

   template< class T> SSInline SSBooleanValue SSSetArray< T>::add( const T& qT)
      {
      if ( locate( qT)) return SSFalse;

      if ( oulIndex >= oulSize)
         {
         if ( !oulInc)
            {
            throwException( SSExceptionSetArrayFull, SSSetArrayMsgFull);
            return SSFalse;
            }

         T* zpNew = new T[ oulSize + oulInc];
         for ( unsigned int i = 0; i < oulSize; i++)
            zpNew[ i] = opArray[ i];
         oulSize += oulInc;
         delete [] opArray;
         opArray = zpNew;
         }

      opArray[ oulIndex++] = qT;
      return SSTrue;
      }

   template< class T> SSInline SSBooleanValue SSSetArray< T>::locate( const T& qT) const
      {
      for ( unsigned int i = 0; i < oulIndex; i++)
         if ( opArray[ i] == qT) return SSTrue;

      return SSFalse;
      }

   template< class T> SSInline SSSetArray< T>::~SSSetArray( void)
      {
      delete [] opArray;
      }
