/*---------------------------------------------------------------------------

					Copyright (c) 1994-1997 SandStone Technology Inc.
								  All rights reserved

		THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
		OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
		DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
#if !defined( SSYACCTB)
#  define SSYACCTB
#  include<ssexcept.hpp>
#if defined( __BORLANDC__)
#     pragma warn -inl
#endif

#  define SSYaccMsgToken "SSYacc: Too many tokens or productions, %ld"

#  if !defined( SS16BIT)
#     define SSYaccPairTableSize          0xffffffff
#  else
#     define SSYaccPairTableSize          0x00010000
#  endif

#  define SSYaccTableThresh               0x00010000

#  define SSYaccPairTableRowFlagSync      0x00000001
#  define SSYaccPairTableRowFlagError     0x00000002
#  define SSYaccPairTableRowFlagSyncAll   0x00000004
#  define SSYaccPairTableRowFlagDuplicate 0x00000008

#  define SSYaccPairTableEntryMask        0xf8000000
#  define SSYaccPairTableEntrySync        0x80000000
#  define SSYaccPairTableEntryShift       0x40000000
#  define SSYaccPairTableEntryReduce      0x20000000
#  define SSYaccPairTableEntryAccept      0x10000000
#  define SSYaccPairTableEntryConflict    0x08000000
#  define SSYaccPairTableEntryMax         ~SSYaccPairTableEntryMask

	class SSClass SSYaccPairTable;
	class SSClass SSYaccPairTableRow;
	class SSClass SSYaccPairTableProd;
   class SSClass SSYaccPairTableEntry;

#  define SSYaccTableTypeNewestPair0 0x53535943	
   enum SSYaccTableType
      {
      pairX,
      newPair,
      newestPair = 0x53535943
      };

	class SSClass SSYaccAction
		{
		public:

			enum SSYaccActionType
				{
				shift,
				error,
				reduce,
				accept,
				conflict
				};
		};

	class SSClass SSYaccPairTable
		{
		public:

			SSUnsigned32          lar( void);
			SSUnsigned32          size( void);
			SSUnsigned32          type( void);
			SSUnsigned32          prod( void);
			SSUnsigned32          states( void);
			SSUnsigned32          rowOffset( void);
			SSUnsigned32          prodOffset( void);

			void                  setLar( SSUnsigned32);
			void                  setProd( SSUnsigned32);
			void                  setStates( SSUnsigned32);
			void                  setType( SSUnsigned32);
			void                  setRowOffset( SSUnsigned32);
			void                  setProdOffset( SSUnsigned32);

			SSYaccPairTableRow*   firstRow( void);
			SSYaccPairTableRow**  rowArray( void);
			SSYaccPairTableRow*   lookupRow( SSUnsigned32);
			SSYaccPairTableProd*  lookupProd( SSUnsigned32);
			SSUnsigned32*         offsetArray( SSUnsigned32 = 0);

			void                  convert( SSYaccPairTable*, SSUnsigned32);

		protected:
			union
				{
				SSYaccTableType    oType;
				SSUnsigned32       oulType;
				};
			SSUnsigned32          oulProd;
			SSUnsigned32          oulStates;
			SSUnsigned32          oulRowOffset;
			SSUnsigned32          oulProdOffset;
		};

	SSInline SSUnsigned32 SSYaccPairTable::type( void)
		{
		return oulType;
		}

	SSInline SSUnsigned32 SSYaccPairTable::lar( void)
		{
		return ( oulProd & 0xffff0000) >> 16;
		}

	SSInline SSUnsigned32 SSYaccPairTable::prod( void)
		{
		return oulProd & 0x0000ffff;
		}

	SSInline SSUnsigned32 SSYaccPairTable::states( void)
		{
		return oulStates;
		}

	SSInline SSUnsigned32 SSYaccPairTable::rowOffset( void)
		{
		return oulRowOffset;
		}

	SSInline SSUnsigned32 SSYaccPairTable::prodOffset( void)
		{
		return oulProdOffset;
		}

	SSInline void SSYaccPairTable::setType( SSUnsigned32 qType)
		{
		oulType = qType;
		}

	SSInline void SSYaccPairTable::setLar( SSUnsigned32 qulProd)
		{
		oulProd &= 0x0000ffff;
		oulProd |= ( qulProd << 16);
		}

	SSInline void SSYaccPairTable::setProd( SSUnsigned32 qulProd)
		{
		oulProd &= 0xffff0000;
		oulProd |= ( qulProd & 0x0000ffff);
		}

	SSInline void SSYaccPairTable::setStates( SSUnsigned32 qulStates)
		{
		oulStates = qulStates;
		}

	SSInline void SSYaccPairTable::setRowOffset( SSUnsigned32 qulRowOffset)
		{
		oulRowOffset = qulRowOffset;
		}

	SSInline void SSYaccPairTable::setProdOffset( SSUnsigned32 qulProdOffset)
		{
		oulProdOffset = qulProdOffset;
		}

	class SSClass SSYaccPairTableRow
		{
		public:
			SSUnsigned32          size( void);
			SSUnsigned32          goTo( void);
			SSUnsigned32          action( void);
			SSUnsigned32          entries( void);
			SSUnsigned32          duplicate( void);

			void                  incGoto( void);
			void                  incAction( void);

			SSBooleanValue        hasSync( void);
			SSBooleanValue        hasError( void);
			SSBooleanValue        hasSyncAll( void);
			SSBooleanValue        isDuplicate( void);

			void                  setSync( void);
			void                  setError( void);
         void                  setSyncAll( void);
         void                  setDuplicate( SSUnsigned32);

         SSYaccPairTableEntry* lookupError( void);
			SSYaccPairTableEntry* lookupGoto( SSUnsigned32);
			SSYaccPairTableEntry* lookupAction( SSUnsigned32);

		protected:
			SSUnsigned32          oulFlag;
			SSUnsigned32          oulGoto;
         union
            {
            SSUnsigned32       oulAction;
            SSUnsigned32       oulDuplicate;
            };
      };

   SSInline SSUnsigned32 SSYaccPairTableRow::duplicate( void)
      {
      return oulDuplicate;
      }

   SSInline void SSYaccPairTableRow::setDuplicate( SSUnsigned32 qulDup)
      {
      oulFlag |= SSYaccPairTableRowFlagDuplicate;
      oulDuplicate = qulDup;
      }

   SSInline SSBooleanValue SSYaccPairTableRow::isDuplicate( void)
      {
      return oulFlag & SSYaccPairTableRowFlagDuplicate ? SSTrue : SSFalse;
      }

   SSInline SSBooleanValue SSYaccPairTableRow::hasError( void)
      {
      return oulFlag & SSYaccPairTableRowFlagError ? SSTrue : SSFalse;
      }

   SSInline SSBooleanValue SSYaccPairTableRow::hasSync( void)
      {
      return oulFlag & SSYaccPairTableRowFlagSync ? SSTrue : SSFalse;
      }

   SSInline SSBooleanValue SSYaccPairTableRow::hasSyncAll( void)
      {
      return oulFlag & SSYaccPairTableRowFlagSyncAll ? SSTrue : SSFalse;
      }

   SSInline void SSYaccPairTableRow::setError( void)
      {
      oulFlag |= SSYaccPairTableRowFlagError;
      }

   SSInline void SSYaccPairTableRow::setSync( void)
      {
		oulFlag |= SSYaccPairTableRowFlagSync;
      }

   SSInline void SSYaccPairTableRow::setSyncAll( void)
      {
      oulFlag |= SSYaccPairTableRowFlagSyncAll;
      }

   SSInline SSUnsigned32 SSYaccPairTableRow::goTo( void)
      {
      return oulGoto;
      }

   SSInline SSUnsigned32 SSYaccPairTableRow::action( void)
      {
      return oulAction;
      }

   SSInline SSUnsigned32 SSYaccPairTableRow::entries( void)
      {
      SSUnsigned32 zulError = hasError() ? 1 : 0;
      return oulGoto + oulAction + zulError;
      }

	SSInline void SSYaccPairTableRow::incGoto( void)
		{
		oulGoto++;
		}

	SSInline void SSYaccPairTableRow::incAction( void)
		{
		oulAction++;
		}

	class SSClass SSYaccPairTableEntry
		{
      public:
         SSUnsigned32        token( void);
         SSUnsigned32        entry( void);
         SSYaccAction::SSYaccActionType action( void);

         SSBooleanValue      hasSync( void);

         void                setSync( void);
         void                setAccept( void);
			void                setGoto( SSUnsigned32);
         void                setToken( SSUnsigned32);
         void                setShift( SSUnsigned32);
         void                setReduce( SSUnsigned32);
			void                setConflict( SSUnsigned32);

         void                throwException( SSUnsigned32);

      protected:
         SSUnsigned32        oulEntry;
         SSUnsigned32        oulToken;
      };

   SSInline void SSYaccPairTableEntry::throwException( SSUnsigned32 qulEntry)
      {
	  qulEntry;
      SSException* zpException = new SSException( SSYaccMsgToken, SSExceptionYaccToken);
		if ( getSSExceptionInfo().isThrowPointer())
			SSTHROW0( zpException);
		else
			SSTHROW1( *zpException);
      }

   SSInline SSUnsigned32 SSYaccPairTableEntry::token( void)
      {
      return oulToken;
      }

   SSInline SSUnsigned32 SSYaccPairTableEntry::entry( void)
      {
      return oulEntry & ~SSYaccPairTableEntryMask;
      }

   SSInline void SSYaccPairTableEntry::setToken( SSUnsigned32 qulToken)
      {
      oulToken = qulToken;
		}

   SSInline void SSYaccPairTableEntry::setShift( SSUnsigned32 qulEntry)
      {
      if ( qulEntry > SSYaccPairTableEntryMax)
         throwException( qulEntry);
      oulEntry = qulEntry;
      oulEntry |= SSYaccPairTableEntryShift;
      }

   SSInline void SSYaccPairTableEntry::setReduce( SSUnsigned32 qulEntry)
		{
		if ( qulEntry > SSYaccPairTableEntryMax)
			throwException( qulEntry);
		oulEntry = qulEntry;
		oulEntry |= SSYaccPairTableEntryReduce;
		}

	SSInline void SSYaccPairTableEntry::setGoto( SSUnsigned32 qulEntry)
		{
		if ( qulEntry > SSYaccPairTableEntryMax)
			throwException( qulEntry);
		oulEntry = qulEntry;
		}

	SSInline void SSYaccPairTableEntry::setAccept( void)
		{
		oulEntry = SSYaccPairTableEntryAccept;
		}

	SSInline void SSYaccPairTableEntry::setConflict( SSUnsigned32 qulEntry)
		{
		oulEntry = qulEntry;
		oulEntry |= SSYaccPairTableEntryConflict;
		}

   SSInline void SSYaccPairTableEntry::setSync( void)
      {
      oulEntry |= SSYaccPairTableEntrySync;
      }

   SSInline SSBooleanValue SSYaccPairTableEntry::hasSync( void)
      {
      return oulEntry & SSYaccPairTableEntrySync ? SSTrue : SSFalse;
      }

	SSInline SSYaccAction::SSYaccActionType SSYaccPairTableEntry::action( void)
      {
      if ( oulEntry & SSYaccPairTableEntryShift) return SSYaccAction::shift;
      if ( oulEntry & SSYaccPairTableEntryReduce) return SSYaccAction::reduce;
      if ( oulEntry & SSYaccPairTableEntryAccept) return SSYaccAction::accept;
      if ( oulEntry & SSYaccPairTableEntryConflict) return SSYaccAction::conflict;
		return SSYaccAction::error;
      }

	class SSClass SSYaccPairTableProd
		{
		public:
			SSUnsigned32        size( void);
			SSUnsigned32        leftside( void);

			void                setSize( SSUnsigned32);
			void                setLeftside( SSUnsigned32);

		protected:
			SSUnsigned32        oulSize;
			SSUnsigned32        oulLeftside;
		};

	SSInline SSUnsigned32 SSYaccPairTableProd::size( void)
      {
      return oulSize;
      }

   SSInline SSUnsigned32 SSYaccPairTableProd::leftside( void)
      {
      return oulLeftside;
      }

   SSInline void SSYaccPairTableProd::setSize( SSUnsigned32 qulSize)
      {
      oulSize = qulSize;
      }

   SSInline void SSYaccPairTableProd::setLeftside( SSUnsigned32 qulLeftside)
      {
      oulLeftside = qulLeftside;
      }

   SSInline SSYaccPairTableEntry* SSYaccPairTableRow::lookupAction(
      SSUnsigned32 qulToken)
      {
      SSYaccPairTableEntry* zpEntry = ( SSYaccPairTableEntry*) ( this + 1);
      for ( unsigned int i = 0; i < oulAction; i++, zpEntry++)
         if ( zpEntry->token() == qulToken)
            return zpEntry;

      return 0;
      }

   SSInline SSYaccPairTableEntry* SSYaccPairTableRow::lookupGoto( 
		SSUnsigned32 qulGoto)
      {
      SSYaccPairTableEntry* zpEntry = ( SSYaccPairTableEntry*) ( this + 1);
      zpEntry += oulAction;
      for ( unsigned int i = 0; i < oulGoto; i++, zpEntry++)
         if ( zpEntry->token() == qulGoto)
            return zpEntry;

      return 0;
      }

   SSInline SSYaccPairTableEntry* SSYaccPairTableRow::lookupError( void)
      {
      if ( !hasError()) return 0;
      SSYaccPairTableEntry* zpEntry = ( SSYaccPairTableEntry*) ( this + 1);
      zpEntry += oulAction + oulGoto;
      return zpEntry;
      }

   SSInline SSYaccPairTableRow* SSYaccPairTable::firstRow( void)
      {
      return ( SSYaccPairTableRow*) (( char*) this + oulRowOffset);
      }

   SSInline SSYaccPairTableRow** SSYaccPairTable::rowArray( void)
      {
      return ( SSYaccPairTableRow**) ( this + 1);
      }

   SSInline SSUnsigned32* SSYaccPairTable::offsetArray( SSUnsigned32 qShift)
      {
      return ( SSUnsigned32*) (( char*) ( this + 1) + qShift);
      }

   SSInline SSYaccPairTableRow* SSYaccPairTable::lookupRow( SSUnsigned32 qulRow)
      {
      SSYaccPairTableRow** zppRow = ( SSYaccPairTableRow**) ( this + 1);
      return zppRow[ qulRow];
      }

   SSInline SSYaccPairTableProd* SSYaccPairTable::lookupProd( SSUnsigned32 qulProd)
      {
      SSYaccPairTableProd* zpProd = ( SSYaccPairTableProd*) 
         (( char*) this + oulProdOffset);
      return &zpProd[ qulProd];
      }

   SSInline SSUnsigned32 SSYaccPairTableRow::size( void)
      {
      return isDuplicate() ? sizeof( SSYaccPairTableRow) :
         sizeof( SSYaccPairTableEntry) * entries() + sizeof( SSYaccPairTableRow);
      }

   SSInline SSUnsigned32 SSYaccPairTable::size( void)
      {
      return sizeof( SSYaccPairTable) + sizeof( SSYaccPairTableProd) * 
         prod() + sizeof( SSYaccPairTableRow*) * states();
      }

#endif
