/*---------------------------------------------------------------------------

					Copyright (c) 1994-1999 SandStone Technology Inc.
								  All rights reserved

		THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
		OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
		DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
#include "stdafx.h"
#include<sslex.hpp>
#include<sslexc.h>
#include<sslexc.hpp>
#if defined( __BORLANDC__)
#  pragma warn -rch
#  pragma warn -aus
#endif

	static SSExceptionBadCorrelatorCallback spBad = 0;
   static void*                            spBadParm = 0; 
   
   SSExceptionImplementDynamic( SSExceptionCapi, SSException)

   SSLexCapiLexeme::SSLexCapiLexeme( void* qpBuff, SSUnsigned32 qulLength, 
      SSUnsigned32 qulExtra) : oulExtra( qulExtra), 
      SSCorrelator( SSLexCorrLexeme)
      {
      setBuffer(( char*) ( this + 1));
      setLength( qulLength);
      ochExtra = ( char*) (( char*) ( this + 1) + qulLength + SSLexMinimumCharacterSize);
      memcpy( opchBuff, qpBuff, qulLength);
      memset( opchBuff + qulLength, 0, SSLexMinimumCharacterSize);
      }

   SSLexCapiLexeme::SSLexCapiLexeme( SSLexConsumer& qConsumer,
      SSUnsigned32 qulToken, SSLexMark* qpMark, SSUnsigned32 qulLength,
      SSUnsigned32 qulExtra) : oulExtra( qulExtra), 
      SSCorrelator( SSLexCorrLexeme)
      {
      setToken( qulToken);
      setBuffer(( char*) ( this + 1));
      if ( qpMark)
         setLength( qConsumer.lexemeLength( *qpMark));
      else
         setLength( qConsumer.lexemeLength());
      ochExtra = ( char*) (( char*) ( this + 1) + qulLength + SSLexMinimumCharacterSize);
      if ( qConsumer.type() == SSLexConsumer::unicode)
         setType( unicode);
      else
         setType( character);
      setLine( qConsumer.line());
      setOffset( qConsumer.offset());
      memcpy( opchBuff, qConsumer.lexemeBuffer(), length());
      memset( opchBuff + length(), 0, SSLexMinimumCharacterSize);
      if ( qpMark)
         qConsumer.flushLexeme( *qpMark);
      else
         qConsumer.flushLexeme();
      }

   void SSLexCapiLexeme::refFree( void)
      {
      delete this;
      }

   SSInline char* SSLexCapiLexeme::extraBuffer( void)
      {
      return ochExtra;
      }

   SSInline SSUnsigned32 SSLexCapiLexeme::extraLength( void)
      {
      return oulExtra;
      }

   SSInline void SSLexCapiConsumer::setNextBufferCallback( 
      SSLexConsumerNextBufferCallback qpCallback, void* qpParm)
      {
      opParm = qpParm;
      opCallback = qpCallback;
      }

   SSInline void SSLexCapiConsumer::close( void)
      {
      if ( opFile) fclose( opFile);
      opFile = 0;
      }

   SSInline FILE* SSLexCapiConsumer::file( void) const
      {
      return opFile;
      }

   SSLexCapiConsumer::SSLexCapiConsumer( void* qpBuff, 
      SSUnsigned32 qulBuff, SSUnsigned32 qulType, SSUnsigned32 qulInc) :
      SSLexConsumer(( SSLexConsumer::SSLexConsumerType) qulType),
      opFile( 0), opCallback( 0), SSCorrelator( SSLexCorrConsumer)
      {
      setBuffer( new char[ qulBuff]);
      setBufferLength( qulBuff);
      setBufferInc( qulInc);
      oulLength = qulBuff;
      memcpy( buffer(), qpBuff, qulBuff);
      }

   SSLexCapiConsumer::SSLexCapiConsumer( const char* qpszFile,
      SSUnsigned32 qulType, SSUnsigned32 qulBuff, SSUnsigned32 qulInc) :
      SSLexConsumer(( SSLexConsumer::SSLexConsumerType) qulType),
      opFile( 0), opCallback( 0), SSCorrelator( SSLexCorrConsumer)
      {
      oulBuff = qulBuff;
      oulInc = qulInc;

      char* zpszMode;
      switch ( type())
         {
         case binary:
            zpszMode = SSLexFileModeBinary;
            break;
         case unicode:
            zpszMode = SSLexFileModeUnicode;
            break;
         case character:
            zpszMode = SSLexFileModeCharacter;
            break;
         }

      opFile = fopen( qpszFile, zpszMode);
      if ( !opFile)
         {
         throwException( SSExceptionLexFileOpen, SSLexMsgFileOpen,
            qpszFile, errno);
         return;
         }

      if ( qulBuff == SSLexConsumerAll)
         {
         fseek( opFile, 0L, SEEK_END);
         oulBuff = ftell( opFile);
         fseek( opFile, 0L, SEEK_SET);
         oulInc = 0;
         }

      if ( !oulBuff)
         {
         throwException( SSExceptionLexFileLength, SSLexMsgFileLength,
            qpszFile);
         return;
         }

      opchBuff = new char[ oulBuff];
      oulLength = fread( opchBuff, 1, oulBuff, opFile);
      }

   SSUnsigned32 SSLexCapiConsumer::nextBuffer( void)
      {
      SSUnsigned32 zulRead, zulFill;
      if ( shiftBuffer( zulRead, zulFill) && expandBuffer( zulRead, zulFill))
         {
         if ( opFile && feof( opFile))
            {
            close();
            return 0;
            }
         else if ( opFile)
            {
            throwException( SSExceptionLexLexemeLength,
               SSLexMsgLexemeLength, oulLength);
            return 0;
            }
         else return 0;
         }

      if ( opCallback)
         return ( *opCallback)( this, opchBuff + zulRead, zulFill, opParm);
      else if ( opFile)
         {
         SSUnsigned32 zulLength = fread( opchBuff + zulRead, 1, zulFill, opFile);
         if ( !zulLength) close();
         return zulLength;
         }
      else
         return 0;
      }

   SSLexCapiConsumer::~SSLexCapiConsumer( void)
      {
		close();
      }

   SSInline void SSLexCapi::setLexemeExtra( SSUnsigned32 qulExtra)
      {
      oulExtra = qulExtra;
      }

   SSInline void SSLexCapi::setErrorCallback( SSLexErrorCallback qpError,
      void* qpErrorParm)
      {
      opError = qpError;
      opErrorParm = qpErrorParm;
      }

   SSInline void SSLexCapi::setCompleteCallback( SSLexCompleteCallback qpComplete,
      void* qpCompleteParm)
      {
      opComplete = qpComplete;
      opCompleteParm = qpCompleteParm;
      }

   SSLexCapi::SSLexCapi( SSLexTable& qTable, SSLexCapiConsumer& qConsumer) :
      SSLex( qConsumer, qTable), opError( 0), oulExtra( 0), opComplete( 0),
      opErrorParm( 0), opCompleteParm( 0), SSCorrelator( SSLexCorrLex)
      {
      }

   SSLexLexeme* SSLexCapi::error( SSLexConsumer& qConsumer)
      {
      SSLexCapiLexeme* zpLexeme = 0;
      if ( opError)
         {
         SSUnsigned32 zulLength = qConsumer.lexemeLength();
         SSUnsigned32 zulTotal = zulLength + oulExtra;
         zpLexeme = new( zulTotal) SSLexCapiLexeme( qConsumer, 0, 0, 
            zulLength, oulExtra);
         zpLexeme->refDec( SSFalse);
         if ( !( ( *opError)( this, zpLexeme, opErrorParm)))
            {
            delete zpLexeme;
            zpLexeme = 0;
            }
         }
      else
         qConsumer.flushLexeme();
      return zpLexeme;
      }

   SSLexLexeme* SSLexCapi::complete( SSLexConsumer& qConsumer, SSUnsigned32
      qulToken, SSLexMark& qMark)
		{
      SSLexCapiLexeme* zpLexeme = 0;
      SSTry
         {
         SSUnsigned32 zulLength = qConsumer.lexemeLength( qMark);
         SSUnsigned32 zulTotal = zulLength + oulExtra;
         zpLexeme = new( zulTotal) SSLexCapiLexeme( qConsumer, qulToken, 
            &qMark, zulLength, oulExtra);
         zpLexeme->refDec( SSFalse);
         }
      SSCatch ( SSException, zExcept)
         {
         setException( new SSExceptionCapi( zExcept));
         return 0;
         }
      SSCatchEnd
 
      if ( opComplete)
         {
         SSBooleanValue zComplete = ( *opComplete)( this, zpLexeme, opCompleteParm);
         if ( !zComplete)
            {
            delete zpLexeme;
            zpLexeme = 0;
            }
         }

      return zpLexeme;
      }

   SSBooleanValue SSCorrelator::verify( void* qpCorr, const char* qpszVer)
      {
      if ( *(( SSUnsigned32*) qpszVer) != oulCorr)
         {
         SSExceptionCallBadCorrelatorCallback( qpCorr, qpszVer);
         return SSFalse;
         }
      return SSTrue;
      }

   void* SSLexTableCreate( const char* qpszName, void** qpExcept)
      {
      SSTry
         {
         SSLexCapiTable* zpTable = new SSLexCapiTable( qpszName);
         return zpTable;
         }
      SSCatch ( SSException, zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      SSCatchEnd 
      return 0;
		}

#  if defined( _Windows) || defined( __WIN32__) || defined( WIN32) || defined( _WINDOWS)
	void* SSLexResourceTableCreate( unsigned long qhInst, const char* qpszName,
		const char* qpszType, void** qpExcept)
		{
		SSTry
			{
         SSLexCapiTable* zpTable = new SSLexCapiTable( qhInst, qpszName, qpszType);
         return zpTable;
         }
      SSCatch ( SSException, zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      SSCatchEnd 
      return 0;
      }
#  endif

	void SSLexTableDestroy( void* qpTable)
      {
      SSLexCapiTable* zpTable = ( SSLexCapiTable*) qpTable;
      if ( !zpTable->verify( qpTable, SSLexCorrTable))
         return;
      delete ( SSLexCapiTable*) qpTable;
      }

   void* SSLexLexemeCreate( void* qpBuff, SSUnsigned32 qulLength,
      SSUnsigned32 qulExtra, void** qpExcept)
      {
      SSTry
         {
         SSUnsigned32 zulLength = qulLength + qulExtra;
         SSLexCapiLexeme* zpLexeme = new( zulLength) SSLexCapiLexeme(
            qpBuff, qulLength, qulExtra);
         zpLexeme->refDec( SSFalse);
         return zpLexeme;
         }
      SSCatch ( SSException, zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      SSCatchEnd
      return 0;
      }
 /*
   void* SSLexLexemeCreateFromConsumer( void* qpConsumer, SSUnsigned32 qToken,
      void* qpMark, SSUnsigned32 qulExtra, void** qpExcept)
      {
      SSLexMark& qMark( *(( SSLexMark*) qpMark));
      SSLexCapiConsumer& qConsumer( *(( SSLexCapiConsumer*) qpConsumer));
      try
         {
         SSUnsigned32 qulLexeme = qConsumer.lexemeLength( qMark);
         SSUnsigned32 qulLength = qulLexeme + qulExtra;
         SSLexCapiLexeme* zpLexeme = new( qulLength) SSLexCapiLexeme( qConsumer,
            qToken, &qMark, qulLexeme, qulExtra);
         return zpLexeme;
         }
      catch ( SSException zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      }
*/
   void SSLexLexemeRefInc( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      zpLexeme->refInc();
      }

   SSBooleanValue SSLexLexemeRefDec( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return SSTrue;
      SSTry
         {
         zpLexeme->refDec();
         return SSFalse;
         }
      SSCatch ( SSException, zExcept)
         {
         return SSTrue;
         }
      SSCatchEnd
      return 0;
      }

   void SSLexLexemeDestroy( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      delete zpLexeme;
      }

   SSUnsigned32 SSLexLexemeGetType( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return 0;
      return zpLexeme->type();
      }

   SSUnsigned32 SSLexLexemeGetLine( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return 0;
      return zpLexeme->line();
      }

   SSUnsigned32 SSLexLexemeGetToken( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return 0;
      return zpLexeme->token();
      }

   SSUnsigned32 SSLexLexemeGetOffset( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return 0;
      return zpLexeme->offset();
      }

   SSUnsigned32 SSLexLexemeGetLength( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return 0;
      return zpLexeme->length();
      }

   void* SSLexLexemeGetBuffer( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return 0;
      return zpLexeme->asChar();
      }

   SSUnsigned32 SSLexLexemeGetExtraLength( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return 0;
      return zpLexeme->extraLength();
      }

   void* SSLexLexemeGetExtraBuffer( void* qpLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return 0;
      return zpLexeme->extraBuffer();
      }

   void SSLexLexemeSetType( void* qpLexeme, SSUnsigned32 qulType)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      zpLexeme->setType(( SSLexLexeme::SSLexLexemeType) qulType);
      }

   void SSLexLexemeSetLine( void* qpLexeme, SSUnsigned32 qulLine)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      zpLexeme->setLine( qulLine);
      }

   void SSLexLexemeSetToken( void* qpLexeme, SSUnsigned32 qulToken)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      zpLexeme->setToken( qulToken);
      }

   void SSLexLexemeSetOffset( void* qpLexeme, SSUnsigned32 qulOffset)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      zpLexeme->setOffset( qulOffset);
      }

   void SSLexLexemeSetLength( void* qpLexeme, SSUnsigned32 qulLength)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      zpLexeme->setLength( qulLength);
      }

   void SSLexLexemeSetBuffer( void* qpLexeme, void* qpBuffer)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      zpLexeme->setBuffer(( char*) qpBuffer);
      }

   void* SSLexConsumerCreate( void* qpBuffer, SSUnsigned32 qulLength, 
      SSUnsigned32 qulType, SSUnsigned32 qulInc, void** qpExcept)
      {
      SSTry
         {
         SSLexCapiConsumer* zpConsumer = new SSLexCapiConsumer( qpBuffer,
            qulLength, qulType, qulInc);
         return zpConsumer;
         }
      SSCatch ( SSException, zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   void* SSLexFileConsumerCreate( const char* qpszName, SSUnsigned32 qulBuff,
      SSUnsigned32 qulInc, SSUnsigned32 qulType, void** qpExcept)
      {
      SSTry
         {
         SSLexCapiConsumer* zpConsumer = new SSLexCapiConsumer( qpszName,
            ( SSLexConsumer::SSLexConsumerType) qulType, qulBuff, qulInc);
         return zpConsumer;
         }
      SSCatch ( SSException, zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   void SSLexConsumerDestroy( void* qpConsumer)
      {
      SSLexCapiConsumer* zpConsumer = ( SSLexCapiConsumer*) qpConsumer;
      if ( !zpConsumer->verify( qpConsumer, SSLexCorrConsumer))
         return;
      delete zpConsumer;
      }

   void SSLexConsumerSetNextBufferCallback( void* qpConsumer, 
      SSLexConsumerNextBufferCallback qpCallback, void* qpParm)
      {
      SSLexCapiConsumer* zpConsumer = ( SSLexCapiConsumer*) qpConsumer;
      if ( !zpConsumer->verify( qpConsumer, SSLexCorrConsumer))
         return;
      zpConsumer->setNextBufferCallback( qpCallback, qpParm);
      }

   FILE* SSLexFileConsumerGetFile( void* qpConsumer)
      {
      SSLexCapiConsumer* zpConsumer = ( SSLexCapiConsumer*) qpConsumer;
      if ( !zpConsumer->verify( qpConsumer, SSLexCorrConsumer))
         return 0;
      return zpConsumer->file();
      }

   void SSLexFileConsumerCloseFile( void* qpConsumer)
      {
      SSLexCapiConsumer* zpConsumer = ( SSLexCapiConsumer*) qpConsumer;
      if ( !zpConsumer->verify( qpConsumer, SSLexCorrConsumer))
         return;
      zpConsumer->close();
      }

   void* SSLexCreate( void* qpTable, void* qpConsumer, void** qpExcept)
      {
      SSLexCapiTable* zpTable = ( SSLexCapiTable*) qpTable;
      if ( !zpTable->verify( qpTable, SSLexCorrTable))
         return 0;
      SSLexCapiConsumer* zpConsumer = ( SSLexCapiConsumer*) qpConsumer;
      if ( !zpConsumer->verify( qpConsumer, SSLexCorrConsumer))
         return 0;

      SSTry
         {
         SSLexCapi* zpLex = new SSLexCapi( *zpTable, *zpConsumer);
         return zpLex;
         }
      SSCatch ( SSException, zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   void SSLexDestroy( void* qpLex)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return;
      delete zpLex;
      }

   void* SSLexGetNextLexeme( void* qpLex)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return 0;
      SSTry
         {
         SSLexLexeme* zpLexeme = ( *zpLex)++;
         return ( SSLexCapiLexeme*) zpLexeme;
         }
      SSCatch ( SSException, zExcept)
         {
         zpLex->setException( new SSExceptionCapi( zExcept));
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   SSBooleanValue SSLexIsCurrentExpressionList( void* qpLex, SSUnsigned32 qList)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return SSFalse;
      SSTry
         {
         return zpLex->isCurrentExpressionList( qList);
         }
      SSCatch ( SSException, zExcept)
         {
         zpLex->setException( new SSExceptionCapi( zExcept));
         return SSFalse;
         }
      SSCatchEnd
      return 0;
      }

   void SSLexSetLexemeExtra( void* qpLex, SSUnsigned32 qulExtra)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return;
      zpLex->setLexemeExtra( qulExtra);
      }

   void SSLexSetErrorCallback( void* qpLex, SSLexErrorCallback qCall, void* qpParm)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return;
      zpLex->setErrorCallback( qCall, qpParm);
      }

   void SSLexSetCompleteCallback( void* qpLex, SSLexCompleteCallback qCall,
      void* qpParm)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return;
      zpLex->setCompleteCallback( qCall, qpParm);
      }

   void SSLexReset( void* qpLex)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return;
      zpLex->reset();
      }

   SSBooleanValue SSLexPopExpressionList( void* qpLex)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return SSTrue;
      SSTry
         {
         zpLex->popExpressionList();
         return SSFalse;
         }
      SSCatch ( SSException, zExcept)
         {
         zpLex->setException( new SSExceptionCapi( zExcept));
         return SSTrue;
         }
      SSCatchEnd
      return 0;
      }

   SSBooleanValue SSLexPushExpressionList( void* qpLex, SSUnsigned32 qList)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return SSTrue;
      SSLexTable& zTable = *( zpLex->table());
      SSTry
         {
         zpLex->pushExpressionList( *zTable.expressionList( qList));
         return SSFalse;
         }
      SSCatch ( SSException, zExcept)
         {
         zpLex->setException( new SSExceptionCapi( zExcept));
         return SSTrue;
         }
      SSCatchEnd
      return 0;
      }

   SSBooleanValue SSLexGotoExpressionList( void* qpLex, SSUnsigned32 qList)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return SSTrue;
      SSLexTable& zTable = *( zpLex->table());
      SSTry
         {
         zpLex->gotoExpressionList( *zTable.expressionList( qList));
         return SSFalse;
         }
      SSCatch ( SSException, zExcept)
         {
         zpLex->setException( new SSExceptionCapi( zExcept));
         return SSTrue;
         }
      SSCatchEnd
      return 0;
      }

   void SSLexClearLastException( void* qpLex)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return;
      zpLex->setException( 0);
      }

   void* SSLexGetLastException( void* qpLex)
      {
      SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
      if ( !zpLex->verify( qpLex, SSLexCorrLex))
         return 0;
      return ( SSExceptionCapi*) zpLex->getException();
      }

   void SSExceptionCallBadCorrelatorCallback( void* qpCorr, const char* qpszVer)
      {
      if ( !spBad) abort();
      ( *spBad)( qpCorr, qpszVer, spBadParm);
      }

   void SSExceptionSetBadCorrelatorCallback( SSExceptionBadCorrelatorCallback
      qpCall, void* qpParm)
      {
      spBad = qpCall;
      spBadParm = qpParm;
      }

   const char* SSExceptionGetMessage( void* qpExcept)
      {
      SSExceptionCapi* zpExcept = ( SSExceptionCapi*) qpExcept;
      if ( !zpExcept->verify( qpExcept, SSExceptionCorr))
         return 0;
      return zpExcept->text();
      }
 
   SSUnsigned32 SSExceptionGetErrorId( void* qpExcept)
      {
      SSExceptionCapi* zpExcept = ( SSExceptionCapi*) qpExcept;
      if ( !zpExcept->verify( qpExcept, SSExceptionCorr))
         return 0;
      return zpExcept->errorId();
      }

   void SSExceptionDestroy( void* qpExcept)
      {
      SSExceptionCapi* zpExcept = ( SSExceptionCapi*) qpExcept;
      if ( !zpExcept->verify( qpExcept, SSExceptionCorr))
         return;
      delete zpExcept;
      }
