/*---------------------------------------------------------------------------

					Copyright (c) 1994-1999 SandStone Technology Inc.
								  All rights reserved

		THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
		OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
		DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
#include "stdafx.h"
#include<ssyaccc.h>
#include<ssyacc.hpp>
#include<sslexc.hpp>
#if defined( __BORLANDC__)
#     pragma warn -rch
#endif

#  define SSYaccCapiCorrTable "SSYT"
#  define SSYaccCapiCorrStack "SSSE"
#  define SSYaccCapiCorrYacc  "SSYC"

   class SSYaccCapiTable : public SSYaccTable, public SSCorrelator
      {
      public:
         SSConstr      SSYaccCapiTable( const char*);
			SSConstr      SSYaccCapiTable( unsigned long, const char*, const char*);
		};

   class SSYaccCapiStackElement : public SSYaccStackElement, public SSCorrelator
      {
      public:
         void*         operator new( size_t, SSUnsigned32);
         void          operator delete( void*);

         SSConstr      SSYaccCapiStackElement( void);

			void*         extra( void);
         void          refFree( void);
      };

   class SSYaccCapi : public SSYacc, public SSCorrelator
      {
      public:
         SSConstr            SSYaccCapi( SSLex*, SSYaccTable*,
                                SSYaccReduceCallback, SSUnsigned32, void*);

         SSLexLexeme*        nextLexeme( void);
         SSYaccStackElement* stackElement( void);
         SSYaccStackElement* shift( SSLexLexeme&);
         SSBooleanValue      error( SSUnsigned32, SSLexLexeme&);
         SSYaccStackElement* reduce( SSUnsigned32, SSUnsigned32);

         void                setShiftCallback( SSYaccShiftCallback, void*);
         void                setErrorCallback( SSYaccErrorCallback, void*);
         void                setNextLexemeCallback( SSYaccNextLexemeCallback,
                                void*);

      private:
			SSUnsigned32               oulExtra;
         void*                      opShiftParm;
         void*                      opErrorParm;
         void*                      opReduceParm;
         void*                      opNextLexemeParm;
         SSYaccShiftCallback        opShiftCallback;
         SSYaccErrorCallback        opErrorCallback;
         SSYaccReduceCallback       opReduceCallback;
         SSYaccNextLexemeCallback   opNextLexemeCallback;
      };

   SSInline void SSYaccCapiStackElement::operator delete( void* qpBuff)
      {
      freeSS( qpBuff);
      }

   SSInline void* SSYaccCapiStackElement::operator new( size_t qSize, 
      SSUnsigned32 qBuff)
      {
      return mallocSS( qSize + qBuff);
      }

	SSInline SSYaccCapiStackElement::SSYaccCapiStackElement( void) :
      SSCorrelator( SSYaccCapiCorrStack)
      {
      }

	SSInline SSYaccCapiTable::SSYaccCapiTable( const char* qpszTable) :
		SSYaccTable( qpszTable), SSCorrelator( SSYaccCapiCorrTable)
		{
		}

	SSInline SSYaccCapiTable::SSYaccCapiTable( unsigned long qhInst,
		const char* qpszName, const char* qpszType) :
		SSYaccTable( qhInst, qpszName, qpszType),
		SSCorrelator( SSYaccCapiCorrTable)
		{
		}

	SSInline SSYaccCapi::SSYaccCapi( SSLex* qpLex, SSYaccTable* qpTable,
		SSYaccReduceCallback qpCall, SSUnsigned32 qulExtra, void* qpParm) :
		SSYacc( *qpLex, *qpTable), oulExtra( qulExtra), opShiftParm( 0),
      opErrorParm( 0), opReduceParm( qpParm), opNextLexemeParm( 0), 
      opShiftCallback( 0), opErrorCallback( 0), opNextLexemeCallback( 0),
      opReduceCallback( qpCall), SSCorrelator( SSYaccCapiCorrYacc)
      {
      }

   SSInline void SSYaccCapi::setShiftCallback( SSYaccShiftCallback qpCall,
      void* qpParm)
      {
		opShiftCallback = qpCall;
      opShiftParm = qpParm;
      }

   SSInline void SSYaccCapi::setErrorCallback( SSYaccErrorCallback qpCall,
      void* qpParm)
      {
      opErrorCallback = qpCall;
      opErrorParm = qpParm;
      }

   SSInline void SSYaccCapi::setNextLexemeCallback( SSYaccNextLexemeCallback 
      qpCall, void* qpParm)
      {
      opNextLexemeCallback = qpCall;
      opNextLexemeParm = qpParm;
      }

   void SSYaccCapiStackElement::refFree( void)
      {
      delete this;
      }

   SSLexLexeme* SSYaccCapi::nextLexeme( void)
      {
      if ( opNextLexemeCallback)
         return ( SSLexCapiLexeme*) ( *opNextLexemeCallback)( this,
            opNextLexemeParm);
      else
         return SSYacc::nextLexeme();
      }

   SSYaccStackElement* SSYaccCapi::shift( SSLexLexeme& qLexeme)
      {
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) &qLexeme;
      if ( opShiftCallback)
         return ( SSYaccCapiStackElement*) ( *opShiftCallback)( this, 
            zpLexeme, opShiftParm);
      else
         return SSYacc::shift( qLexeme);
      }

   SSBooleanValue SSYaccCapi::error( SSUnsigned32 qulState, 
      SSLexLexeme& qLexeme)
		{
      SSLexCapiLexeme* zpCapi = ( SSLexCapiLexeme*) &qLexeme;
      if ( qLexeme.token() == SSYaccEofToken)
         zpCapi = 0;
      if ( opErrorCallback)
         return ( *opErrorCallback)( this, zpCapi, qulState, opErrorParm);
      else
         return SSYacc::error( qulState, qLexeme);
      }

   SSYaccStackElement* SSYaccCapi::reduce( SSUnsigned32 qulProd,
      SSUnsigned32 qulSize)
      {
      return ( SSYaccCapiStackElement*)
         ( *opReduceCallback)( this, qulProd, qulSize, opReduceParm);
      }

	SSYaccStackElement* SSYaccCapi::stackElement( void)
		{
		SSYaccCapiStackElement* zpEle= new( oulExtra) SSYaccCapiStackElement;
		zpEle->refDec( SSFalse);
		return zpEle;
		}

	SSInline void* SSYaccCapiStackElement::extra( void)
		{
		return ( this + 1);
		}

#  if defined( _Windows) || defined( __WIN32__) || defined( WIN32) || defined( _WINDOWS)
	void* SSYaccResourceTableCreate( unsigned long qhInst, const char* qpszName,
		const char* qpszType, void** qpExcept)
		{
		SSTry
			{
			return new SSYaccCapiTable( qhInst, qpszName, qpszType);
			}
		SSCatch ( SSException, zExcept)
			{
			if ( qpExcept)
				*qpExcept = new SSExceptionCapi( zExcept);
			return 0;
			}
		SSCatchEnd
		return 0;
		}
#  endif

	void* SSYaccTableCreate( const char* qpszFile, void** qpExcept)
		{
		SSTry
			{
			return new SSYaccCapiTable( qpszFile);
			}
		SSCatch ( SSException, zExcept)
			{
			if ( qpExcept)
				*qpExcept = new SSExceptionCapi( zExcept);
			return 0;
			}
		SSCatchEnd
		return 0;
		}

   void SSYaccTableDestroy( void* qpTable)
      {
      SSYaccCapiTable* zpTable = ( SSYaccCapiTable*) qpTable;
      if ( !zpTable->verify( qpTable, SSYaccCapiCorrTable))
			return;
      delete zpTable;
      }
 
   void* SSYaccStackElementCreate( SSUnsigned32 qulExtra, void** qpExcept)
      {
      SSTry
			{
			SSYaccStackElement* zpEle = new( qulExtra) SSYaccCapiStackElement;
			zpEle->refDec( SSFalse);
			return zpEle;
         }
      SSCatch ( SSException, zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   void SSYaccStackElementRefInc( void* qpElement)
      {
      SSYaccCapiStackElement* zpElement = ( SSYaccCapiStackElement*) qpElement;
      if ( !zpElement->verify( qpElement, SSYaccCapiCorrStack))
         return;
      zpElement->refInc();
      }

   void SSYaccStackElementRefDec( void* qpElement)
      {
      SSYaccCapiStackElement* zpElement = ( SSYaccCapiStackElement*) qpElement;
      if ( !zpElement->verify( qpElement, SSYaccCapiCorrStack))
         return;
      zpElement->refDec();
      }

   void SSYaccStackElementDestroy( void* qpElement)
      {
      SSYaccCapiStackElement* zpElement = ( SSYaccCapiStackElement*) qpElement;
      if ( !zpElement->verify( qpElement, SSYaccCapiCorrStack))
         return;
      delete zpElement;
      }

   void* SSYaccStackElementGetExtra( void* qpElement)
      {
      SSYaccCapiStackElement* zpElement = ( SSYaccCapiStackElement*) qpElement;
      if ( !zpElement->verify( qpElement, SSYaccCapiCorrStack))
         return 0;
      return zpElement->extra();
      }

   SSUnsigned32 SSYaccStackElementGetState( void* qpElement)
      {
      SSYaccCapiStackElement* zpElement = ( SSYaccCapiStackElement*) qpElement;
      if ( !zpElement->verify( qpElement, SSYaccCapiCorrStack))
         return 0;
      return zpElement->state();
      }

   void* SSYaccStackElementGetLexeme( void* qpElement)
      {
      SSYaccCapiStackElement* zpElement = ( SSYaccCapiStackElement*) qpElement;
      if ( !zpElement->verify( qpElement, SSYaccCapiCorrStack))
         return 0;
      return zpElement->lexeme();
      }

   void SSYaccStackElementSetState( void* qpElement, SSUnsigned32 qulState)
      {
      SSYaccCapiStackElement* zpElement = ( SSYaccCapiStackElement*) qpElement;
      if ( !zpElement->verify( qpElement, SSYaccCapiCorrStack))
         return;
      zpElement->setState( qulState);
      }

   void SSYaccStackElementSetLexeme( void* qpElement, void* qpLexeme)
      {
      SSYaccCapiStackElement* zpElement = ( SSYaccCapiStackElement*) qpElement;
      if ( !zpElement->verify( qpElement, SSYaccCapiCorrStack))
         return;
      SSLexCapiLexeme* zpLexeme = ( SSLexCapiLexeme*) qpLexeme;
      if ( !zpLexeme->verify( qpLexeme, SSLexCorrLexeme))
         return;
      zpElement->setLexeme( *zpLexeme);
      }

   void* SSYaccCreate( void* qpLex, void* qpTable, SSYaccReduceCallback qpCall, 
      void* qpParm, SSUnsigned32 qulExtra, void** qpExcept)
      {
      SSTry
         {
         SSLexCapi* zpLex = ( SSLexCapi*) qpLex;
         if ( !zpLex->verify( qpLex, SSLexCorrLex))
            return 0;
         SSYaccCapiTable* zpTable = ( SSYaccCapiTable*) qpTable;
         if ( !zpTable->verify( qpTable, SSYaccCapiCorrTable))
            return 0;
         return new SSYaccCapi( zpLex, zpTable, qpCall, qulExtra, qpParm);
         }
      SSCatch ( SSException, zExcept)
         {
         if ( qpExcept)
            *qpExcept = new SSExceptionCapi( zExcept);
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   void SSYaccDestroy( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return;
      delete zpYacc;
      }

   void SSYaccSetNextLexemeCallback( void* qpYacc, 
      SSYaccNextLexemeCallback qpCall, void* qpParm)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return;
      zpYacc->setNextLexemeCallback( qpCall, qpParm);
      }

   void SSYaccSetShiftCallback( void* qpYacc,
      SSYaccShiftCallback qpCall, void* qpParm)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return;
      zpYacc->setShiftCallback( qpCall, qpParm);
      }

   void SSYaccSetErrorCallback( void* qpYacc,
      SSYaccErrorCallback qpCall, void* qpParm)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return;
      zpYacc->setErrorCallback( qpCall, qpParm);
      }

   void SSYaccSetAbort( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return;
      zpYacc->setAbort();
      }

   void SSYaccClearLastException( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return;
      zpYacc->setException( 0);
      }

   SSBooleanValue SSYaccGetAbort( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return SSTrue;
      return zpYacc->wasAborted();
      }

   SSBooleanValue SSYaccGetError( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return SSTrue;
      return zpYacc->wasError();
      }

   void* SSYaccGetLastException( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return 0;
      return zpYacc->getException();
      }

   void* SSYaccGetElementFromStack( void* qpYacc, SSUnsigned32 qulStack)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return 0;
      SSTry
         {
         SSYaccStackElement* zpElement = zpYacc->elementFromStack( qulStack);
         return ( SSYaccCapiStackElement*) zpElement;
         }
      SSCatch ( SSException, zExcept)
         {
         zpYacc->setException( new SSExceptionCapi( zExcept));
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   void* SSYaccGetElementFromProduction( void* qpYacc, SSSigned32 qulProd)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return 0;
      SSTry
         {
         SSYaccStackElement* zpElement = zpYacc->elementFromProduction( qulProd);
         return ( SSYaccCapiStackElement*) zpElement;
         }
      SSCatch ( SSException, zExcept)
         {
         zpYacc->setException( new SSExceptionCapi( zExcept));
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   SSUnsigned32* SSYaccGetValidLookaheads( void* qpYacc, SSUnsigned32 qulState,
      SSUnsigned32* qpNum)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return 0;
      SSTry
         {
         return zpYacc->validLookaheads( qulState, *qpNum);
         }
      SSCatch ( SSException, zExcept)
         {
         zpYacc->setException( new SSExceptionCapi( zExcept));
         return 0;
         }
      SSCatchEnd
      return 0;
      }

   void SSYaccFreeValidLookaheads( SSUnsigned32* qpLook)
      {
      delete [] qpLook;
      }

   SSBooleanValue SSYaccReset( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return SSTrue;
      SSTry
         {
         zpYacc->reset();
         return SSFalse;
         }
      SSCatch ( SSException, zExcept)
         {
         zpYacc->setException( new SSExceptionCapi( zExcept));
         return SSTrue;
         }
      SSCatchEnd
      return SSTrue;
      }

   SSBooleanValue SSYaccParse( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return SSTrue;
      SSTry
         {
         return zpYacc->parse();
         }
      SSCatch ( SSException, zExcept)
         {
         zpYacc->setException( new SSExceptionCapi( zExcept));
         return SSTrue;
         }
      SSCatchEnd
      return SSTrue;
      }

   SSBooleanValue SSYaccProcessError( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return SSTrue;
      SSTry
         {
         return zpYacc->errorToken();
         }
      SSCatch ( SSException, zExcept)
         {
         zpYacc->setException( new SSExceptionCapi( zExcept));
         return SSTrue;
         }
      SSCatchEnd
      return SSTrue;
      }

   SSUnsigned32 SSYaccGetShiftedSinceError( void* qpYacc)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return SSTrue;
      return zpYacc->shiftedSinceError();
      }

   SSBooleanValue SSYaccPushStackElement( void* qpYacc, void* qpElement)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return SSTrue;
      SSTry
         {
         SSYaccCapiStackElement* zpElement = 
            ( SSYaccCapiStackElement*) qpElement;
         return zpYacc->push( *zpElement);
         }
      SSCatch ( SSException, zExcept)
         {
         zpYacc->setException( new SSExceptionCapi( zExcept));
         return SSTrue;
         }
      SSCatchEnd    
      return SSTrue;
      }

   SSBooleanValue SSYaccPopStackElement( void* qpYacc, SSUnsigned32 qulPop)
      {
      SSYaccCapi* zpYacc = ( SSYaccCapi*) qpYacc;
      if ( !zpYacc->verify( qpYacc, SSYaccCapiCorrYacc))
         return SSTrue;
      SSTry
         {
         return zpYacc->pop( qulPop);
         }
      SSCatch ( SSException, zExcept)
         {
         zpYacc->setException( new SSExceptionCapi( zExcept));
         return SSTrue;
         }
      SSCatchEnd   
      return SSTrue;
      }
