/*---------------------------------------------------------------------------

					Copyright (c) 1994-1999 SandStone Technology Inc.
								  All rights reserved

		THIS PROGRAM CONSISTS OF TRADE SECRETS THAT ARE  THE PROPERTY
		OF SANDSTONE SOFTWARE INC..  THE CONTENTS  MAY NOT BE USED OR
		DISCLOSED WITHOUT THE EXPRESS WRITTEN PERMISSION OF THE OWNER.

----------------------------------------------------------------------------*/
#include "stdafx.h"
#include<ssyaccev.hpp>
#if defined( __BORLANDC__)
#endif

   SSYaccEvent::SSYaccEventType SSYaccEvent::parse( void)
      {
      if ( !opTable)
         throwException( SSExceptionYaccMissingTable, SSYaccMsgMissingTable);

		do
			{
			switch( oReturn)
				{
				case start:
					getLexeme();
					break;

				case lexOk:
					if ( oConflict)
						doLook();
					else
						{
						lookupAction( state(), lookahead().token());
						translateAction();
						}
					break;

				case lexMore:
					if ( oConflict)
						getLexLook();
					else
						getLexeme();
					break;

				case lexError:
					if ( oConflict)
						getLookLexeme();
					else
						getLexeme();
					break;

				case yaccShift:
					if ( !( oEvents & yaccShift))
						if ( !( oElement = shift( lookahead())))
							{
							oReturn = yaccPermError;
							break;
							}
					oElement->setLexeme( lookahead());
					oElement->setState( state());
					push();
					getLexeme();
					oulError++;
					break;

				case yaccReduce:
					if ( !( oEvents & yaccReduce))
						if ( !( oElement = reduce( production(), productionSize())))
							{
							oReturn = yaccPermError;
							break;
							}
					pop( productionSize());
					goTo( leftside());
					translateAction();
					break;

				case yaccConflict:
					{
					oulLar = 0;
					oulCache = 0;
					oConflict = SSTrue;
					SSLexIterator* zpIterator = ( SSLexIterator*) opIterator;
					zpIterator->lookupNext( oulLar, oLookahead->token());
					getLookLexeme();
					break;
					}

				case yaccLarLook:
					if ( !( oEvents & yaccLarLook))
						if ( larLookahead( *oLookahead))
							{
							oReturn = yaccPermError;
							break;
							}
					lookupAction( state(), lookahead().token());
					translateAction();
					break;

				case yaccLarError:
					oError = SSTrue;
					oConflict = SSFalse;
					if ( !( oEvents & yaccLarError))
						if ( larError( state(), lookahead(), *oLarLookahead))
							oReturn = yaccPermError;
					oulError = 0;
					break;

				case yaccError:
					oError = SSTrue;
					oConflict = SSFalse;
					if ( !( oEvents & yaccError))
					{
						SSLexLexemeRef z_lexeme = lookahead();
						if ( error( state(), *z_lexeme))
							oReturn = yaccPermError;
					}
					oulError = 0;
					break;

				case yaccAccept:
					throwException( SSExceptionYaccEventPastAccept, SSYaccEventMsgPastAccept);
					break;

				case yaccPermError:
					throwException( SSExceptionYaccEventPermError, SSYaccMsgPermError);
					break;

				default:
					throwException( SSExceptionYaccEventParse, SSYaccMsgParse);
				}
			}
		while ( !( oReturn & oEvents) && !oAbort);
		if ( oAbort) oReturn = yaccPermError;

		return oReturn;
		}

	SSYaccEvent::SSYaccEventType SSYaccEvent::getLexeme( void)
		{
		if ( oEndOfInput)
			throwException( SSExceptionYaccEof, SSYaccMsgEof);

		if ( oLookahead = lexemeCache().remove())
			{
			oReturn = yaccLarLook;
			return oReturn;
			}

		oLexReturn = lex()++;
		switch ( oLexReturn)
			{
			case lexOk:
				oLookahead = lex().lexeme();
				oReturn = lexOk;
				break;

			case lexMore:
				oReturn = lexMore;
				break;

			case lexDone:
				oEndOfInput = SSTrue;
				oLookahead = orEndLexeme;
				lookupAction( state(), lookahead().token());
				translateAction();
				break;

			case lexError:
				oReturn = lexError;
				break;

			default:
				throwException( SSExceptionYaccEventGetLexeme,
					SSYaccEventMsgGetLexeme, oLexReturn);
			}

		return oReturn;
		}

	SSYaccStackElement* SSYaccEvent::reduce( SSUnsigned32 qulProd,
		SSUnsigned32 qulSize)
		{
		qulSize;
		qulProd;
		throwException( SSExceptionYaccEventReduce, SSYaccEventMsgReduce);
		return 0;
		}

	SSBooleanValue SSYaccEvent::error( SSUnsigned32 qulState,
		SSLexLexeme& qLook)
		{
		qLook;//Unreferenced
		qulState;//Unreferenced
		if ( errorToken())
			{
			oReturn = yaccPermError;
			return SSFalse;
			}
		translateAction();
		return SSFalse;
		}

	SSBooleanValue SSYaccEvent::recover( void)
		{
		try 
			{
			if ( errorToken())
				{
				oReturn = yaccPermError;
				return SSFalse;
				}
			translateAction();
			return SSTrue;
			}
		catch ( ...)
			{
			oReturn = yaccPermError;
			return SSFalse;
			}
		}

	SSYaccEvent::SSYaccEventType SSYaccEvent::translateAction( void)
		{
		switch ( oAction)
			{
			case SSYaccAction::shift:
				oReturn = yaccShift;
				break;

			case SSYaccAction::error:
				oReturn = yaccError;
				break;

			case SSYaccAction::reduce:
				oReturn = yaccReduce;
				break;

			case SSYaccAction::accept:
				oReturn = yaccAccept;
				break;

			case SSYaccAction::conflict:
				oReturn = yaccConflict;
				break;
			}
		return oReturn;
		}

	void SSYaccEvent::getLookLexeme( void)
		{
		oLarLookahead = 0;
		if ( oulCache != SSYaccLexemeCacheMax)
			oLarLookahead = lexemeCache().get( oulCache++);
		if ( oLarLookahead)
			oReturn = lexOk;
		else
			{
			oulCache = SSYaccLexemeCacheMax;
			getLexLook();
			}
		}

	void SSYaccEvent::getLexLook( void)
		{
		oLexReturn = lex()++;
		switch ( oLexReturn)
			{
			case lexOk:
				oLarLookahead = lex().lexeme();
				lexemeCache().add( *oLarLookahead);
				oReturn = lexOk;
				break;

			case lexMore:
				oReturn = lexMore;
				break;

			case lexDone:
				oEndOfInput = SSTrue;
				oLarLookahead = orEndLexeme;
				lexemeCache().add( *oLarLookahead);
				doLook();
				break;

			case lexError:
				oReturn = lexError;
				break;

			default:
				throwException( SSExceptionYaccEventGetLexeme,
					SSYaccEventMsgGetLexeme, oLexReturn);
			}
		}

	void SSYaccEvent::doLook( void)
		{
		SSLexIterator* zpIterator = ( SSLexIterator*) opIterator;
		if ( zpIterator->lookupNext( oulLar, oLarLookahead->token()))
			{
			SSLexFinalState& zFinal = zpIterator->lookupFinal( oulLar);
			if ( zFinal.isFinal())
				{
				if ( zFinal.isReduce())
					{
					oulProduction = zFinal.token();
					SSYaccPairTable* zpTable = ( SSYaccPairTable*) opTab;
					SSYaccPairTableProd* zpProd = zpTable->lookupProd( oulProduction);
					oulLeftside = zpProd->leftside();
					oulProductionSize = zpProd->size();
					oConflict = SSFalse;
					oReturn = yaccReduce;
					}
				else
					{
					oulState = zFinal.token();
					oConflict = SSFalse;
					oReturn = yaccShift;
					}
				}
			else
				getLookLexeme();
			}
		else
			oReturn = yaccLarError;
		}

