#ifndef VPCPPCLASSES_H
#define VPCPPCLASSES_H
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1999, All Rights Reserved.
//***************************************************************************
//
// FILE:       VPCppClasses.h
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface and implementation of the CppLex and CppYacc classes
//
//***************************************************************************

// built by Visual Parse++, modified as needed
#pragma warning( disable : 4100 4239 )

#include "sslex.hpp"
#include "ssyacc.hpp"
#include "VPCppConstants.h"
#include "SMCpp.h"

class CppLexClass : public SSLex
{
public:
   SSInline SSConstr CppLexClass(SSLexTable & oLexTbl);
   const char*       tokenToConstChar( SSUnsigned32);
};

SSInline CppLexClass::CppLexClass(SSLexTable & oLexTbl)
   : SSLex(SSLexConsumer(SSLexConsumer::SSLexConsumerType::character), oLexTbl)
{
}

// modified to get the lex and yacc tables from EXE resources
class CppYaccClass : public SSYacc
{
   public:
      SSConstr CppYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMCpp * caller);
      SSYaccStackElement *
               reduce(SSUnsigned32, SSUnsigned32);

   protected:
      SMCpp *  m_poSMCpp;           // use to record counts
      bool     m_fInsideMethod;     // parsing state parameters
      bool     m_fInsideComment;
      int      m_iBlockDepth;
      int      m_iMethodStatements;
      int      m_iForSemicolons;
      int      m_iMaxBlockDepth;
      int      m_iMaxDepth;
      CString  m_sClassName;
      CString  m_sMethodName;

   private:
      CString  GetMethodName(int iLexemeIndex);
};

// inline constructor
SSInline CppYaccClass::CppYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMCpp * caller)
   : SSYacc(oLex, oYaccTable),
     m_poSMCpp(caller), m_fInsideComment(false), m_fInsideMethod(false),
     m_iBlockDepth(0), m_iForSemicolons(0), m_iMaxBlockDepth(0), m_iMaxDepth(SMCpp::BLOCK_DEPTH_COUNTS - 1)
{
}

#endif   // VPCPPCLASSES_H
