#include "stdafx.h"
#if !defined( VPCPPFUNCTIONSSSCPP)
#define VPCPPFUNCTIONSSSCPP
#include "VPCppClasses.h"

const char* CppLexClass::tokenToConstChar( SSUnsigned32 ulToken)
{
	const char* pchToken;
	switch ( ulToken)
	{
	case CppLexNewLine:
		pchToken = "\n";
		break;

	case CppLexIdName:
		pchToken = "Name";
		break;

	case CppLexClassDef:
		pchToken = "ClassDef";
		break;

	case CppLexClassName:
		pchToken = "ClassName";
		break;

	case CppLexFunctionName:
		pchToken = "FunctionName";
		break;

	case CppLexPreprocess:
		pchToken = "Preproc";
		break;

	case CppLexOCurly:
		pchToken = "{";
		break;

	case CppLexCCurly:
		pchToken = "}";
		break;

	case CppLexSemiColon:
		pchToken = ";";
		break;

	case CppLexBeginMLComment:
		pchToken = "BeginMLComment";
		break;

	case CppLexBeginSLComment:
		pchToken = "BeginSLComment";
		break;

	case CppLexControlStmt:
		pchToken = "ControlStmt";
		break;

	case CppLexFORStmt:
		pchToken = "FORStmt";
		break;

	case CppLexOperator:
		pchToken = "Operator";
		break;

	case CppLexPLUS:
		pchToken = "+";
		break;

	case CppLexMINUS:
		pchToken = "-";
		break;

	case CppLexMULT:
		pchToken = "*";
		break;

	case CppLexDIV:
		pchToken = "/";
		break;

	case CppLexMOD:
		pchToken = "%";
		break;

	case CppLexTilda:
		pchToken = "~";
		break;

	case CppLexHAT:
		pchToken = "^";
		break;

	case CppLexBIT_AND:
		pchToken = "&";
		break;

	case CppLexBIT_OR:
		pchToken = "|";
		break;

	case CppLexNOT:
		pchToken = "!";
		break;

	case CppLexLT:
		pchToken = "<";
		break;

	case CppLexGT:
		pchToken = ">";
		break;

	case CppLexSL:
		pchToken = "<<";
		break;

	case CppLexSR:
		pchToken = ">>";
		break;

	case CppLexAND:
		pchToken = "&&";
		break;

	case CppLexOR:
		pchToken = "||";
		break;

	case CppLexPTR:
		pchToken = "->";
		break;

	case CppLexINCR:
		pchToken = "++";
		break;

	case CppLexDECR:
		pchToken = "--";
		break;

	case CppLexLE:
		pchToken = "<=";
		break;

	case CppLexGE:
		pchToken = ">=";
		break;

	case CppLexEQ:
		pchToken = "==";
		break;

	case CppLexNE:
		pchToken = "!=";
		break;

	case CppLexAssignOpr:
		pchToken = "=";
		break;

	case CppLexNEW:
		pchToken = "new()";
		break;

	case CppLexDELETE:
		pchToken = "delete()";
		break;

	case CppLexCOMMA:
		pchToken = ",";
		break;

	case CppLexLeftRightParen:
		pchToken = "()(";
		break;

	case CppLexLeftRightBox:
		pchToken = "[](";
		break;

	case CppLexEndMLComment:
		pchToken = "EndMLComment";
		break;

	case SSYaccErrorToken:
		pchToken = "%error";
		break;

	case SSYaccEofToken:
		pchToken = "eof";
		break;

	default:
		pchToken = SSLexTokenNotFound;
	}
	return pchToken;
}

#endif
