#ifndef VPDelphiCLASSES_HPP
#define VPDelphiCLASSES_HPP
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1997, All Rights Reserved.
//***************************************************************************
//
// FILE:       VPDelphiClasses.hpp
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface and implementation of the DelphiLexClass and DelphiYaccClassImp classes
//
//***************************************************************************
// SourceSafe Status:
// $Header: /source metrics/VisualParse/VPDelphiClasses.hpp 1     12/09/97 3:50p Jfw $
//
// $History: VPDelphiClasses.hpp $
//
//*****************  Version 1  *****************
//User: Jfw          Date: 12/09/97   Time: 3:50p
//Created in $/source metrics/VisualParse
//***************************************************************************
//

// built by Visual Parse++, modified as needed

#pragma warning( disable : 4100 4239 )

#include "sslex.hpp"
#include "ssyacc.hpp"
#include "VPDelphiConstants.h"
#include "SMDelphi.h"

class DelphiLexClass : public SSLex
{
public:
   SSInline SSConstr DelphiLexClass(SSLexTable & oLexTbl);
   const char*       tokenToConstChar( SSUnsigned32);
};

SSInline DelphiLexClass::DelphiLexClass(SSLexTable & oLexTbl)
   : SSLex(SSLexConsumer(SSLexConsumer::SSLexConsumerType::character), oLexTbl)
{
}

// modified to get the lex and yacc tables from EXE resources
class DelphiYaccClass : public SSYacc
{
   public:
      SSConstr DelphiYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMDelphi * caller);
      SSYaccStackElement *
               reduce(SSUnsigned32, SSUnsigned32);

   protected:
      SMDelphi *  m_poSMDelphi;           // use to record counts
      bool        m_fInsideClass;         // parsing state parameters        // parsing state parameters
      bool        m_fInsideMethod;
      bool        m_fInsideSubroutine;
      bool        m_fInsideVarClause;
      bool        m_fInsideComment;
      bool        m_fInsideCase;
      bool        m_fInsideProperty;
      bool        m_fInsideClassOrRecord;
      bool        m_fInsideInterface;
      int         m_iMethodBlock;         // block level of current method
      int         m_iBlockDepth;
      int         m_iMethodStatements;
      int         m_iSubroutineStatements;
      int         m_iCaseBlockLevel;
      int         m_iMaxBlockDepth;
      int         m_iMaxDepth;
      CString     m_sClassMethodNames;    // this is procedure|function <class>.<method> and must be parsed
      CString     m_sSubroutineName;      // this is procedure|function <subroutine> and must be parsed
};

// inline constructor
SSInline DelphiYaccClass::DelphiYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMDelphi * caller)
   : SSYacc(oLex, oYaccTable),
     m_poSMDelphi(caller), m_fInsideComment(false), m_fInsideMethod(false), m_fInsideCase(false),
     m_fInsideProperty(false), m_fInsideClassOrRecord(false), m_fInsideInterface(false),
     m_fInsideSubroutine(false), m_fInsideVarClause(false), m_fInsideClass(false), m_iCaseBlockLevel(0),
     m_iBlockDepth(0), m_iMaxBlockDepth(0), m_iMaxDepth(SMDelphi::BLOCK_DEPTH_COUNTS - 1)
{
}

#endif   // VPDelphiCLASSES_HPP
