#ifndef VPHTMLCLASSES_HPP
#define VPHTMLCLASSES_HPP
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1997, All Rights Reserved.
//***************************************************************************
//
// FILE:       VPHTMLClasses.hpp
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface and implementation of the HTMLLexClass and HTMLYaccClass classes
//
//***************************************************************************
// SourceSafe Status:
// $Header: /source metrics/VisualParse/VPHTMLClasses.hpp 2     12/01/97 1:03p Jfw $
//
// $History: VPHTMLClasses.hpp $
//
//*****************  Version 2  *****************
//User: Jfw          Date: 12/01/97   Time: 1:03p
//Updated in $/source metrics/VisualParse
//Fixed all known bugs, removed ActiveX feature, implemented print
//options, Undo.
//
//*****************  Version 1  *****************
//User: Jfw          Date: 11/03/97   Time: 7:09p
//Created in $/source metrics/VisualParse
//***************************************************************************
//

// built by Visual Parse++, modified as needed

#pragma warning( disable : 4100 4239 )

#include "sslex.hpp"
#include "ssyacc.hpp"
#include "VPHTMLConstants.h"

class HTMLLexClass : public SSLex
{
public:
   SSInline SSConstr HTMLLexClass(SSLexTable & oLexTbl);
   const char*       tokenToConstChar( SSUnsigned32);
};

SSInline HTMLLexClass::HTMLLexClass(SSLexTable & oLexTbl)
   : SSLex(SSLexConsumer(SSLexConsumer::SSLexConsumerType::character), oLexTbl)
{
}

// modified to accept a text buffer as the parser fodder, get the lex and yacc
// tables from EXE resources
// forward reference for language object
class SMHTML;

class HTMLYaccClass : public SSYacc
{
   public:
      SSConstr HTMLYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMHTML * caller);
      SSYaccStackElement *
               reduce(SSUnsigned32, SSUnsigned32);

   protected:
      SMHTML * m_poSMHTML;             // use to record counts
      bool     m_fInsideComment;
};

// inline constructor
// TODO: put the lex and yacc tables into the EXE as resources
SSInline HTMLYaccClass::HTMLYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMHTML * caller)
   : SSYacc(oLex, oYaccTable),
     m_poSMHTML(caller), m_fInsideComment(false)
{
}

#endif   // VPHTMLCLASSES_HPP
