#include "stdafx.h"

#include "VPHTMLClasses.hpp"
#include "SMHTML.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

SSYaccStackElement *
HTMLYaccClass::reduce( SSUnsigned32 ulProd, SSUnsigned32 /* ulSize */)
{
   switch ( ulProd)
   {
   // NOTE: many productions are ignored because they help parse but aren't relevant to any metrics
   case HTMLYaccError:           // metricCount -> %error \n
      m_poSMHTML->ParseError();  // report error to user, then count current line anyway
   case HTMLYaccSourceLine:      // metricCount -> \n 
      if( m_fInsideComment )
      {
         m_poSMHTML->BumpCount(SMHTML::COMMENT_COUNT);
      }
      m_poSMHTML->BumpCount(SMHTML::LINE_COUNT);
      break;

   case HTMLYaccAppletTag:       // metricCount -> APPLET
      m_poSMHTML->BumpCount(SMHTML::APPLET_COUNT);
      m_poSMHTML->BumpCount(SMHTML::SIMPLE_TAG_COUNT);
      break;

   case HTMLYaccScriptTag:       // metricCount -> SCRIPT 
      m_poSMHTML->BumpCount(SMHTML::SCRIPT_COUNT);
      m_poSMHTML->BumpCount(SMHTML::SIMPLE_TAG_COUNT);
      break;

   case HTMLYaccComplexTag:      // metricCount -> ComplexTag 
      m_poSMHTML->BumpCount(SMHTML::COMPLEX_TAG_COUNT);
      break;

   case HTMLYaccOtherTag:        // metricCount -> OtherTag 
      m_poSMHTML->BumpCount(SMHTML::SIMPLE_TAG_COUNT);
      break;

   case HTMLYaccImageDownload:   // metricCount -> SRC 
      m_poSMHTML->BumpCount(SMHTML::DOWNLOAD_COUNT);
      break;

   case HTMLYaccHyperlink:       // metricCount -> HREF 
      m_poSMHTML->BumpCount(SMHTML::HYPERLINK_COUNT);
      break;

   case HTMLYaccBeginComment:    // metricCount -> BeginComment 
      m_fInsideComment = true;
      break;

   case HTMLYaccEndComment:      // metricCount -> EndComment 
      m_poSMHTML->BumpCount(SMHTML::COMMENT_COUNT);
      m_fInsideComment = false;
      break;

   default:
      break;
   }

   return stackElement();
}
