#ifndef VPJavaCLASSES_HPP
#define VPJavaCLASSES_HPP
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1997, All Rights Reserved.
//***************************************************************************
//
// FILE:       VPJavaClasses.hpp
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface and implementation of the JavaLexClass and JavaYaccClassImp classes
//
//***************************************************************************
// SourceSafe Status:
// $Header: /source metrics/VisualParse/VPJavaClasses.hpp 2     12/01/97 1:03p Jfw $
//
// $History: VPJavaClasses.hpp $
//
//*****************  Version 2  *****************
//User: Jfw          Date: 12/01/97   Time: 1:03p
//Updated in $/source metrics/VisualParse
//Fixed all known bugs, removed ActiveX feature, implemented print
//options, Undo.
//
//*****************  Version 1  *****************
//User: Jfw          Date: 11/03/97   Time: 7:09p
//Created in $/source metrics/VisualParse
//***************************************************************************
//

// built by Visual Parse++, modified as needed

#pragma warning( disable : 4100 4239 )

#include "sslex.hpp"
#include "ssyacc.hpp"
#include "VPJavaConstants.h"
#include "SMJava.h"

class JavaLexClass : public SSLex
{
public:
   SSInline SSConstr JavaLexClass(SSLexTable & oLexTbl);
   const char*       tokenToConstChar( SSUnsigned32);
};

SSInline JavaLexClass::JavaLexClass(SSLexTable & oLexTbl)
   : SSLex(SSLexConsumer(SSLexConsumer::SSLexConsumerType::character), oLexTbl)
{
}

// modified to get the lex and yacc tables from EXE resources

class JavaYaccClass : public SSYacc
{
   public:
      SSConstr JavaYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMJava * caller);
      SSYaccStackElement *
               reduce(SSUnsigned32, SSUnsigned32);

   protected:
      SMJava *       m_poSMJava;             // use to record counts
      bool           m_fInsideMethod;        // parsing state parameters
      bool           m_fInsideComment;
      bool           m_fInsideInterface;
      int            m_iBlockDepth;
      int            m_iMethodStatements;
      int            m_iMaxBlockDepth;
      int            m_iMaxDepth;
      CStringArray   m_sClassMethodNames;
      CString        m_sCallOrMethodName;
};

// inline constructor
SSInline JavaYaccClass::JavaYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMJava * caller)
   : SSYacc(oLex, oYaccTable), m_poSMJava(caller),
      m_fInsideComment(false), m_fInsideMethod(false), m_fInsideInterface(false),
      m_iBlockDepth(0), m_iMaxBlockDepth(0), m_iMaxDepth(SMJava::BLOCK_DEPTH_COUNTS - 1)
{
}

#endif   // VPJavaCLASSES_HPP
