#ifndef VPVBCLASSES_HPP
#define VPVBCLASSES_HPP
//** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL ***** CONFIDENTIAL **
//   Campwood Software, Charlotte, Vermont 05445 USA
//   Copyright  1997, All Rights Reserved.
//***************************************************************************
//
// FILE:       VPVBClasses.hpp
//
// SUBSYSTEM:  Source Monitor Applicaton
//
// AUTHOR:     JF Wanner
//
// OVERVIEW:   Interface and implementation of the VBLexClass and VBYaccClass classes
//
//***************************************************************************
// SourceSafe Status:
// $Header: /source metrics/VisualParse/VPVBClasses.hpp 2     12/01/97 1:03p Jfw $
//
// $History: VPVBClasses.hpp $
//
//*****************  Version 2  *****************
//User: Jfw          Date: 12/01/97   Time: 1:03p
//Updated in $/source metrics/VisualParse
//Fixed all known bugs, removed ActiveX feature, implemented print
//options, Undo.
//
//*****************  Version 1  *****************
//User: Jfw          Date: 11/03/97   Time: 7:09p
//Created in $/source metrics/VisualParse
//***************************************************************************
//

// built by Visual Parse++, modified as needed

#pragma warning( disable : 4100 4239 )

#include "sslex.hpp"
#include "ssyacc.hpp"
#include "VPVBConstants.h"
#include "SMVisualBasic.h"

class VBLexClass : public SSLex
{
public:
   SSInline SSConstr VBLexClass(SSLexTable & oLexTbl);
   const char*       tokenToConstChar( SSUnsigned32);
};

SSInline VBLexClass::VBLexClass(SSLexTable & oLexTbl)
   : SSLex(SSLexConsumer(SSLexConsumer::SSLexConsumerType::character), oLexTbl)
{
}

// modified to get the lex and yacc tables from EXE resources
// forward reference for language object
class SMVisualBasic;

class VBYaccClass : public SSYacc
{
   public:
      SSConstr VBYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMVisualBasic * caller);
      SSYaccStackElement *
               reduce(SSUnsigned32, SSUnsigned32);

   protected:
      SMVisualBasic *
               m_poSMVisualBasic;         // use to record counts
      bool     m_fInsideSubroutine;
      bool     m_fInsideStatement;
      bool     m_fBeginSubroutine;        // set so next name after keyword -> sub name
      bool     m_fStartingSubroutine;     // pend start of SR statement counts 'till after SR statement
      bool     m_fStartingBranchBlock;    // set on start block statements to pend level increment
      bool     m_fStartingCase;           // true only for fist Case (don't unindent level)
      bool     m_fStartingIf;             // true when checking for single line "If" statements
      int      m_iBlockDepth;
      int      m_iSubroutineStatements;
      int      m_iMaxBlockDepth;
      int      m_iMaxDepth;
      CString  m_sSubroutineName;
};

// inline constructor
SSInline VBYaccClass::VBYaccClass(SSLex & oLex, SSYaccTable & oYaccTable, SMVisualBasic * caller)
   : SSYacc(oLex, oYaccTable),
     m_poSMVisualBasic(caller), m_fInsideStatement(false), m_fInsideSubroutine(false),
     m_fBeginSubroutine(false), m_fStartingBranchBlock(false), m_fStartingCase(0),
     m_fStartingSubroutine(false), m_fStartingIf(false), m_iBlockDepth(0), m_iMaxBlockDepth(0),
     m_iMaxDepth(SMVisualBasic::BLOCK_DEPTH_COUNTS - 1)
{
}

#endif   // VPVBCLASSES_HPP
