#include "stdafx.h"
#if !defined( VPVBFUNCTIONSSSCPP)
#define VPVBFUNCTIONSSSCPP
#include "VPVBClasses.hpp"

const char* VBLexClass::tokenToConstChar( SSUnsigned32 ulToken)
{
	const char* pchToken;
	switch ( ulToken)
	{
	case VBLexName:
		pchToken = "Name";
		break;

	case VBLexNewLine:
		pchToken = "\n";
		break;

	case VBLexComment:
		pchToken = "Comment";
		break;

	case VBLexStatementSeparator:
		pchToken = ":";
		break;

	case VBLexBlockBegin:
		pchToken = "BlockBegin";
		break;

	case VBLexBlockEnd:
		pchToken = "BlockEnd";
		break;

	case VBLexType:
		pchToken = "Type";
		break;

	case VBLexEndType:
		pchToken = "End Type";
		break;

	case VBLexSub:
		pchToken = "Sub";
		break;

	case VBLexDeclare:
		pchToken = "Declare";
		break;

	case VBLexEndSub:
		pchToken = "End Sub";
		break;

	case VBLexFunction:
		pchToken = "Function";
		break;

	case VBLexEndFunction:
		pchToken = "End Function";
		break;

	case VBLexProperty:
		pchToken = "Property";
		break;

	case VBLexEndProperty:
		pchToken = "End Property";
		break;

	case VBLexBeginIf:
		pchToken = "If";
		break;

	case VBLexThen:
		pchToken = "Then";
		break;

	case VBLexElse:
		pchToken = "Else";
		break;

	case VBLexElseIf:
		pchToken = "ElseIf";
		break;

	case VBLexEndIf:
		pchToken = "End If";
		break;

	case VBLexCase:
		pchToken = "Case";
		break;

	case VBLexSelectCase:
		pchToken = "Select Case";
		break;

	case VBLexCaseElse:
		pchToken = "Case Else";
		break;

	case VBLexEndSelect:
		pchToken = "End Select";
		break;

	case VBLexDo:
		pchToken = "Do";
		break;

	case VBLexDoWhile:
		pchToken = "Do While";
		break;

	case VBLexDoUntil:
		pchToken = "Do Until";
		break;

	case VBLexLoop:
		pchToken = "Loop";
		break;

	case VBLexLoopWhile:
		pchToken = "Loop While";
		break;

	case VBLexFor:
		pchToken = "For";
		break;

	case VBLexNext:
		pchToken = "Next";
		break;

	case VBLexExitStatement:
		pchToken = "ExitStatement";
		break;

	case VBLexBranchStatement:
		pchToken = "BranchStatement";
		break;

	case SSYaccErrorToken:
		pchToken = "%error";
		break;

	case SSYaccEofToken:
		pchToken = "eof";
		break;

	default:
		pchToken = SSLexTokenNotFound;
	}
	return pchToken;
}

#endif
