/*
 * consumer.c -- consumer of data produced by producer
 *
 * Written by Jerry Epplin
 */

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <rtl_fifo.h>
#include <rtl_time.h>

#define BUFSIZE 70

char buf[BUFSIZE];

int main()
{
  fd_set rfds;
  int i, n, ret;
  int fd0;
  
  /* open the RT-FIFO device */
  if ((fd0 = open("/dev/rtf1", O_RDONLY)) < 0) {
    fprintf(stderr, "Error opening /dev/rtf1\n");
    exit(1);
  }

  /* show the data for a while */
  for (i=0; i<21 ; ++i)
  {
    FD_ZERO(&rfds);
    FD_SET(fd0, &rfds);

    /* wait until data is present */
    ret = select(FD_SETSIZE, &rfds, NULL, NULL, NULL);
    if (ret > 0)
    {
      if (FD_ISSET(fd0, &rfds))
      {
        /* read the data out and display it */
        n = read(fd0, buf, BUFSIZE - 1);
        buf[n] = '\0';
        printf("%s", buf);
      }
    }
    else
      printf("select() failed with %d.\n", ret);
  }
  return 0;
}
